
//
///////////////////////////////////////////////////////////////////////////////
//////   This file is created by a script. Modifications will be lost!   //////
///////////////////////////////////////////////////////////////////////////////

#include "file-type.h"


//
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////   FileTypeTab[]   //////////////////////////////
///////////////////////////////////////////////////////////////////////////////

const char filetype_info_unknown[] = "?";
const char filetype_info_not_supported[] = "not supported";

const file_type_t FileTypeTab[FF_N+1] =
{

 // FF_UNKNOWN = 0
    {	"?",
	".bin", ".szs", ".bin",
	FFT_VALID,
	filetype_info_not_supported,
	filetype_info_not_supported,
	"Unknown file"
    },

 // FF_YAZ0 = 1
    {	"YAZ0",
	".szs", ".szs", ".szs",
	FFT_VALID | FFT_COMPRESS,
	"0",
	"0,1",
	"YAZ compression"
    },

 // FF_YAZ1 = 2
    {	"YAZ1",
	".szs", ".szs", ".szs",
	FFT_VALID | FFT_COMPRESS,
	"1",
	"0,1",
	"YAZ compression"
    },

 // FF_XYZ = 3
    {	"XYZ",
	".xyz", ".szs", ".xyz",
	FFT_VALID | FFT_COMPRESS,
	MinusString,
	MinusString,
	"disguise YAZ compression"
    },

 // FF_BZ = 4
    {	"BZ",
	".bz", ".szs", ".bz",
	FFT_VALID | FFT_COMPRESS,
	MinusString,
	MinusString,
	"bzip2 compression used"
    },

 // FF_BZ2 = 5
    {	"BZ2",
	".bz2", ".szs", ".bz2",
	FFT_VALID | FFT_COMPRESS,
	MinusString,
	MinusString,
	"bzip2 compressed file"
    },

 // FF_U8 = 6
    {	"U8",
	".u8", ".szs", ".u8",
	FFT_VALID | FFT_ARCHIVE | FFT_CREATE | FFT_EXTRACT | FFT_CUT,
	MinusString,
	MinusString,
	"Nintendos archive format"
    },

 // FF_WU8 = 7
    {	"WU8",
	".wu8", ".wu8", ".wu8",
	FFT_VALID | FFT_ARCHIVE | FFT_CREATE | FFT_EXTRACT | FFT_CUT,
	MinusString,
	MinusString,
	"Wiimms differential U8"
    },

 // FF_RARC = 8
    {	"RARC",
	".rarc", ".arc", ".rarc",
	FFT_VALID | FFT_ARCHIVE | FFT_EXTRACT | FFT_CUT,
	MinusString,
	filetype_info_not_supported,
	"Archive format for objects"
    },

 // FF_BRRES = 9
    {	"BRRES",
	".brres", ".szs", ".bres",
	FFT_VALID | FFT_ARCHIVE | FFT_CREATE | FFT_EXTRACT | FFT_CUT,
	MinusString,
	MinusString,
	"Archive format for objects"
    },

 // FF_BREFF = 10
    {	"BREFF",
	".breff", ".szs", ".reff",
	FFT_VALID | FFT_ARCHIVE | FFT_CREATE | FFT_EXTRACT,
	"9,11",
	"9,11",
	"Main file of an effect pair"
    },

 // FF_BREFT = 11
    {	"BREFT",
	".breft", ".szs", ".reft",
	FFT_VALID | FFT_ARCHIVE | FFT_CREATE | FFT_EXTRACT | FFT_CUT,
	"9,11",
	"9,11",
	"Image file of an effect pair"
    },

 // FF_PACK = 12
    {	"PACK",
	".pack", ".szs", ".pack",
	FFT_VALID | FFT_ARCHIVE | FFT_CREATE | FFT_EXTRACT | FFT_CUT,
	MinusString,
	MinusString,
	"Simple archive format"
    },

 // FF_CHR = 13
    {	"CHR",
	".chr", ".szs", ".chr0",
	FFT_VALID | FFT_BRSUB | FFT_BRSUB2 | FFT_CUT,
	"5,(*)",
	filetype_info_not_supported,
	"Model movement animations"
    },

 // FF_CLR = 14
    {	"CLR",
	".clr", ".szs", ".clr0",
	FFT_VALID | FFT_BRSUB | FFT_BRSUB2 | FFT_CUT,
	"4,(*)",
	filetype_info_not_supported,
	"Colour changing animations"
    },

 // FF_MDL = 15
    {	"MDL",
	".mdl", ".szs", ".mdl0",
	FFT_VALID | FFT_BRSUB | FFT_BRSUB2 | FFT_CUT | FFT_DECODE | FFT_PATCH,
	"11,(*)",
	filetype_info_not_supported,
	"Model files"
    },

 // FF_PAT = 16
    {	"PAT",
	".pat", ".szs", ".pat0",
	FFT_VALID | FFT_BRSUB | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	"4,(*)",
	"4",
	"Texture swapping animations"
    },

 // FF_SCN = 17
    {	"SCN",
	".scn", ".szs", ".scn0",
	FFT_VALID | FFT_BRSUB | FFT_BRSUB2 | FFT_CUT,
	"5,(*)",
	filetype_info_not_supported,
	"Polygon morphing animations"
    },

 // FF_SHP = 18
    {	"SHP",
	".shp", ".szs", ".shp0",
	FFT_VALID | FFT_BRSUB | FFT_BRSUB2 | FFT_CUT,
	"4,(*)",
	filetype_info_not_supported,
	filetype_info_unknown
    },

 // FF_SRT = 19
    {	"SRT",
	".srt", ".szs", ".srt0",
	FFT_VALID | FFT_BRSUB | FFT_BRSUB2 | FFT_CUT,
	"5,(*)",
	filetype_info_not_supported,
	"Texture movement animations"
    },

 // FF_TEX = 20
    {	"TEX",
	".tex", ".szs", ".tex0",
	FFT_VALID | FFT_GRAPHIC | FFT_BRSUB | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	"3,(*)",
	"3",
	"Texture file"
    },

 // FF_TEX_CT = 21
    {	"TEX+CT",
	".tex", ".szs", ".tex0",
	FFT_VALID | FFT_GRAPHIC | FFT_BRSUB | FFT_CUT | FFT_DECODE | FFT_ENCODE | FFT_PATCH,
	"3,(*)",
	"3",
	"Texture file with CTGP-CODE"
    },

 // FF_CT_TEXT = 22
    {	"CTTEXT",
	".txt", ".szs", ".txt",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE | FFT_PARSER,
	MinusString,
	MinusString,
	"CTGP-CODE text file"
    },

 // FF_CT0_CODE = 23
    {	"C0CODE",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-CODE for main.dol section T2"
    },

 // FF_CT0_DATA = 24
    {	"C0DATA",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-DATA for main.dol section D8"
    },

 // FF_CT1_CODE = 25
    {	"C1CODE",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-CODE for strap TEX0 file"
    },

 // FF_CT1_DATA = 26
    {	"C1DATA",
	".ctcode", ".szs", ".ctcode",
	FFT_VALID | FFT_CUT | FFT_DECODE | FFT_PATCH,
	MinusString,
	MinusString,
	"CT-DATA for strap TEX0 file"
    },

 // FF_CUP1 = 27
    {	"CUP1",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-DATA section: Cups"
    },

 // FF_CRS1 = 28
    {	"CRS1",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-DATA section: Tracks"
    },

 // FF_MOD1 = 29
    {	"MOD1",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-DATA section: main.dol patches"
    },

 // FF_MOD2 = 30
    {	"MOD2",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-DATA section: StaticR.rel patches"
    },

 // FF_OVR1 = 31
    {	"OVR1",
	".bin", ".szs", ".bin",
	FFT_VALID,
	MinusString,
	MinusString,
	"CT-DATA section: Speedometer"
    },

 // FF_MDL_TXT = 32
    {	"MDLTXT",
	".txt", ".szs", ".txt",
	FFT_VALID | FFT_TEXT,
	filetype_info_not_supported,
	MinusString,
	"Text version of MDL"
    },

 // FF_PAT_TXT = 33
    {	"PATTXT",
	".txt", ".szs", ".txt",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE | FFT_PARSER,
	MinusString,
	MinusString,
	"Text version of PAT"
    },

 // FF_TPL = 34
    {	"TPL",
	".tpl", ".szs", ".tpl",
	FFT_VALID | FFT_GRAPHIC | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"Image old_container"
    },

 // FF_BTI = 35
    {	"BTI",
	".bti", ".szs", ".bti",
	FFT_VALID | FFT_GRAPHIC | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"Image old_container"
    },

 // FF_BREFT_IMG = 36
    {	"BT-IMG",
	".bt-img", ".szs", ".bt-img",
	FFT_VALID | FFT_GRAPHIC | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"Raw image of BREFT file"
    },

 // FF_BMG = 37
    {	"BMG",
	".bmg", ".szs", ".bmg",
	FFT_VALID | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"Message file"
    },

 // FF_BMG_TXT = 38
    {	"BMGTXT",
	".txt", ".szs", ".txt",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"Text version of BMG"
    },

 // FF_KCL = 39
    {	"KCL",
	".kcl", ".szs", ".kcl",
	FFT_VALID | FFT_CUT | FFT_DECODE | FFT_ENCODE | FFT_PATCH,
	MinusString,
	MinusString,
	"Collision file"
    },

 // FF_KCL_TXT = 40
    {	"KCLTXT",
	".obj", ".szs", ".obj",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE | FFT_PARSER,
	MinusString,
	MinusString,
	"Wavefront OBJ by WSZST"
    },

 // FF_WAV_OBJ = 41
    {	"WAVOBJ",
	".obj", ".szs", ".obj",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE | FFT_PARSER,
	MinusString,
	MinusString,
	"Wavefront OBJ"
    },

 // FF_SKP_OBJ = 42
    {	"SKPOBJ",
	".obj", ".szs", ".obj",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE | FFT_PARSER,
	MinusString,
	MinusString,
	"Wavefront OBJ by Sketchup"
    },

 // FF_KMP = 43
    {	"KMP",
	".kmp", ".szs", ".kmp",
	FFT_VALID | FFT_CUT | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"Track information file"
    },

 // FF_KMP_TXT = 44
    {	"KMPTXT",
	".txt", ".szs", ".txt",
	FFT_VALID | FFT_TEXT | FFT_DECODE | FFT_ENCODE | FFT_PARSER,
	MinusString,
	MinusString,
	"Text version of KMP"
    },

 // FF_BRASD = 45
    {	"BRASD",
	".brasd", ".szs", ".brasd",
	FFT_VALID,
	MinusString,
	MinusString,
	filetype_info_unknown
    },

 // FF_STATICR = 46
    {	"STATR",
	".rel", ".szs", ".rel",
	FFT_VALID | FFT_PATCH,
	MinusString,
	MinusString,
	"A 'StaticR.rel' file"
    },

 // FF_DOL = 47
    {	"DOL",
	".dol", ".szs", ".dol",
	FFT_VALID | FFT_EXTRACT | FFT_PATCH,
	MinusString,
	MinusString,
	"An executable DOL file"
    },

 // FF_GCT = 48
    {	"GCT",
	".gct", ".szs", ".gct",
	FFT_VALID,
	MinusString,
	MinusString,
	"Gecko Cheat Code"
    },

 // FF_GCH = 49
    {	"GCH",
	".gch", ".szs", ".gch",
	FFT_VALID,
	MinusString,
	MinusString,
	"Gecko Cheat Handler + coded"
    },

 // FF_WCH = 50
    {	"WCH",
	".wch", ".szs", ".wch",
	FFT_VALID,
	MinusString,
	MinusString,
	"Wiimms Cheat Handler + codes"
    },

 // FF_WPF = 51
    {	"WPF",
	".wpf", ".szs", ".wpf",
	FFT_VALID,
	MinusString,
	MinusString,
	"Wiimms Patch File"
    },

 // FF_XPF = 52
    {	"XPF",
	".xpf", ".szs", ".xpf",
	FFT_VALID,
	MinusString,
	MinusString,
	"Extended Patch File"
    },

 // FF_PNG = 53
    {	"PNG",
	".png", ".png", ".png",
	FFT_VALID | FFT_GRAPHIC | FFT_EXTERNAL | FFT_DECODE | FFT_ENCODE,
	MinusString,
	MinusString,
	"A public image format"
    },

 // FF_DIRECTORY = 54
    {	"DIR",
	".d", ".d", ".d",
	FFT_EXTERNAL,
	"transparent",
	"transparent",
	"Directory of filesystem"
    },

  // FF_N
	{0}
};


//
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////   FileTypeTab[]   //////////////////////////////
///////////////////////////////////////////////////////////////////////////////

const KeywordTab_t cmdtab_FileType[] =
{
    // INFO: cmd->opt := ff_attrib_t

    { FF_YAZ0,		"YAZ",		"YAZ0",		    0x3 },
    { FF_YAZ1,		"YAZ1",		0,		    0x3 },
    { FF_XYZ,		"XYZ",		0,		    0x3 },
    { FF_BZ,		"BZ",		0,		    0x3 },
    { FF_BZ2,		"BZ2",		0,		    0x3 },
    { FF_U8,		"U8",		0,		  0x705 },
    { FF_WU8,		"WU8",		0,		  0x705 },
    { FF_RARC,		"ARC",		"RARC",		  0x605 },
    { FF_BRRES,		"BRES",		"BRRES",	  0x705 },
    { FF_BREFF,		"BREFF",	"REFF",		  0x305 },
    { FF_BREFT,		"BREFT",	"REFT",		  0x705 },
    { FF_PACK,		"PACK",		0,		  0x705 },
    { FF_CHR,		"CHR",		"CHR0",		  0x461 },
    { FF_CLR,		"CLR",		"CLR0",		  0x461 },
    { FF_MDL,		"MDL",		"MDL0",		 0x4c61 },
    { FF_PAT,		"PAT",		"PAT0",		 0x1c21 },
    { FF_SCN,		"SCN",		"SCN0",		  0x461 },
    { FF_SHP,		"SHP",		"SHP0",		  0x461 },
    { FF_SRT,		"SRT",		"SRT0",		  0x461 },
    { FF_TEX,		"TEX",		"TEX0",		 0x1c29 },
    { FF_TEX_CT,	"TEX",		"TEX+CT",	 0x5c29 },
    { FF_TEX_CT,	"TEX-CT",	"TEX0",		 0x5c29 },
    { FF_TEX_CT,	"TEXCT",	0,		 0x5c29 },
    { FF_CT_TEXT,	"CT-TEXT",	"CTTEXT",	 0x3811 },
    { FF_CT0_CODE,	"C0CODE",	"CT0-CODE",	    0x1 },
    { FF_CT0_CODE,	"CT0CODE",	0,		    0x1 },
    { FF_CT0_DATA,	"C0DATA",	"CT0-DATA",	    0x1 },
    { FF_CT0_DATA,	"CT0DATA",	0,		    0x1 },
    { FF_CT1_CODE,	"C1CODE",	"CT1-CODE",	    0x1 },
    { FF_CT1_CODE,	"CT1CODE",	0,		    0x1 },
    { FF_CT1_DATA,	"C1DATA",	"CT1-DATA",	 0x4c01 },
    { FF_CT1_DATA,	"CT1DATA",	"CTCODE",	 0x4c01 },
    { FF_CUP1,		"CUP1",		0,		    0x1 },
    { FF_CRS1,		"CRS1",		0,		    0x1 },
    { FF_MOD1,		"MOD1",		0,		    0x1 },
    { FF_MOD2,		"MOD2",		0,		    0x1 },
    { FF_OVR1,		"OVR1",		0,		    0x1 },
    { FF_MDL_TXT,	"MDL-TXT",	"MDLTXT",	   0x11 },
    { FF_PAT_TXT,	"PAT-TXT",	"PATTXT",	 0x3811 },
    { FF_TPL,		"TPL",		0,		 0x1c09 },
    { FF_BTI,		"BTI",		"BTIENV",	 0x1c09 },
    { FF_BTI,		"BTIMAT",	0,		 0x1c09 },
    { FF_BREFT_IMG,	"BREFT-IMG",	"BREFTIMG",	 0x1c09 },
    { FF_BREFT_IMG,	"BT-IMG",	"BTIMG",	 0x1c09 },
    { FF_BMG,		"BMG",		"MESGBMG1",	 0x1c01 },
    { FF_BMG_TXT,	"BMG-TXT",	"BMGTXT",	 0x1811 },
    { FF_KCL,		"KCL",		0,		 0x5c01 },
    { FF_KCL_TXT,	"KCL-TXT",	"KCLTXT",	 0x3811 },
    { FF_WAV_OBJ,	"WAV-OBJ",	"WAVOBJ",	 0x3811 },
    { FF_SKP_OBJ,	"SKP-OBJ",	"SKPOBJ",	 0x3811 },
    { FF_KMP,		"KMP",		0,		 0x1c01 },
    { FF_KMP_TXT,	"KMP-TXT",	"KMPTXT",	 0x3811 },
    { FF_BRASD,		"BRASD",	0,		    0x1 },
    { FF_STATICR,	"REL",		"STATICR",	 0x4001 },
    { FF_DOL,		"DOL",		0,		 0x4201 },
    { FF_GCT,		"GCT",		0,		    0x1 },
    { FF_GCH,		"GCH",		0,		    0x1 },
    { FF_WCH,		"WCH",		0,		    0x1 },
    { FF_WPF,		"WPF",		0,		    0x1 },
    { FF_XPF,		"XPF",		0,		    0x1 },
    { FF_PNG,		"PNG",		0,		 0x1889 },
    { FF_DIRECTORY,	"DIRECTORY",	0,		   0x80 },

    {0,0,0,0}
};

//
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////   E N D   //////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

