
//
///////////////////////////////////////////////////////////////////////////////
//////   This file is created by a script. Modifications will be lost!   //////
///////////////////////////////////////////////////////////////////////////////

#ifndef SZS_FILE_TYPE_H
#define SZS_FILE_TYPE_H 1

#include "types.h"
#include "dclib-basics.h"


//
///////////////////////////////////////////////////////////////////////////////
////////////////////////////   enum ff_attrib_t   /////////////////////////////
///////////////////////////////////////////////////////////////////////////////

typedef enum ff_attrib_t
{
    FFT_VALID       = 0x0001,  // a valid file format

    FFT_COMPRESS    = 0x0002,  // is a compression format
    FFT_ARCHIVE     = 0x0004,  // is a supported archive
    FFT_GRAPHIC     = 0x0008,  // graphic image format
    FFT_TEXT        = 0x0010,  // (decoded) text file
     FFT_M_FTYPE    = 0x001e,  // mask of file types

    FFT_BRSUB       = 0x0020,  // is a BRRES sub file
    FFT_BRSUB2      = 0x0040,  // have a scondary file structure like a BRSUB
    FFT_EXTERNAL    = 0x0080,  // external file format
     FFT_M_CLASS    = 0x00e0,  // mask of file classes

    FFT_CREATE      = 0x0100,  // creation supported
    FFT_EXTRACT     = 0x0200,  // extracting supported
    FFT_CUT         = 0x0400,  // 'cut-files' supported
    FFT_DECODE      = 0x0800,  // decoding supported
    FFT_ENCODE      = 0x1000,  // encoding supported
    FFT_PARSER      = 0x2000,  // parser support on encoding
    FFT_PATCH       = 0x4000,  // patching of binaries
     FFT_M_SUPPORT  = 0x7f00,  // mask of supported operations

    FFT_NONE        = 0x0000,  // none set
    FFT_M_ALL       = 0x7fff   // all flags of above

} ff_attrib_t;


//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////   enum file_format_t   ////////////////////////////
///////////////////////////////////////////////////////////////////////////////

typedef enum file_format_t
{
	FF_UNKNOWN = 0, // definitley 0

	//--- file modes

	FF_YAZ0,	//  1
	FF_YAZ1,	//  2
	FF_XYZ,		//  3
	FF_BZ,		//  4
	FF_BZ2,		//  5

	FF_U8,		//  6
	FF_WU8,		//  7
	FF_RARC,	//  8
	FF_BRRES,	//  9
	FF_BREFF,	// 10
	FF_BREFT,	// 11
	FF_PACK,	// 12

	FF_CHR,		// 13
	FF_CLR,		// 14
	FF_MDL,		// 15
	FF_PAT,		// 16
	FF_SCN,		// 17
	FF_SHP,		// 18
	FF_SRT,		// 19
	FF_TEX,		// 20

	FF_TEX_CT,	// 21
	FF_CT_TEXT,	// 22

	FF_CT0_CODE,	// 23
	FF_CT0_DATA,	// 24
	FF_CT1_CODE,	// 25
	FF_CT1_DATA,	// 26

	FF_CUP1,	// 27
	FF_CRS1,	// 28
	FF_MOD1,	// 29
	FF_MOD2,	// 30
	FF_OVR1,	// 31

	FF_MDL_TXT,	// 32
	FF_PAT_TXT,	// 33

	FF_TPL,		// 34
	FF_BTI,		// 35
	FF_BREFT_IMG,	// 36

	FF_BMG,		// 37
	FF_BMG_TXT,	// 38
	FF_KCL,		// 39
	FF_KCL_TXT,	// 40
	FF_WAV_OBJ,	// 41
	FF_SKP_OBJ,	// 42
	FF_KMP,		// 43
	FF_KMP_TXT,	// 44
	FF_BRASD,	// 45

	FF_STATICR,	// 46
	FF_DOL,		// 47

	FF_GCT,		// 48
	FF_GCH,		// 49
	FF_WCH,		// 50
	FF_WPF,		// 51
	FF_XPF,		// 52

	FF_PNG,		// 53
	FF_DIRECTORY,	// 54

	//--- number of elements

	FF_N,
	FF_AUTO		= FF_N,

	//--- some more values

	FF_INVALID	= -1,
	FF__FIRST_BRSUB	= FF_CHR,
	FF__LAST_BRSUB	= FF_TEX,

} file_format_t;


//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////   struct file_type_t   ////////////////////////////
///////////////////////////////////////////////////////////////////////////////

typedef struct file_type_t
{
	ccp name;		// name
	ccp ext;		// standard file extension
	ccp ext_compr;		// file extension if compressed
	ccp ext_magic;		// magic based file extension

	ff_attrib_t attrib;	// file atributes

	ccp read_info;		// info about reading support, never NULL
	ccp write_info;		// info about writing support, never NULL
	ccp remark;		// remark about file type, never NULL

} file_type_t;

extern const file_type_t FileTypeTab[FF_N+1];
extern const struct KeywordTab_t cmdtab_FileType[];
extern const char filetype_info_unknown[];
extern const char filetype_info_not_supported[];


//
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////   E N D   //////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#endif // SZS_FILE_TYPE_H
