
/***************************************************************************
 *                       _______ _______ _______                           *
 *                      |  ___  |____   |  ___  |                          *
 *                      | |   |_|    / /| |   |_|                          *
 *                      | |_____    / / | |_____                           *
 *                      |_____  |  / /  |_____  |                          *
 *                       _    | | / /    _    | |                          *
 *                      | |___| |/ /____| |___| |                          *
 *                      |_______|_______|_______|                          *
 *                                                                         *
 *                           Wiimms SZS Tools                              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This file is part of the SZS project.                                 *
 *   Visit http://szs.wiimm.de/ for project details and sources.           *
 *                                                                         *
 *   Copyright (c) 2011-2015 by Dirk Clemens <wiimm@wiimm.de>              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   See file gpl-2.0.txt or http://www.gnu.org/licenses/gpl-2.0.txt       *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   >>>  This file is automatically generated by './src/gen-ui.c'.  <<<   *
 *   >>>                   Do not edit this file!                    <<<   *
 *                                                                         *
 ***************************************************************************/

#include <getopt.h>
#include "ui-wbmgt.h"

//
///////////////////////////////////////////////////////////////////////////////
///////////////                  OptionInfo[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t OptionInfo[OPT__N_TOTAL+1] =
{
    {0,0,0,0,0,0,0,0}, // OPT_NONE,

    //----- command specific options -----

    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print long numeric message IDs instead of alternative message names"
	" like Txx, Uxx or Mxx."
    },

    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in BMG text files."
    },

    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"If set, the information header in decoded text files is suppressed"
	" (for historical reasons same as --no-header). If set at least twice,"
	" all comments are suppressed and the output is packed without empty"
	" lines. If set 3 times, the #BMG file indentification is also"
	" suppressed."
    },

    {	OPT_DEST, false, false, false, true, 'd', "dest",
	"path",
	"Define a destination path (directory/file). The destination - means:"
	" write to standard output.\n"
	"  The path may contain escape sequences: %Q is replaced by the fully"
	" qualified source name. %P and %F are replaced by the source path or"
	" by the filename. %N and %E are replaced by source filename without"
	" extension or by the source extension. Finally, %T is replaced by the"
	" default extension of the destination format.\n"
	"  A '?' direct behind '%' in %E and %T conversions avoid that the"
	" same extension is used twice in row. Read"
	" http://szs.wiimm.de/opt/dest for more details."
    },

    {	OPT_DEST2, false, false, false, false, 'D', "DEST",
	"path",
	"Like --dest, but create the directory path automatically."
    },

    {	OPT_ESC, false, false, false, false, 'E', "esc",
	"char",
	"Define an alternative escape character for destination files. The"
	" default is '%'. For Windows batch files it is a good choice to set"
	" '-E$'."
    },

    {	OPT_OVERWRITE, false, false, false, false, 'o', "overwrite",
	0,
	"Overwrite already existing files without warning and ignore option"
	" --number."
    },

    {	OPT_NUMBER, false, false, false, false, 0, "number",
	0,
	"If a file already exist, append a number directly before the file"
	" extension to make the filename unique. If other numbered files"
	" already exist (ignoring case), use the maximum existing index+1."
	" --num is a short cut."
    },

    {	OPT_REMOVE_DEST, false, false, false, false, 'r', "remove-dest",
	0,
	"Remove already existing files before creating it. If set, --overwrite"
	" is ignored. --rm-dest is a short cut."
    },

    {	OPT_UPDATE, false, false, false, false, 'u', "update",
	0,
	"Create only files that do not exist. Already existing files are"
	" ignored without warning. If set, --overwrite and --remove-dest are"
	" ignored."
    },

    {	OPT_PRESERVE, false, false, false, false, 'p', "preserve",
	0,
	"Preserve file times (atime+mtime) while converting or copying files."
    },

    {	OPT_IGNORE, false, false, false, false, 'i', "ignore",
	0,
	"Ignore non existing source files without warning."
    },

    {	OPT_ALIGN, false, false, false, false, 0, "align",
	"size",
	"Define an align value for the sub sections in the archive. The value"
	" must be a power of 2 and the default value is 32 (0x20)"
    },

    {	OPT_PATCH_BMG, false, false, false, false, 'P', "patch-bmg",
	"mode[=param]",
	"This option specifies a BMG patch mode. Some of the modes need a"
	" parameter or a file name of a BMG patch file (raw or text BMG), both"
	" separated by an equal sign. Modes with required file names are"
	" PRINT, REPLACE, INSERT, OVERWRITE, DELETE, MASK, EQUAL and NOTEQUAL."
	" A mode with text parameter is FORMAT.  Standalone modes are ID,"
	" ID-ALL, UNICODE, RM-ESCAPES, RM-CUPS, CT-COPY, CT-FORCE-COPY and"
	" CT-FILL. Unique abbreviations are allowed.\n"
	"  If this option is used multiple times, all patch files will be"
	" processed in the entered order. --patch is a short cut. Read"
	" http://szs.wiimm.de/opt/patch-bmg for more details."
    },

    {	OPT_BMG_INF_SIZE, false, false, false, false, 0, "inf-size",
	"size",
	"Defines the 'INF0' size of new BMG files between 4 and 1000. The"
	" first 4 bytes of a INF0 record is a pointer to the string and the"
	" remaining bytes the string attributes. However, maximal 20 attribute"
	" bytes are supported and additional bytes are assumed to be NULL. All"
	" BMG files of MKW have a size of 8."
    },

    {	OPT_FORCE_ATTRIB, false, false, false, false, 0, "force-attrib",
	"attrib",
	"Forces, that all attributes are set to this vector. See"
	" http://szs.wiimm.de/doc/bmg/attrib for the syntax."
    },

    {	OPT_DEF_ATTRIB, false, false, false, false, 0, "def-attrib",
	"attrib",
	"Define the default attributes for BMG files. If not set, the default"
	" attributes are estimated. On text output, strings with default"
	" attributes are printed without attribute vector. The usual default"
	" attribute for MKW is [1]. See http://szs.wiimm.de/doc/bmg/attrib for"
	" the syntax."
    },

    {	OPT_NO_ATTRIB, false, false, false, false, 0, "no-attrib",
	0,
	"Suppress the output of any BMG attributes at text BMG files."
    },

    {	OPT_X_ESCAPES, false, false, false, false, 0, "x-escapes",
	0,
	"Use \\x{} escapes instead of \\z{} escapes."
    },

    {	OPT_OLD_ESCAPES, false, false, false, false, 0, "old-escapes",
	0,
	"To be compatible with v1.43 and earlier, print 1A escape sequences"
	" with total size of >12 bytes as single words using \\x{}. Also don't"
	" use \\x{} and \\u{} with parameter lists."
    },

    {	OPT_SINGLE_LINE, false, false, false, false, '1', "single-line",
	0,
	"If set, don't print continuation lines for BMG text output. If set"
	" twice, print only single text lines and suppress attributes like"
	" option --no-attrib does it."
    },

    {	OPT_NO_BMG_COLORS, false, false, false, false, 0, "no-bmg-colors",
	0,
	"If set, suppress the output of '\\c{color}' escape sequences for"
	" colors definitions in BMG text output to be compatible with old"
	" versions of the tools."
    },

    {	OPT_BMG_COLORS, false, false, false, false, 0, "bmg-colors",
	0,
	"Force output of '\\c{color}' escape sequences with names, even for"
	" foreign (not MKWii) BMG files."
    },

    {	OPT_NO_BMG_INLINE, false, false, false, false, 0, "no-bmg-inline",
	0,
	"Print BMG values as separate line before the message definition to be"
	" compatible with versions until v1.39. The output for the standard"
	" value 0x01000000 is always suppressed. This was the default until"
	" v1.43. Since v1.44, --bmg-inline is the default."
    },

    {	OPT_BMG_INLINE, false, true, false, false, 0, "bmg-inline",
	0,
	"[DEPRECATED] Print BMG values between message name and the equal sign"
	" using the format '[...]'. The output for the standard value (usually"
	" 0x01000000) is always suppressed. Since v1.44, the inline mode is"
	" the default. It can be disabled by option --no-bmg-inline to be"
	" compatible with versions until v1.39."
    },

    {	OPT_EXPORT, false, false, false, false, 'X', "export",
	0,
	"Enable the export modus and create small and machine readable text"
	" files for easy post processing. The option works similar like -HBl11"
	" for BMG text files."
    },

    {	OPT_MSG, false, false, false, false, 0, "msg",
	"list",
	"If this option is set, the BMG messages are filtered by this list."
	" Only enabled messages are exported to the ouput BMG file (binary or"
	" text).\n"
	"  The parameter is a list of message ids (short MID, 'Txx' or 'Uxx'"
	" or Mxx' or hex number) or message ranges (MID:MID) or one of the"
	" keywords NONE, PARAM, CUPS, TRACKS, ARENAS, CHAT, CTCODE, CTTRACKS"
	" or ALL. If an element is preceeded by a minus sign,  it is removed"
	" from the filter list (disabled)."
    },

    {	OPT_SECTIONS, false, false, false, true, 0, "sections",
	0,
	"Print in machine readable sections and parameter lines."
    },

    {0,0,0,0,0,0,0,0}, // OPT__N_SPECIFIC == 29

    //----- global options -----

    {	OPT_VERSION, false, false, false, false, 'V', "version",
	0,
	"Stop parsing the command line, print a version info and exit."
    },

    {	OPT_HELP, false, false, false, false, 'h', "help",
	0,
	"Stop parsing the command line, print a help message and exit."
    },

    {	OPT_XHELP, false, false, false, false, 0, "xhelp",
	0,
	"Stop parsing the command line and print a help message with all"
	" commands included. Exit after printing."
    },

    {	OPT_ALLOW_ALL, false, false, false, false, 0, "allow-all",
	0,
	"Usually commands accept only options with impact to the command. All"
	" other options fire a syntax error. But if --allow-all is set, all"
	" commands accept all options.\n"
	"  This makes changing the command of a long command line without"
	" removing useless options easier. It also helps to override wrong"
	" option permissions."
    },

    {	OPT_COMPATIBLE, false, false, false, false, 0, "compatible",
	"vers",
	"The option expects a version number (format '#.##' or 'v#.##') or a"
	" revision number (format 'r#') as parameter. If set, the tools try to"
	" create BMG and KMP text files, that are compatible to the entered"
	" version of the tools. This may override other legacy options."
    },

    {	OPT_WIDTH, false, false, true, false, 0, "width",
	"width",
	"Define the width (number of columns) for help and some other messages"
	" and disable the automatic detection of the terminal width."
    },

    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Be quiet and print only error messages. Multiple usage is possible."
	" The impact is command dependent."
    },

    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Be verbose and print more progress information. Multiple usage is"
	" possible. The impact is command dependent."
    },

    {	OPT_DE, false, false, false, false, 0, "de",
	0,
	"Use german track and arena names."
    },

    {	OPT_COLOR, false, false, true, false, 0, "color",
	0,
	"Force colorized text. This is the default, if an output file is a"
	" terminal. But colorized text is only supported for a few messages.\n"
	"  If a command is prefixed by 'C-', then this option is set"
	" automatically."
    },

    {	OPT_NO_COLOR, false, false, true, false, 0, "no-color",
	0,
	"Deactive colorized text. This is the default, if an output file is"
	" not a terminal."
    },

    {	OPT_CT_CODE, false, false, false, false, 0, "ct-code",
	0,
	"Enable the CT-CODE modus. See http://szs.wiimm.de/opt/ctcode for"
	" details."
    },

    {	OPT_CHDIR, false, false, false, false, 0, "chdir",
	"dir",
	"Set a new working directory for all following options, for all"
	" parameters and for the command execution. This option can be used"
	" multiple times, but for parameter parsing and for command execution"
	" only the last usage is relevant. Nevertheless, '@param' values are"
	" scanned while reading the command line."
    },

    {	OPT_CONST, false, false, false, false, 'c', "const",
	"list",
	"Define constant values, that are used by the internal encoders and by"
	" the numeric options as predefined global variables. This option"
	" allows a conditional encoding of text files. It can be used multiple"
	" times for multiple definitions.\n"
	"  The Parameter is a comma separated list of terms and a term is"
	" 'name=expression'. The expression is calculated by the text parser."
    },

    {	OPT_MAX_FILE_SIZE, false, false, false, false, 'M', "max-file-size",
	"size",
	"This security option defines the maximum file size for input files;"
	" larger files are ignored with a warning. The default unit is MiB and"
	" the default size is 100 MiB; that should be enough for standard"
	" usage."
    },

    {	OPT_TRACKS, false, false, false, false, 'T', "tracks",
	"tracks",
	"Define a new track order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are track names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned track. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Tracks will only be exchanged so that always all tracks are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_ARENAS, false, false, false, false, 'A', "arenas",
	"arenas",
	"Define a new arena order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are arena names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned arena. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Arenas will only be exchanged so that always all arenas are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_POINTS, false, false, false, false, 0, "points",
	"list",
	"This option creates the new message 3FF0 to hold a description of the"
	" versus points table. It defines a new table for the points assigned"
	" to players after a versus or room race. The parameter is a blank or"
	" comma and slash (next row) separated list with numbers (points)"
	" between 0 and 255 and the following keywords: NINTENDO, LINEAR, WIN,"
	" WIN15, WIN25 to select a predefined table; NO-BONUS, BONUS, NULL,"
	" ONE as options; N1..N12 to select the row for N players. See"
	" http://szs.wiimm.de/opt/points for details."
    },

    {	OPT_UTF_8, true, false, false, true, 0, "utf-8",
	0,
	"Enables UTF-8 support for filenames (default)."
    },

    {	OPT_NO_UTF_8, true, false, false, false, 0, "no-utf-8",
	0,
	"Disables UTF-8 support for filenames."
    },

    {	OPT_TEST, false, false, false, true, 't', "test",
	0,
	"Run in test mode, modify nothing.\n"
	">>> USE THIS OPTION IF UNSURE! <<<"
    },

    {	OPT_FORCE, false, false, false, false, 0, "force",
	0,
	"The tools analyse input files and reject files with invalid data"
	" structures. If --force is set, little repairable issues are ignored"
	" and a warning is printed.\n"
	"Option '--kmp force' does the same, but only for KMP files.\n"
	">>> THE RESULT MAY BE INVALID OUTPUT FILES! <<<"
    },

    {	OPT_OLD, true, false, false, false, 0, "OLD",
	0,
	"Use old implemenation if available."
    },

    {	OPT_NEW, true, false, false, false, 0, "NEW",
	0,
	"Use new implemenation if available."
    },

    {	OPT_EXTRACT, true, false, false, false, 0, "EXTRACT",
	0,
	"Create the directory and extract different objects in different"
	" formats at the moment when they are seen. This is a development"
	" helper option."
    },

    {0,0,0,0,0,0,0,0} // OPT__N_TOTAL == 54

};

//
///////////////////////////////////////////////////////////////////////////////
///////////////             alternate option infos              ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t option_cmd_VERSION_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print only the version number, revision and system. If set twice,"
	" print only the version number."
    };

static const InfoOption_t option_cmd_VERSION_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print in long format. Ignored if option --sections is set."
    };

static const InfoOption_t option_cmd_COLORS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print also a list of all colored text types."
    };

static const InfoOption_t option_cmd_ERROR_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print a message text instead of a message name."
    };

static const InfoOption_t option_cmd_FILETYPE_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print an additional column with the decompressed file type and"
	" version. If entered twice, a validation status column is added."
    };

static const InfoOption_t option_cmd_POINTS_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print the table as comma separated lists in C notation."
    };

static const InfoOption_t option_cmd_POINTS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Append a string in --points format that defines the table. If set"
	" twice, append up to 3 strings in different modes."
    };


//
///////////////////////////////////////////////////////////////////////////////
///////////////                  CommandTab[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const KeywordTab_t CommandTab[] =
{
    { CMD_VERSION,	"VERSION",	0,		0 },
    { CMD_HELP,		"HELP",		"H",		0 },
    { CMD_HELP,		"?",		0,		0 },
    { CMD_ARGTEST,	"ARGTEST",	0,		0 },
    { CMD_TEST,		"TEST",		0,		0 },
    { CMD_COLORS,	"COLORS",	0,		0 },
    { CMD_ERROR,	"ERROR",	"ERR",		0 },
    { CMD_FILETYPE,	"FILETYPE",	"FT",		0 },
    { CMD_FILEATTRIB,	"FILEATTRIB",	"FA",		0 },
    { CMD_POINTS,	"POINTS",	"PTS",		0 },
    { CMD_LIST,		"LIST",		"LS",		0 },
    { CMD_LIST,		"LL",		0,		0 },
    { CMD_DIFF,		"DIFF",		"CMP",		0 },
    { CMD_CAT,		"CAT",		0,		0 },
    { CMD_MIX,		"MIX",		0,		0 },
    { CMD_DECODE,	"DECODE",	"DEC",		0 },
    { CMD_ENCODE,	"ENCODE",	"ENC",		0 },
    { CMD_PATCH,	"PATCH",	"PAT",		0 },

    { CMD__N,0,0,0 }
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionShort & OptionLong             ///////////////
///////////////////////////////////////////////////////////////////////////////

static const char OptionShort[] = "Vhqvc:lHBM:T:A:td:D:E:orupiP:1X";

static const struct option OptionLong[] =
{
	{ "version",		0, 0, 'V' },
	{ "help",		0, 0, 'h' },
	{ "xhelp",		0, 0, GO_XHELP },
	{ "allow-all",		0, 0, GO_ALLOW_ALL },
	 { "allowall",		0, 0, GO_ALLOW_ALL },
	{ "compatible",		1, 0, GO_COMPATIBLE },
	{ "width",		1, 0, GO_WIDTH },
	{ "quiet",		0, 0, 'q' },
	{ "verbose",		0, 0, 'v' },
	{ "de",			0, 0, GO_DE },
	{ "color",		0, 0, GO_COLOR },
	{ "no-color",		0, 0, GO_NO_COLOR },
	 { "nocolor",		0, 0, GO_NO_COLOR },
	{ "ct-code",		0, 0, GO_CT_CODE },
	 { "ctcode",		0, 0, GO_CT_CODE },
	{ "chdir",		1, 0, GO_CHDIR },
	{ "const",		1, 0, 'c' },
	{ "long",		0, 0, 'l' },
	{ "no-header",		0, 0, 'H' },
	 { "noheader",		0, 0, 'H' },
	{ "brief",		0, 0, 'B' },
	{ "max-file-size",	1, 0, 'M' },
	 { "maxfilesize",	1, 0, 'M' },
	{ "tracks",		1, 0, 'T' },
	{ "arenas",		1, 0, 'A' },
	{ "points",		1, 0, GO_POINTS },
	 { "pts",		1, 0, GO_POINTS },
	{ "utf-8",		0, 0, GO_UTF_8 },
	 { "utf8",		0, 0, GO_UTF_8 },
	{ "no-utf-8",		0, 0, GO_NO_UTF_8 },
	 { "no-utf8",		0, 0, GO_NO_UTF_8 },
	 { "noutf8",		0, 0, GO_NO_UTF_8 },
	{ "test",		0, 0, 't' },
	{ "force",		0, 0, GO_FORCE },
	{ "OLD",		0, 0, GO_OLD },
	{ "NEW",		0, 0, GO_NEW },
	{ "EXTRACT",		0, 0, GO_EXTRACT },
	{ "dest",		1, 0, 'd' },
	{ "DEST",		1, 0, 'D' },
	{ "esc",		1, 0, 'E' },
	{ "overwrite",		0, 0, 'o' },
	{ "number",		0, 0, GO_NUMBER },
	 { "num",		0, 0, GO_NUMBER },
	{ "remove-dest",	0, 0, 'r' },
	 { "removedest",	0, 0, 'r' },
	 { "rm-dest",		0, 0, 'r' },
	 { "rmdest",		0, 0, 'r' },
	 { "remove",		0, 0, 'r' },
	{ "update",		0, 0, 'u' },
	{ "preserve",		0, 0, 'p' },
	{ "ignore",		0, 0, 'i' },
	{ "align",		1, 0, GO_ALIGN },
	{ "patch-bmg",		1, 0, 'P' },
	 { "patchbmg",		1, 0, 'P' },
	 { "pb",		1, 0, 'P' },
	 { "patch",		1, 0, 'P' },
	{ "inf-size",		1, 0, GO_BMG_INF_SIZE },
	 { "infsize",		1, 0, GO_BMG_INF_SIZE },
	 { "bmg-inf-size",	1, 0, GO_BMG_INF_SIZE },
	 { "bmginfsize",	1, 0, GO_BMG_INF_SIZE },
	{ "force-attrib",	1, 0, GO_FORCE_ATTRIB },
	 { "forceattrib",	1, 0, GO_FORCE_ATTRIB },
	{ "def-attrib",		1, 0, GO_DEF_ATTRIB },
	 { "defattrib",		1, 0, GO_DEF_ATTRIB },
	{ "no-attrib",		0, 0, GO_NO_ATTRIB },
	 { "noattrib",		0, 0, GO_NO_ATTRIB },
	{ "x-escapes",		0, 0, GO_X_ESCAPES },
	 { "xescapes",		0, 0, GO_X_ESCAPES },
	{ "old-escapes",	0, 0, GO_OLD_ESCAPES },
	 { "oldescapes",	0, 0, GO_OLD_ESCAPES },
	{ "single-line",	0, 0, '1' },
	 { "singleline",	0, 0, '1' },
	{ "no-bmg-colors",	0, 0, GO_NO_BMG_COLORS },
	 { "nobmgcolors",	0, 0, GO_NO_BMG_COLORS },
	{ "bmg-colors",		0, 0, GO_BMG_COLORS },
	 { "bmgcolors",		0, 0, GO_BMG_COLORS },
	{ "no-bmg-inline",	0, 0, GO_NO_BMG_INLINE },
	 { "nobmginline",	0, 0, GO_NO_BMG_INLINE },
	{ "bmg-inline",		0, 0, GO_BMG_INLINE },
	 { "bmginline",		0, 0, GO_BMG_INLINE },
	{ "export",		0, 0, 'X' },
	{ "msg",		1, 0, GO_MSG },
	{ "sections",		0, 0, GO_SECTIONS },

	{0,0,0,0}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionUsed & OptionIndex             ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 OptionUsed[OPT__N_TOTAL+1] = {0};

static const u8 OptionIndex[OPT_INDEX_SIZE] = 
{
	/* 0x00   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x10   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x20   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x30   */	 0,
	/* 0x31 1 */	OPT_SINGLE_LINE,
	/* 0x32   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,
	/* 0x41 A */	OPT_ARENAS,
	/* 0x42 B */	OPT_BRIEF,
	/* 0x43   */	 0,
	/* 0x44 D */	OPT_DEST2,
	/* 0x45 E */	OPT_ESC,
	/* 0x46   */	 0,0,
	/* 0x48 H */	OPT_NO_HEADER,
	/* 0x49   */	 0,0,0,0, 
	/* 0x4d M */	OPT_MAX_FILE_SIZE,
	/* 0x4e   */	 0,0,
	/* 0x50 P */	OPT_PATCH_BMG,
	/* 0x51   */	 0,0,0,
	/* 0x54 T */	OPT_TRACKS,
	/* 0x55   */	 0,
	/* 0x56 V */	OPT_VERSION,
	/* 0x57   */	 0,
	/* 0x58 X */	OPT_EXPORT,
	/* 0x59   */	 0,0,0,0, 0,0,0,0, 0,0,
	/* 0x63 c */	OPT_CONST,
	/* 0x64 d */	OPT_DEST,
	/* 0x65   */	 0,0,0,
	/* 0x68 h */	OPT_HELP,
	/* 0x69 i */	OPT_IGNORE,
	/* 0x6a   */	 0,0,
	/* 0x6c l */	OPT_LONG,
	/* 0x6d   */	 0,0,
	/* 0x6f o */	OPT_OVERWRITE,
	/* 0x70 p */	OPT_PRESERVE,
	/* 0x71 q */	OPT_QUIET,
	/* 0x72 r */	OPT_REMOVE_DEST,
	/* 0x73   */	 0,
	/* 0x74 t */	OPT_TEST,
	/* 0x75 u */	OPT_UPDATE,
	/* 0x76 v */	OPT_VERBOSE,
	/* 0x77   */	 0,0,0,0, 0,0,0,0, 0,
	/* 0x80   */	OPT_XHELP,
	/* 0x81   */	OPT_ALLOW_ALL,
	/* 0x82   */	OPT_COMPATIBLE,
	/* 0x83   */	OPT_WIDTH,
	/* 0x84   */	OPT_DE,
	/* 0x85   */	OPT_COLOR,
	/* 0x86   */	OPT_NO_COLOR,
	/* 0x87   */	OPT_CT_CODE,
	/* 0x88   */	OPT_CHDIR,
	/* 0x89   */	OPT_POINTS,
	/* 0x8a   */	OPT_UTF_8,
	/* 0x8b   */	OPT_NO_UTF_8,
	/* 0x8c   */	OPT_FORCE,
	/* 0x8d   */	OPT_OLD,
	/* 0x8e   */	OPT_NEW,
	/* 0x8f   */	OPT_EXTRACT,
	/* 0x90   */	OPT_NUMBER,
	/* 0x91   */	OPT_ALIGN,
	/* 0x92   */	OPT_BMG_INF_SIZE,
	/* 0x93   */	OPT_FORCE_ATTRIB,
	/* 0x94   */	OPT_DEF_ATTRIB,
	/* 0x95   */	OPT_NO_ATTRIB,
	/* 0x96   */	OPT_X_ESCAPES,
	/* 0x97   */	OPT_OLD_ESCAPES,
	/* 0x98   */	OPT_NO_BMG_COLORS,
	/* 0x99   */	OPT_BMG_COLORS,
	/* 0x9a   */	OPT_NO_BMG_INLINE,
	/* 0x9b   */	OPT_BMG_INLINE,
	/* 0x9c   */	OPT_MSG,
	/* 0x9d   */	OPT_SECTIONS,
	/* 0x9e   */	 0,0,
	/* 0xa0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xb0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xc0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xd0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xe0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xf0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                opt_allowed_cmd_*                ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 option_allowed_cmd_VERSION[29] = // cmd #1
{
    0,1,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1
};

static u8 option_allowed_cmd_HELP[29] = // cmd #2
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1
};

static u8 option_allowed_cmd_ARGTEST[29] = // cmd #3
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1
};

static u8 option_allowed_cmd_TEST[29] = // cmd #4
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1
};

static u8 option_allowed_cmd_COLORS[29] = // cmd #5
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0
};

static u8 option_allowed_cmd_ERROR[29] = // cmd #6
{
    0,1,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1
};

static u8 option_allowed_cmd_FILETYPE[29] = // cmd #7
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0
};

static u8 option_allowed_cmd_FILEATTRIB[29] = // cmd #8
{
    0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0
};

static u8 option_allowed_cmd_POINTS[29] = // cmd #9
{
    0,1,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0
};

static u8 option_allowed_cmd_LIST[29] = // cmd #10
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,0,1, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,0
};

static u8 option_allowed_cmd_DIFF[29] = // cmd #11
{
    0,0,0,0,1, 0,1,0,0,0,  0,0,0,0,1, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,0
};

static u8 option_allowed_cmd_CAT[29] = // cmd #12
{
    0,1,1,1,0, 0,0,0,0,0,  0,0,1,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,0
};

static u8 option_allowed_cmd_MIX[29] = // cmd #13
{
    0,1,1,1,0, 0,0,0,0,0,  0,0,1,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,0
};

static u8 option_allowed_cmd_DECODE[29] = // cmd #14
{
    0,1,1,1,1, 1,1,1,1,1,  1,1,1,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,0
};

static u8 option_allowed_cmd_ENCODE[29] = // cmd #15
{
    0,0,0,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,0,0,0,  0,0,0,0,0, 0,0,1,0
};

static u8 option_allowed_cmd_PATCH[29] = // cmd #16
{
    0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                 InfoOption tabs                 ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t * option_tab_tool[] =
{
	OptionInfo + OPT_VERSION,
	OptionInfo + OPT_HELP,
	OptionInfo + OPT_XHELP,
	OptionInfo + OPT_ALLOW_ALL,
	OptionInfo + OPT_COMPATIBLE,
	OptionInfo + OPT_WIDTH,
	OptionInfo + OPT_QUIET,
	OptionInfo + OPT_VERBOSE,
	OptionInfo + OPT_DE,
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	OptionInfo + OPT_CT_CODE,
	OptionInfo + OPT_CHDIR,
	OptionInfo + OPT_CONST,
	OptionInfo + OPT_MAX_FILE_SIZE,
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_POINTS,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TEST,
	OptionInfo + OPT_FORCE,

	0
};

static const InfoOption_t * option_tab_cmd_VERSION[] =
{
	&option_cmd_VERSION_BRIEF,
	OptionInfo + OPT_SECTIONS,
	&option_cmd_VERSION_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_HELP[] =
{
	OptionInfo + OPT_WIDTH,

	0
};

static const InfoOption_t * option_tab_cmd_ARGTEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_TEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_COLORS[] =
{
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	&option_cmd_COLORS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_ERROR[] =
{
	OptionInfo + OPT_SECTIONS,
	OptionInfo + OPT_NO_HEADER,
	&option_cmd_ERROR_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_FILETYPE[] =
{
	&option_cmd_FILETYPE_LONG,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_FILEATTRIB[] =
{
	OptionInfo + OPT_NO_HEADER,

	0
};

static const InfoOption_t * option_tab_cmd_POINTS[] =
{
	OptionInfo + OPT_POINTS,
	&option_cmd_POINTS_BRIEF,
	&option_cmd_POINTS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_LIST[] =
{
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_WIDTH,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_DIFF[] =
{
	OptionInfo + OPT_WIDTH,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_ESC,

	0
};

static const InfoOption_t * option_tab_cmd_CAT[] =
{
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_BMG_INF_SIZE,
	OptionInfo + OPT_FORCE_ATTRIB,
	OptionInfo + OPT_DEF_ATTRIB,
	OptionInfo + OPT_NO_ATTRIB,
	OptionInfo + OPT_X_ESCAPES,
	OptionInfo + OPT_OLD_ESCAPES,
	OptionInfo + OPT_SINGLE_LINE,
	OptionInfo + OPT_NO_BMG_COLORS,
	OptionInfo + OPT_BMG_COLORS,
	OptionInfo + OPT_NO_BMG_INLINE,
	OptionInfo + OPT_BMG_INLINE,
	OptionInfo + OPT_LONG,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_MIX[] =
{
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_BMG_INF_SIZE,
	OptionInfo + OPT_FORCE_ATTRIB,
	OptionInfo + OPT_DEF_ATTRIB,
	OptionInfo + OPT_NO_ATTRIB,
	OptionInfo + OPT_X_ESCAPES,
	OptionInfo + OPT_OLD_ESCAPES,
	OptionInfo + OPT_SINGLE_LINE,
	OptionInfo + OPT_NO_BMG_COLORS,
	OptionInfo + OPT_BMG_COLORS,
	OptionInfo + OPT_NO_BMG_INLINE,
	OptionInfo + OPT_BMG_INLINE,
	OptionInfo + OPT_LONG,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_DECODE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_BMG_INF_SIZE,
	OptionInfo + OPT_FORCE_ATTRIB,
	OptionInfo + OPT_DEF_ATTRIB,
	OptionInfo + OPT_NO_ATTRIB,
	OptionInfo + OPT_X_ESCAPES,
	OptionInfo + OPT_OLD_ESCAPES,
	OptionInfo + OPT_SINGLE_LINE,
	OptionInfo + OPT_NO_BMG_COLORS,
	OptionInfo + OPT_BMG_COLORS,
	OptionInfo + OPT_NO_BMG_INLINE,
	OptionInfo + OPT_BMG_INLINE,
	OptionInfo + OPT_LONG,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_ENCODE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_BMG_INF_SIZE,
	OptionInfo + OPT_FORCE_ATTRIB,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,
	OptionInfo + OPT_ALIGN,

	0
};

static const InfoOption_t * option_tab_cmd_PATCH[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_BMG_INF_SIZE,
	OptionInfo + OPT_FORCE_ATTRIB,
	OptionInfo + OPT_DEF_ATTRIB,
	OptionInfo + OPT_NO_ATTRIB,
	OptionInfo + OPT_X_ESCAPES,
	OptionInfo + OPT_OLD_ESCAPES,
	OptionInfo + OPT_SINGLE_LINE,
	OptionInfo + OPT_NO_BMG_COLORS,
	OptionInfo + OPT_BMG_COLORS,
	OptionInfo + OPT_NO_BMG_INLINE,
	OptionInfo + OPT_BMG_INLINE,
	OptionInfo + OPT_LONG,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,
	OptionInfo + OPT_ALIGN,

	0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                   InfoCommand                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoCommand_t CommandInfo[CMD__N+1] =
{
    {	0,
	false,
	false,
	false,
	"wbmgt",
	0,
	"wbmgt [option]... command [option|parameter|file]...",
	"Wiimms BMG Tool : Convert and patch raw and text BMG (message) files.",
	0,
	20,
	option_tab_tool,
	0
    },

    {	CMD_VERSION,
	false,
	false,
	false,
	"VERSION",
	0,
	"wbmgt VERSION [ignored]...",
	"Print program name and version and exit.",
	0,
	3,
	option_tab_cmd_VERSION,
	option_allowed_cmd_VERSION
    },

    {	CMD_HELP,
	false,
	false,
	false,
	"HELP",
	"H",
	"wbmgt HELP [--width=wd] OPT|OPTION ...\n"
	"wbmgt HELP [--width=wd] CMD|COMMAND [ignored]...\n"
	"wbmgt HELP [--width=wd] command [-b] [ignored]...\n"
	"wbmgt HELP [--width=wd] [ignored]...",
	"Print help for commands and options.",
	"Print help for commands and options.\n"
	"  The first variant (with keyword OPT or OPTION) prints a list of all"
	" global and command specific options. If at least one option is set,"
	" only infos about the declared options are printed. The second"
	" variant (with keyword CMD or COMMAND) prints an overview about all"
	" commands. The third variant (with a valid command name) prints"
	" details about the declared command. The fourth variant prints an"
	" overview about all commands and all global options.",
	1,
	option_tab_cmd_HELP,
	option_allowed_cmd_HELP
    },

    {	CMD_ARGTEST,
	false,
	false,
	false,
	"ARGTEST",
	0,
	"wbmgt ARGTEST ...",
	"This debug command accepts all kinds of parameters and prints one"
	" line for each parameter.",
	0,
	0,
	option_tab_cmd_ARGTEST,
	option_allowed_cmd_ARGTEST
    },

    {	CMD_TEST,
	false,
	false,
	false,
	"TEST",
	0,
	"wbmgt TEST [options]... [ignored]...",
	"This debugging command accepts all options and parameters and prints"
	" a list of the internal option values. The command is designed to"
	" test the option parameters. The non option parameters are completly"
	" ignored.",
	0,
	0,
	option_tab_cmd_TEST,
	option_allowed_cmd_TEST
    },

    {	CMD_COLORS,
	false,
	false,
	false,
	"COLORS",
	0,
	"wbmgt COLORS",
	"Ignore all parameters and print clored text for testing.",
	0,
	3,
	option_tab_cmd_COLORS,
	option_allowed_cmd_COLORS
    },

    {	CMD_ERROR,
	false,
	false,
	false,
	"ERROR",
	"ERR",
	"wbmgt ERROR [error_code]",
	"Translate an exit code to a message name. If no exit code is entered,"
	" print a table with all error messages.",
	0,
	3,
	option_tab_cmd_ERROR,
	option_allowed_cmd_ERROR
    },

    {	CMD_FILETYPE,
	false,
	false,
	false,
	"FILETYPE",
	"FT",
	"wbmgt FILETYPE file...",
	"Scan the header of the entered files and print file type and path for"
	" each file as list.",
	0,
	2,
	option_tab_cmd_FILETYPE,
	option_allowed_cmd_FILETYPE
    },

    {	CMD_FILEATTRIB,
	false,
	false,
	false,
	"FILEATTRIB",
	"FA",
	"wbmgt FILEATTRIB [keyword]...",
	"Print a table with attributes for all known file types. If at least"
	" one keyword is entered, only matching file types are printed. A"
	" keyword is either a file type (like 'BRRES' or 'BMG') or one of the"
	" printed keywords (like 'ARCHIVE' or 'EXTRACT').",
	0,
	1,
	option_tab_cmd_FILEATTRIB,
	option_allowed_cmd_FILEATTRIB
    },

    {	CMD_POINTS,
	false,
	false,
	false,
	"POINTS",
	"PTS",
	"wbmgt POINTS [--points=list]",
	"Print a table with the points assigned to player after a versus or"
	" room race.",
	0,
	3,
	option_tab_cmd_POINTS,
	option_allowed_cmd_POINTS
    },

    {	CMD_LIST,
	false,
	false,
	true,
	"LIST",
	"LS",
	"wbmgt LIST [source]...",
	"List a message file to proof the content. Patches are applied before"
	" listing. The lines are cut to fit the terminal width.",
	0,
	4,
	option_tab_cmd_LIST,
	option_allowed_cmd_LIST
    },

    {	CMD_DIFF,
	false,
	false,
	false,
	"DIFF",
	"CMP",
	"wbmgt DIFF source1 source2\n"
	"wbmgt DIFF source... --dest dest\n",
	"Compare two or more BMG (raw or text) files on string level and"
	" report mismatches for each string. If option --dest is set, than"
	" each source file is compared with a file in the destination. Patches"
	" are applied to all sources before comparing.",
	0,
	5,
	option_tab_cmd_DIFF,
	option_allowed_cmd_DIFF
    },

    {	CMD_CAT,
	false,
	false,
	true,
	"CAT",
	0,
	"wbmgt CAT [source]...",
	"Read the entered BMG files (text, binary or szs sub file) and print"
	" them as decoded text files to standard output. All BMG files of a"
	" single archive (SZS,...) are combined to 1 source. The output of all"
	" source files is concatenated.",
	0,
	18,
	option_tab_cmd_CAT,
	option_allowed_cmd_CAT
    },

    {	CMD_MIX,
	false,
	false,
	false,
	"MIX",
	0,
	"wbmgt MIX [source]...",
	"Read the entered BMG files (text, binary or szs sub file) and print"
	" them as decoded text files to standard output. All BMG files of all"
	" archives (SZS,...) are read. The output of all source files is"
	" combined and strings of later source files override prior defined"
	" strings.",
	0,
	18,
	option_tab_cmd_MIX,
	option_allowed_cmd_MIX
    },

    {	CMD_DECODE,
	false,
	false,
	false,
	"DECODE",
	"DEC",
	"wbmgt DECODE [szs]...",
	"Read the entered message files and decode them to text files. All BMG"
	" files of a single archive (SZS,...) are concatenated to 1 source."
	" This command is similar to PATCH, but the result is always decoded."
	" The default destination is '%P/%N.txt'.",
	0,
	26,
	option_tab_cmd_DECODE,
	option_allowed_cmd_DECODE
    },

    {	CMD_ENCODE,
	false,
	false,
	false,
	"ENCODE",
	"ENC",
	"wbmgt ENCODE [source]...",
	"Read the entered message files and encode them to BMG files. All BMG"
	" files of a single archive (SZS,...) are concatenated to 1 source."
	" This command is similar to PATCH, but the result is always encoded."
	" The default destination is '%P/%N.bmg'.",
	0,
	14,
	option_tab_cmd_ENCODE,
	option_allowed_cmd_ENCODE
    },

    {	CMD_PATCH,
	false,
	false,
	false,
	"PATCH",
	"PAT",
	"wbmgt PATCH [source]...",
	"Patch the entered files by using the patch list specified by option"
	" --patch-bmg. The coding of the source files is not changed. The"
	" default destination is '%P/%F'.\n"
	"  Use 'wszst patch --patch-bmg ...' to patch BMG files within a SZS"
	" file.",
	0,
	27,
	option_tab_cmd_PATCH,
	option_allowed_cmd_PATCH
    },

    {0,0,0,0,0,0,0,0,0,00,}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                     InfoUI                      ///////////////
///////////////////////////////////////////////////////////////////////////////

const InfoUI_t InfoUI_wbmgt =
{
	"wbmgt",
	CMD__N,
	CommandTab,
	CommandInfo,
	OPT__N_SPECIFIC,
	OPT__N_TOTAL,
	OptionInfo,
	OptionUsed,
	OptionIndex,
	OptionShort,
	OptionLong
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                       END                       ///////////////
///////////////////////////////////////////////////////////////////////////////

