
/***************************************************************************
 *                       _______ _______ _______                           *
 *                      |  ___  |____   |  ___  |                          *
 *                      | |   |_|    / /| |   |_|                          *
 *                      | |_____    / / | |_____                           *
 *                      |_____  |  / /  |_____  |                          *
 *                       _    | | / /    _    | |                          *
 *                      | |___| |/ /____| |___| |                          *
 *                      |_______|_______|_______|                          *
 *                                                                         *
 *                           Wiimms SZS Tools                              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This file is part of the SZS project.                                 *
 *   Visit http://szs.wiimm.de/ for project details and sources.           *
 *                                                                         *
 *   Copyright (c) 2011-2015 by Dirk Clemens <wiimm@wiimm.de>              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   See file gpl-2.0.txt or http://www.gnu.org/licenses/gpl-2.0.txt       *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   >>>  This file is automatically generated by './src/gen-ui.c'.  <<<   *
 *   >>>                   Do not edit this file!                    <<<   *
 *                                                                         *
 ***************************************************************************/


#ifndef SZS_UI_WCTCT_H
#define SZS_UI_WCTCT_H
#include "dclib-basics.h"
#include "dclib-ui.h"

//
///////////////////////////////////////////////////////////////////////////////
///////////////                enum enumOptions                 ///////////////
///////////////////////////////////////////////////////////////////////////////

typedef enum enumOptions
{
	OPT_NONE,

	//----- command specific options -----

	OPT_LONG,
	OPT_NO_HEADER,
	OPT_BRIEF,
	OPT_RAW,
	OPT_BMG_INF_SIZE,
	OPT_FORCE_ATTRIB,
	OPT_DEF_ATTRIB,
	OPT_NO_ATTRIB,
	OPT_X_ESCAPES,
	OPT_OLD_ESCAPES,
	OPT_SINGLE_LINE,
	OPT_NO_BMG_COLORS,
	OPT_BMG_COLORS,
	OPT_NO_BMG_INLINE,
	OPT_BMG_INLINE,
	OPT_EXPORT,
	OPT_NO_PARAM,
	OPT_NO_ECHO,
	OPT_NO_CHECK,
	OPT_LIST,
	OPT_REF,
	OPT_FULL,
	OPT_HEX,
	OPT_IMAGES,
	OPT_LOAD_BMG,
	OPT_PATCH_BMG,
	OPT_PATCH_NAMES,
	OPT_ORDER_BY,
	OPT_ORDER_ALL,
	OPT_WRITE_TRACKS,
	OPT_DEST,
	OPT_DEST2,
	OPT_ESC,
	OPT_OVERWRITE,
	OPT_NUMBER,
	OPT_REMOVE_DEST,
	OPT_UPDATE,
	OPT_PRESERVE,
	OPT_IGNORE,
	OPT_SECTIONS,

	OPT__N_SPECIFIC, // == 41 

	//----- global options -----

	OPT_VERSION,
	OPT_HELP,
	OPT_XHELP,
	OPT_ALLOW_ALL,
	OPT_COMPATIBLE,
	OPT_WIDTH,
	OPT_QUIET,
	OPT_VERBOSE,
	OPT_DE,
	OPT_COLOR,
	OPT_NO_COLOR,
	OPT_CT_CODE,
	OPT_OLD_SPINY,
	OPT_CRS1,
	OPT_CHDIR,
	OPT_CONST,
	OPT_LOGGING,
	OPT_MAX_FILE_SIZE,
	OPT_TRACKS,
	OPT_ARENAS,
	OPT_UTF_8,
	OPT_NO_UTF_8,
	OPT_TEST,
	OPT_FORCE,
	OPT_OLD,
	OPT_NEW,
	OPT_EXTRACT,
	OPT_CT_DIR,
	OPT_ALLOW_SLOTS,

	OPT__N_TOTAL // == 70

} enumOptions;

//
///////////////////////////////////////////////////////////////////////////////
///////////////               enum enumOptionsBit               ///////////////
///////////////////////////////////////////////////////////////////////////////

//	*****  only for verification  *****

//typedef enum enumOptionsBit
//{
//	//----- command specific options -----
//
//	OB_LONG			= 1llu << OPT_LONG,
//	OB_NO_HEADER		= 1llu << OPT_NO_HEADER,
//	OB_BRIEF		= 1llu << OPT_BRIEF,
//	OB_RAW			= 1llu << OPT_RAW,
//	OB_BMG_INF_SIZE		= 1llu << OPT_BMG_INF_SIZE,
//	OB_FORCE_ATTRIB		= 1llu << OPT_FORCE_ATTRIB,
//	OB_DEF_ATTRIB		= 1llu << OPT_DEF_ATTRIB,
//	OB_NO_ATTRIB		= 1llu << OPT_NO_ATTRIB,
//	OB_X_ESCAPES		= 1llu << OPT_X_ESCAPES,
//	OB_OLD_ESCAPES		= 1llu << OPT_OLD_ESCAPES,
//	OB_SINGLE_LINE		= 1llu << OPT_SINGLE_LINE,
//	OB_NO_BMG_COLORS	= 1llu << OPT_NO_BMG_COLORS,
//	OB_BMG_COLORS		= 1llu << OPT_BMG_COLORS,
//	OB_NO_BMG_INLINE	= 1llu << OPT_NO_BMG_INLINE,
//	OB_BMG_INLINE		= 1llu << OPT_BMG_INLINE,
//	OB_EXPORT		= 1llu << OPT_EXPORT,
//	OB_NO_PARAM		= 1llu << OPT_NO_PARAM,
//	OB_NO_ECHO		= 1llu << OPT_NO_ECHO,
//	OB_NO_CHECK		= 1llu << OPT_NO_CHECK,
//	OB_LIST			= 1llu << OPT_LIST,
//	OB_REF			= 1llu << OPT_REF,
//	OB_FULL			= 1llu << OPT_FULL,
//	OB_HEX			= 1llu << OPT_HEX,
//	OB_IMAGES		= 1llu << OPT_IMAGES,
//	OB_LOAD_BMG		= 1llu << OPT_LOAD_BMG,
//	OB_PATCH_BMG		= 1llu << OPT_PATCH_BMG,
//	OB_PATCH_NAMES		= 1llu << OPT_PATCH_NAMES,
//	OB_ORDER_BY		= 1llu << OPT_ORDER_BY,
//	OB_ORDER_ALL		= 1llu << OPT_ORDER_ALL,
//	OB_WRITE_TRACKS		= 1llu << OPT_WRITE_TRACKS,
//	OB_DEST			= 1llu << OPT_DEST,
//	OB_DEST2		= 1llu << OPT_DEST2,
//	OB_ESC			= 1llu << OPT_ESC,
//	OB_OVERWRITE		= 1llu << OPT_OVERWRITE,
//	OB_NUMBER		= 1llu << OPT_NUMBER,
//	OB_REMOVE_DEST		= 1llu << OPT_REMOVE_DEST,
//	OB_UPDATE		= 1llu << OPT_UPDATE,
//	OB_PRESERVE		= 1llu << OPT_PRESERVE,
//	OB_IGNORE		= 1llu << OPT_IGNORE,
//	OB_SECTIONS		= 1llu << OPT_SECTIONS,
//
//	//----- group & command options -----
//
//	OB_GRP_DEST		= OB_WRITE_TRACKS
//				| OB_DEST
//				| OB_DEST2
//				| OB_ESC
//				| OB_OVERWRITE
//				| OB_NUMBER
//				| OB_REMOVE_DEST
//				| OB_UPDATE
//				| OB_PRESERVE,
//
//	OB_GRP_PATCH		= OB_LOAD_BMG
//				| OB_PATCH_BMG
//				| OB_PATCH_NAMES
//				| OB_ORDER_BY
//				| OB_ORDER_ALL,
//
//	OB_GRP_TEXTOPT		= OB_HEX
//				| OB_NO_HEADER
//				| OB_BRIEF
//				| OB_EXPORT,
//
//	OB_GRP_TEXTOUT		= OB_IGNORE
//				| OB_LIST
//				| OB_REF
//				| OB_FULL
//				| OB_GRP_TEXTOPT,
//
//	OB_CMD_VERSION		= OB_BRIEF
//				| OB_SECTIONS
//				| OB_LONG,
//
//	OB_CMD_HELP		= ~(u64)0,
//
//	OB_CMD_ARGTEST		= ~(u64)0,
//
//	OB_CMD_TEST		= ~(u64)0,
//
//	OB_CMD_COLORS		= OB_LONG,
//
//	OB_CMD_ERROR		= OB_SECTIONS
//				| OB_NO_HEADER
//				| OB_LONG,
//
//	OB_CMD_FILETYPE		= OB_LONG
//				| OB_IGNORE,
//
//	OB_CMD_FILEATTRIB	= OB_NO_HEADER,
//
//	OB_CMD_SYMBOLS		= OB_NO_HEADER,
//
//	OB_CMD_FUNCTIONS	= OB_NO_HEADER
//				| OB_BRIEF
//				| OB_LONG,
//
//	OB_CMD_CALCULATE	= 0,
//
//	OB_CMD_FLOAT		= 0,
//
//	OB_CMD_EXPORT		= 0,
//
//	OB_CMD_RAWDUMP		= OB_DEST
//				| OB_DEST2,
//
//	OB_CMD_DUMP		= OB_LONG
//				| OB_GRP_PATCH,
//
//	OB_CMD_BMG		= OB_BRIEF
//				| OB_LONG
//				| OB_GRP_TEXTOUT
//				| OB_BMG_INF_SIZE
//				| OB_FORCE_ATTRIB
//				| OB_DEF_ATTRIB
//				| OB_NO_ATTRIB
//				| OB_X_ESCAPES
//				| OB_OLD_ESCAPES
//				| OB_SINGLE_LINE
//				| OB_NO_BMG_COLORS
//				| OB_BMG_COLORS
//				| OB_NO_BMG_INLINE
//				| OB_BMG_INLINE
//				| OB_WRITE_TRACKS
//				| OB_NO_ECHO
//				| OB_NO_CHECK
//				| OB_IGNORE
//				| OB_GRP_PATCH,
//
//	OB_CMD_TRACKS		= OB_NO_HEADER
//				| OB_BRIEF
//				| OB_LONG
//				| OB_RAW
//				| OB_GRP_TEXTOUT
//				| OB_WRITE_TRACKS
//				| OB_NO_ECHO
//				| OB_NO_CHECK
//				| OB_IGNORE
//				| OB_GRP_PATCH,
//
//	OB_CMD_CAT		= OB_GRP_TEXTOUT
//				| OB_WRITE_TRACKS
//				| OB_NO_ECHO
//				| OB_NO_CHECK
//				| OB_IGNORE
//				| OB_GRP_PATCH,
//
//	OB_CMD_DECODE		= OB_GRP_DEST
//				| OB_GRP_TEXTOUT
//				| OB_NO_ECHO
//				| OB_NO_CHECK
//				| OB_IGNORE
//				| OB_GRP_PATCH,
//
//	OB_CMD_CREATE		= OB_GRP_DEST
//				| OB_IGNORE
//				| OB_GRP_TEXTOPT
//				| OB_BMG_INF_SIZE
//				| OB_FORCE_ATTRIB
//				| OB_DEF_ATTRIB
//				| OB_NO_ATTRIB
//				| OB_X_ESCAPES
//				| OB_OLD_ESCAPES
//				| OB_SINGLE_LINE
//				| OB_NO_BMG_COLORS
//				| OB_BMG_COLORS
//				| OB_NO_BMG_INLINE
//				| OB_BMG_INLINE
//				| OB_BRIEF
//				| OB_LONG
//				| OB_NO_ECHO
//				| OB_NO_CHECK
//				| OB_IGNORE
//				| OB_IMAGES
//				| OB_GRP_PATCH,
//
//	OB_CMD_PATCH		= OB_GRP_DEST
//				| OB_IGNORE
//				| OB_NO_CHECK
//				| OB_IGNORE
//				| OB_GRP_PATCH,
//
//} enumOptionsBit;

//
///////////////////////////////////////////////////////////////////////////////
///////////////                enum enumCommands                ///////////////
///////////////////////////////////////////////////////////////////////////////

typedef enum enumCommands
{
	CMD__NONE,

	CMD_VERSION,
	CMD_HELP,
	CMD_ARGTEST,
	CMD_TEST,
	CMD_COLORS,
	CMD_ERROR,
	CMD_FILETYPE,
	CMD_FILEATTRIB,
	CMD_SYMBOLS,
	CMD_FUNCTIONS,
	CMD_CALCULATE,
	CMD_FLOAT,
	CMD_EXPORT,
	CMD_RAWDUMP,

	CMD_DUMP,
	CMD_CAT,
	CMD_BMG,
	CMD_TRACKS,
	CMD_DECODE,
	CMD_CREATE,
	CMD_PATCH,


	CMD__N // == 22

} enumCommands;

//
///////////////////////////////////////////////////////////////////////////////
///////////////                   enumGetOpt                    ///////////////
///////////////////////////////////////////////////////////////////////////////

typedef enum enumGetOpt
{
	GO_SINGLE_LINE		= '1',

	GO__ERR			= '?',

	GO_ARENAS		= 'A',
	GO_BRIEF		= 'B',
	GO_DEST2		= 'D',
	GO_ESC			= 'E',
	GO_NO_HEADER		= 'H',
	GO_LOGGING		= 'L',
	GO_MAX_FILE_SIZE	= 'M',
	GO_NO_CHECK		= 'N',
	GO_NO_PARAM		= 'P',
	GO_TRACKS		= 'T',
	GO_VERSION		= 'V',
	GO_EXPORT		= 'X',

	GO_CONST		= 'c',
	GO_DEST			= 'd',
	GO_HELP			= 'h',
	GO_IGNORE		= 'i',
	GO_LONG			= 'l',
	GO_OVERWRITE		= 'o',
	GO_PRESERVE		= 'p',
	GO_QUIET		= 'q',
	GO_REMOVE_DEST		= 'r',
	GO_TEST			= 't',
	GO_UPDATE		= 'u',
	GO_VERBOSE		= 'v',

	GO_XHELP		= 0x80,
	GO_ALLOW_ALL,
	GO_COMPATIBLE,
	GO_WIDTH,
	GO_DE,
	GO_COLOR,
	GO_NO_COLOR,
	GO_CT_CODE,
	GO_OLD_SPINY,
	GO_CRS1,
	GO_CHDIR,
	GO_RAW,
	GO_BMG_INF_SIZE,
	GO_FORCE_ATTRIB,
	GO_DEF_ATTRIB,
	GO_NO_ATTRIB,
	GO_X_ESCAPES,
	GO_OLD_ESCAPES,
	GO_NO_BMG_COLORS,
	GO_BMG_COLORS,
	GO_NO_BMG_INLINE,
	GO_BMG_INLINE,
	GO_NO_ECHO,
	GO_UTF_8,
	GO_NO_UTF_8,
	GO_FORCE,
	GO_OLD,
	GO_NEW,
	GO_EXTRACT,
	GO_LIST,
	GO_REF,
	GO_FULL,
	GO_HEX,
	GO_CT_DIR,
	GO_ALLOW_SLOTS,
	GO_IMAGES,
	GO_LOAD_BMG,
	GO_PATCH_BMG,
	GO_PATCH_NAMES,
	GO_ORDER_BY,
	GO_ORDER_ALL,
	GO_WRITE_TRACKS,
	GO_NUMBER,
	GO_SECTIONS,

} enumGetOpt;

//
///////////////////////////////////////////////////////////////////////////////
///////////////                  external vars                  ///////////////
///////////////////////////////////////////////////////////////////////////////

//extern const InfoOption_t OptionInfo[OPT__N_TOTAL+1];
//extern const KeywordTab_t CommandTab[];
//extern const char OptionShort[];
//extern const struct option OptionLong[];
//extern u8 OptionUsed[OPT__N_TOTAL+1];
//extern const u8 OptionIndex[OPT_INDEX_SIZE];
//extern const InfoCommand_t CommandInfo[CMD__N+1];
extern const InfoUI_t InfoUI_wctct;

//
///////////////////////////////////////////////////////////////////////////////
///////////////                       END                       ///////////////
///////////////////////////////////////////////////////////////////////////////

#endif // SZS_UI_WCTCT_H

