
/***************************************************************************
 *                       _______ _______ _______                           *
 *                      |  ___  |____   |  ___  |                          *
 *                      | |   |_|    / /| |   |_|                          *
 *                      | |_____    / / | |_____                           *
 *                      |_____  |  / /  |_____  |                          *
 *                       _    | | / /    _    | |                          *
 *                      | |___| |/ /____| |___| |                          *
 *                      |_______|_______|_______|                          *
 *                                                                         *
 *                           Wiimms SZS Tools                              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This file is part of the SZS project.                                 *
 *   Visit http://szs.wiimm.de/ for project details and sources.           *
 *                                                                         *
 *   Copyright (c) 2011-2015 by Dirk Clemens <wiimm@wiimm.de>              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   See file gpl-2.0.txt or http://www.gnu.org/licenses/gpl-2.0.txt       *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   >>>  This file is automatically generated by './src/gen-ui.c'.  <<<   *
 *   >>>                   Do not edit this file!                    <<<   *
 *                                                                         *
 ***************************************************************************/

#include <getopt.h>
#include "ui-wimgt.h"

//
///////////////////////////////////////////////////////////////////////////////
///////////////                  OptionInfo[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t OptionInfo[OPT__N_TOTAL+1] =
{
    {0,0,0,0,0,0,0,0}, // OPT_NONE,

    //----- command specific options -----

    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print long numeric message IDs instead of alternative message names"
	" like Txx, Uxx or Mxx."
    },

    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in BMG text files."
    },

    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Create smaller output."
    },

    {	OPT_DEST, false, false, false, true, 'd', "dest",
	"path",
	"Define a destination path (directory/file). The destination - means:"
	" write to standard output.\n"
	"  The path may contain escape sequences: %Q is replaced by the fully"
	" qualified source name. %P and %F are replaced by the source path or"
	" by the filename. %N and %E are replaced by source filename without"
	" extension or by the source extension. Finally, %T is replaced by the"
	" default extension of the destination format.\n"
	"  A '?' direct behind '%' in %E and %T conversions avoid that the"
	" same extension is used twice in row. Read"
	" http://szs.wiimm.de/opt/dest for more details."
    },

    {	OPT_DEST2, false, false, false, false, 'D', "DEST",
	"path",
	"Like --dest, but create the directory path automatically."
    },

    {	OPT_ESC, false, false, false, false, 'E', "esc",
	"char",
	"Define an alternative escape character for destination files. The"
	" default is '%'. For Windows batch files it is a good choice to set"
	" '-E$'."
    },

    {	OPT_OVERWRITE, false, false, false, false, 'o', "overwrite",
	0,
	"Overwrite already existing files without warning and ignore option"
	" --number."
    },

    {	OPT_NUMBER, false, false, false, false, 0, "number",
	0,
	"If a file already exist, append a number directly before the file"
	" extension to make the filename unique. If other numbered files"
	" already exist (ignoring case), use the maximum existing index+1."
	" --num is a short cut."
    },

    {	OPT_REMOVE_DEST, false, false, false, false, 'r', "remove-dest",
	0,
	"Remove already existing files before creating it. If set, --overwrite"
	" is ignored. --rm-dest is a short cut."
    },

    {	OPT_UPDATE, false, false, false, false, 'u', "update",
	0,
	"Create only files that do not exist. Already existing files are"
	" ignored without warning. If set, --overwrite and --remove-dest are"
	" ignored."
    },

    {	OPT_PRESERVE, false, false, false, false, 'p', "preserve",
	0,
	"Preserve file times (atime+mtime) while converting or copying files."
    },

    {	OPT_IGNORE, false, false, false, false, 'i', "ignore",
	0,
	"Ignore non existing source files without warning."
    },

    {	OPT_ALL, false, false, false, false, 'a', "all",
	0,
	"Convert all files and not only the files with changed file or image"
	" formats."
    },

    {	OPT_N_MIPMAPS, false, false, false, false, 0, "n-mipmaps",
	"num",
	"Force the number of mipmaps. Values between 0 and 20 are allowed."
	" Value AUTO (default) enabless automatic detection. The creation of"
	" mipmaps stops if the witdh or the height of the mipmap becomes 0."
	" --n-mm is a short cut."
    },

    {	OPT_MIPMAP_SIZE, false, false, false, false, 0, "mipmap-size",
	"num",
	"Define the minimal width and minimal height of a generated mipmap."
	" The default is 16. Tools before v1.49 used 1 as not alterable value."
	" --mm-size is a short cut."
    },

    {	OPT_MIPMAPS, false, false, false, false, 0, "mipmaps",
	0,
	"If reading a source, scan for mipmaps and load them too. For PNG"
	" files, files named NAME.mm#.EXT with #=1.. are searched. This is the"
	" default."
    },

    {	OPT_NO_MIPMAPS, false, false, false, false, 0, "no-mipmaps",
	0,
	"If reading a source, ignore mipmaps. This disables not the creation"
	" of mipmaps (see -n-mipmaps). --no-mm is a short cut."
    },

    {	OPT_SMART, false, false, false, false, 0, "smart",
	0,
	"If resizing an image, use the new smart resize function. The new"
	" function is much slower (factor 2-4) than the old function, but"
	" creates much better resized images. This is only relevant for"
	" creating mipmaps with odd width or height."
    },

    {	OPT_PRE_CONVERT, false, false, false, false, 0, "pre-convert",
	0,
	"Convert the image before the image format for the destination file is"
	" selected. This results in a perhaps worser graphic and is only"
	" useful to control graphic conversions."
    },

    {	OPT_PATCH, false, false, false, true, 'P', "patch",
	"mode1.mode2...=file",
	"This option specifies patch mode list and a file, separated by an"
	" equal sign. Mode is a point separated list of the keywords: TOP (T),"
	" BOTTOM (B), VCENTER (V), INS-TOP (IT) and INS-BOTTOM (IB) for the"
	" vertical alignment, LEFT (L), RIGHT (R), HCENTER (H), INS-LEFT (IL)"
	" and INS-RIGHT (IR) for the horizontal alignment, COPY (CP),"
	" BACKGROUND (BG), FOREGROUND (FG) and MIX (MX) as color calculation"
	" mode and SHRINK (SH), GROW (GR) and LEAVE (LV) as image size mode.\n"
	"  Abbreviations are allowed. The default is VCENTER.HCENTER.MIX.LEAVE"
	" or in short form V.H.MX.LV. If this option is used multiple times"
	" all patch files will be used in the entered order."
    },

    {	OPT_TRANSFORM, false, false, false, true, 'x', "transform",
	"list",
	"Convert image formats when reading. A comma separated list with terms"
	" is expected. A term have the syntax '[SRC=]DEST'. It means: convert"
	" SRC format into DEST format. If SRC= is not set, the destination"
	" format is used for all source formats. This makes only sense as last"
	" rule. If DEST is empty no transformation is done for the source."
	" Examples: 'TPL' or 'GRAY' or 'BTI.IA8' or 'TPL.I4+I8=IA8,TEX=,CMPR'\n"
	"  SRC and DEST are tupel of file, image and palette formats and of 2"
	" more attributes. All parts are optional and separated by points, the"
	" order is irrelevant.\n"
	"  Allowed file formats are: TPL, TEX, BTI, BREFT-IMG (=BTIMG), PNG"
	" (import). Allowed image formats are: I4, I8, IA4, IA8, RGB565"
	" (=R565), RGB5A3 (=R3), RGBA32 (=R32), C4, C8, C14X2, CMPR. Allowed"
	" palette formats are: P-IA8 (=P8), P-RGB565 (=P565), P-RGB5A3 (=P3)."
	" Attributtes are PALETTE, NO-PALETTE, GRAY, COLOR, ALPHA and"
	" NO-ALPHA.\n"
	"  All terms are managed as list. For each graphic the list is"
	" iterated until the first SRC tupel of a term matches the graphic."
	" Then the destination tupel is used for the transformation.\n"
	"  The command 'wimgt TEST' prints a clearly arranged readable table"
	" as result of this option."
    },

    {	OPT_SECTIONS, false, false, false, true, 0, "sections",
	0,
	"Print in machine readable sections and parameter lines."
    },

    {0,0,0,0,0,0,0,0}, // OPT__N_SPECIFIC == 23

    //----- global options -----

    {	OPT_VERSION, false, false, false, false, 'V', "version",
	0,
	"Stop parsing the command line, print a version info and exit."
    },

    {	OPT_HELP, false, false, false, false, 'h', "help",
	0,
	"Stop parsing the command line, print a help message and exit."
    },

    {	OPT_XHELP, false, false, false, false, 0, "xhelp",
	0,
	"Stop parsing the command line and print a help message with all"
	" commands included. Exit after printing."
    },

    {	OPT_ALLOW_ALL, false, false, false, false, 0, "allow-all",
	0,
	"Usually commands accept only options with impact to the command. All"
	" other options fire a syntax error. But if --allow-all is set, all"
	" commands accept all options.\n"
	"  This makes changing the command of a long command line without"
	" removing useless options easier. It also helps to override wrong"
	" option permissions."
    },

    {	OPT_COMPATIBLE, false, false, false, false, 0, "compatible",
	"vers",
	"The option expects a version number (format '#.##' or 'v#.##') or a"
	" revision number (format 'r#') as parameter. If set, the tools try to"
	" create BMG and KMP text files, that are compatible to the entered"
	" version of the tools. This may override other legacy options."
    },

    {	OPT_WIDTH, false, false, true, false, 0, "width",
	"width",
	"Define the width (number of columns) for help and some other messages"
	" and disable the automatic detection of the terminal width."
    },

    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Be quiet and print only error messages. Multiple usage is possible."
	" The impact is command dependent."
    },

    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Be verbose and print more progress information. Multiple usage is"
	" possible. The impact is command dependent."
    },

    {	OPT_DE, false, false, false, false, 0, "de",
	0,
	"Use german track and arena names."
    },

    {	OPT_COLOR, false, false, true, false, 0, "color",
	0,
	"Force colorized text. This is the default, if an output file is a"
	" terminal. But colorized text is only supported for a few messages.\n"
	"  If a command is prefixed by 'C-', then this option is set"
	" automatically."
    },

    {	OPT_NO_COLOR, false, false, true, false, 0, "no-color",
	0,
	"Deactive colorized text. This is the default, if an output file is"
	" not a terminal."
    },

    {	OPT_CT_CODE, false, false, false, false, 0, "ct-code",
	0,
	"Enable the CT-CODE modus. See http://szs.wiimm.de/opt/ctcode for"
	" details."
    },

    {	OPT_CHDIR, false, false, false, false, 0, "chdir",
	"dir",
	"Set a new working directory for all following options, for all"
	" parameters and for the command execution. This option can be used"
	" multiple times, but for parameter parsing and for command execution"
	" only the last usage is relevant. Nevertheless, '@param' values are"
	" scanned while reading the command line."
    },

    {	OPT_CONST, false, false, false, false, 'c', "const",
	"list",
	"Define constant values, that are used by the internal encoders and by"
	" the numeric options as predefined global variables. This option"
	" allows a conditional encoding of text files. It can be used multiple"
	" times for multiple definitions.\n"
	"  The Parameter is a comma separated list of terms and a term is"
	" 'name=expression'. The expression is calculated by the text parser."
    },

    {	OPT_MAX_FILE_SIZE, false, false, false, false, 'M', "max-file-size",
	"size",
	"This security option defines the maximum file size for input files;"
	" larger files are ignored with a warning. The default unit is MiB and"
	" the default size is 100 MiB; that should be enough for standard"
	" usage."
    },

    {	OPT_TRACKS, true, false, false, false, 'T', "tracks",
	"tracks",
	"Define a new track order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are track names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned track. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Tracks will only be exchanged so that always all tracks are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_ARENAS, true, false, false, false, 'A', "arenas",
	"arenas",
	"Define a new arena order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are arena names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned arena. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Arenas will only be exchanged so that always all arenas are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_UTF_8, true, false, false, true, 0, "utf-8",
	0,
	"Enables UTF-8 support for filenames (default)."
    },

    {	OPT_NO_UTF_8, true, false, false, false, 0, "no-utf-8",
	0,
	"Disables UTF-8 support for filenames."
    },

    {	OPT_TEST, false, false, false, true, 't', "test",
	0,
	"Run in test mode, modify nothing.\n"
	">>> USE THIS OPTION IF UNSURE! <<<"
    },

    {	OPT_FORCE, false, false, false, false, 0, "force",
	0,
	"The tools analyse input files and reject files with invalid data"
	" structures. If --force is set, little repairable issues are ignored"
	" and a warning is printed.\n"
	"Option '--kmp force' does the same, but only for KMP files.\n"
	">>> THE RESULT MAY BE INVALID OUTPUT FILES! <<<"
    },

    {	OPT_OLD, true, false, false, false, 0, "OLD",
	0,
	"Use old implemenation if available."
    },

    {	OPT_NEW, true, false, false, false, 0, "NEW",
	0,
	"Use new implemenation if available."
    },

    {	OPT_EXTRACT, true, false, false, false, 0, "EXTRACT",
	0,
	"Create the directory and extract different objects in different"
	" formats at the moment when they are seen. This is a development"
	" helper option."
    },

    {0,0,0,0,0,0,0,0} // OPT__N_TOTAL == 47

};

//
///////////////////////////////////////////////////////////////////////////////
///////////////             alternate option infos              ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t option_cmd_VERSION_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print only the version number, revision and system. If set twice,"
	" print only the version number."
    };

static const InfoOption_t option_cmd_VERSION_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print in long format. Ignored if option --sections is set."
    };

static const InfoOption_t option_cmd_COLORS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print also a list of all colored text types."
    };

static const InfoOption_t option_cmd_ERROR_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print a message text instead of a message name."
    };

static const InfoOption_t option_cmd_FILETYPE_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print an additional column with the decompressed file type and"
	" version. If entered twice, a validation status column is added."
    };

static const InfoOption_t option_cmd_LIST_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set, geometry data of the image is printed. If set twice, advanced"
	" geometry data is printed."
    };

static const InfoOption_t option_cmd_ENCODE_ALL =
    {	OPT_ALL, false, false, false, false, 'a', "all",
	0,
	"If source and destination file are the same, the file is only written"
	" on modifications (transform, patch, ...). If --all is set, then the"
	" file is always written."
    };


//
///////////////////////////////////////////////////////////////////////////////
///////////////                  CommandTab[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const KeywordTab_t CommandTab[] =
{
    { CMD_VERSION,	"VERSION",	0,		0 },
    { CMD_HELP,		"HELP",		"H",		0 },
    { CMD_HELP,		"?",		0,		0 },
    { CMD_ARGTEST,	"ARGTEST",	0,		0 },
    { CMD_TEST,		"TEST",		0,		0 },
    { CMD_COLORS,	"COLORS",	0,		0 },
    { CMD_ERROR,	"ERROR",	"ERR",		0 },
    { CMD_FILETYPE,	"FILETYPE",	"FT",		0 },
    { CMD_FILEATTRIB,	"FILEATTRIB",	"FA",		0 },
    { CMD_LIST,		"LIST",		"LS",		0 },
    { CMD_LIST_L,	"LIST-L",	"LL",		0 },
    { CMD_LIST_L,	"LISTL",	0,		0 },
    { CMD_LIST_LL,	"LIST-LL",	"LLL",		0 },
    { CMD_LIST_LL,	"LISTLL",	0,		0 },
    { CMD_DECODE,	"DECODE",	"DEC",		0 },
    { CMD_ENCODE,	"ENCODE",	"ENC",		0 },
    { CMD_CONVERT,	"CONVERT",	"CV",		0 },
    { CMD_COPY,		"COPY",		"CP",		0 },

    { CMD__N,0,0,0 }
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionShort & OptionLong             ///////////////
///////////////////////////////////////////////////////////////////////////////

static const char OptionShort[] = "Vhqvc:lHBM:T:A:td:D:E:orupiaP:x:";

static const struct option OptionLong[] =
{
	{ "version",		0, 0, 'V' },
	{ "help",		0, 0, 'h' },
	{ "xhelp",		0, 0, GO_XHELP },
	{ "allow-all",		0, 0, GO_ALLOW_ALL },
	 { "allowall",		0, 0, GO_ALLOW_ALL },
	{ "compatible",		1, 0, GO_COMPATIBLE },
	{ "width",		1, 0, GO_WIDTH },
	{ "quiet",		0, 0, 'q' },
	{ "verbose",		0, 0, 'v' },
	{ "de",			0, 0, GO_DE },
	{ "color",		0, 0, GO_COLOR },
	{ "no-color",		0, 0, GO_NO_COLOR },
	 { "nocolor",		0, 0, GO_NO_COLOR },
	{ "ct-code",		0, 0, GO_CT_CODE },
	 { "ctcode",		0, 0, GO_CT_CODE },
	{ "chdir",		1, 0, GO_CHDIR },
	{ "const",		1, 0, 'c' },
	{ "long",		0, 0, 'l' },
	{ "no-header",		0, 0, 'H' },
	 { "noheader",		0, 0, 'H' },
	{ "brief",		0, 0, 'B' },
	{ "max-file-size",	1, 0, 'M' },
	 { "maxfilesize",	1, 0, 'M' },
	{ "tracks",		1, 0, 'T' },
	{ "arenas",		1, 0, 'A' },
	{ "utf-8",		0, 0, GO_UTF_8 },
	 { "utf8",		0, 0, GO_UTF_8 },
	{ "no-utf-8",		0, 0, GO_NO_UTF_8 },
	 { "no-utf8",		0, 0, GO_NO_UTF_8 },
	 { "noutf8",		0, 0, GO_NO_UTF_8 },
	{ "test",		0, 0, 't' },
	{ "force",		0, 0, GO_FORCE },
	{ "OLD",		0, 0, GO_OLD },
	{ "NEW",		0, 0, GO_NEW },
	{ "EXTRACT",		0, 0, GO_EXTRACT },
	{ "dest",		1, 0, 'd' },
	{ "DEST",		1, 0, 'D' },
	{ "esc",		1, 0, 'E' },
	{ "overwrite",		0, 0, 'o' },
	{ "number",		0, 0, GO_NUMBER },
	 { "num",		0, 0, GO_NUMBER },
	{ "remove-dest",	0, 0, 'r' },
	 { "removedest",	0, 0, 'r' },
	 { "rm-dest",		0, 0, 'r' },
	 { "rmdest",		0, 0, 'r' },
	 { "remove",		0, 0, 'r' },
	{ "update",		0, 0, 'u' },
	{ "preserve",		0, 0, 'p' },
	{ "ignore",		0, 0, 'i' },
	{ "all",		0, 0, 'a' },
	{ "n-mipmaps",		1, 0, GO_N_MIPMAPS },
	 { "nmipmaps",		1, 0, GO_N_MIPMAPS },
	 { "n-mm",		1, 0, GO_N_MIPMAPS },
	 { "nmm",		1, 0, GO_N_MIPMAPS },
	{ "mipmap-size",	1, 0, GO_MIPMAP_SIZE },
	 { "mipmap-size",	1, 0, GO_MIPMAP_SIZE },
	 { "mm-size",		1, 0, GO_MIPMAP_SIZE },
	 { "mm-size",		1, 0, GO_MIPMAP_SIZE },
	{ "mipmaps",		0, 0, GO_MIPMAPS },
	{ "no-mipmaps",		0, 0, GO_NO_MIPMAPS },
	 { "nomipmaps",		0, 0, GO_NO_MIPMAPS },
	 { "no-mm",		0, 0, GO_NO_MIPMAPS },
	 { "nomm",		0, 0, GO_NO_MIPMAPS },
	{ "smart",		0, 0, GO_SMART },
	{ "pre-convert",	0, 0, GO_PRE_CONVERT },
	 { "preconvert",	0, 0, GO_PRE_CONVERT },
	{ "patch",		1, 0, 'P' },
	{ "transform",		1, 0, 'x' },
	{ "sections",		0, 0, GO_SECTIONS },

	{0,0,0,0}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionUsed & OptionIndex             ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 OptionUsed[OPT__N_TOTAL+1] = {0};

static const u8 OptionIndex[OPT_INDEX_SIZE] = 
{
	/* 0x00   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x10   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x20   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x30   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x40   */	 0,
	/* 0x41 A */	OPT_ARENAS,
	/* 0x42 B */	OPT_BRIEF,
	/* 0x43   */	 0,
	/* 0x44 D */	OPT_DEST2,
	/* 0x45 E */	OPT_ESC,
	/* 0x46   */	 0,0,
	/* 0x48 H */	OPT_NO_HEADER,
	/* 0x49   */	 0,0,0,0, 
	/* 0x4d M */	OPT_MAX_FILE_SIZE,
	/* 0x4e   */	 0,0,
	/* 0x50 P */	OPT_PATCH,
	/* 0x51   */	 0,0,0,
	/* 0x54 T */	OPT_TRACKS,
	/* 0x55   */	 0,
	/* 0x56 V */	OPT_VERSION,
	/* 0x57   */	 0,0,0,0, 0,0,0,0, 0,0,
	/* 0x61 a */	OPT_ALL,
	/* 0x62   */	 0,
	/* 0x63 c */	OPT_CONST,
	/* 0x64 d */	OPT_DEST,
	/* 0x65   */	 0,0,0,
	/* 0x68 h */	OPT_HELP,
	/* 0x69 i */	OPT_IGNORE,
	/* 0x6a   */	 0,0,
	/* 0x6c l */	OPT_LONG,
	/* 0x6d   */	 0,0,
	/* 0x6f o */	OPT_OVERWRITE,
	/* 0x70 p */	OPT_PRESERVE,
	/* 0x71 q */	OPT_QUIET,
	/* 0x72 r */	OPT_REMOVE_DEST,
	/* 0x73   */	 0,
	/* 0x74 t */	OPT_TEST,
	/* 0x75 u */	OPT_UPDATE,
	/* 0x76 v */	OPT_VERBOSE,
	/* 0x77   */	 0,
	/* 0x78 x */	OPT_TRANSFORM,
	/* 0x79   */	 0,0,0,0, 0,0,0,
	/* 0x80   */	OPT_XHELP,
	/* 0x81   */	OPT_ALLOW_ALL,
	/* 0x82   */	OPT_COMPATIBLE,
	/* 0x83   */	OPT_WIDTH,
	/* 0x84   */	OPT_DE,
	/* 0x85   */	OPT_COLOR,
	/* 0x86   */	OPT_NO_COLOR,
	/* 0x87   */	OPT_CT_CODE,
	/* 0x88   */	OPT_CHDIR,
	/* 0x89   */	OPT_UTF_8,
	/* 0x8a   */	OPT_NO_UTF_8,
	/* 0x8b   */	OPT_FORCE,
	/* 0x8c   */	OPT_OLD,
	/* 0x8d   */	OPT_NEW,
	/* 0x8e   */	OPT_EXTRACT,
	/* 0x8f   */	OPT_NUMBER,
	/* 0x90   */	OPT_N_MIPMAPS,
	/* 0x91   */	OPT_MIPMAP_SIZE,
	/* 0x92   */	OPT_MIPMAPS,
	/* 0x93   */	OPT_NO_MIPMAPS,
	/* 0x94   */	OPT_SMART,
	/* 0x95   */	OPT_PRE_CONVERT,
	/* 0x96   */	OPT_SECTIONS,
	/* 0x97   */	 0,0,0,0, 0,0,0,0, 0,
	/* 0xa0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xb0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xc0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xd0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xe0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xf0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                opt_allowed_cmd_*                ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 option_allowed_cmd_VERSION[23] = // cmd #1
{
    0,1,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,1
};

static u8 option_allowed_cmd_HELP[23] = // cmd #2
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1
};

static u8 option_allowed_cmd_ARGTEST[23] = // cmd #3
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1
};

static u8 option_allowed_cmd_TEST[23] = // cmd #4
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1
};

static u8 option_allowed_cmd_COLORS[23] = // cmd #5
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_ERROR[23] = // cmd #6
{
    0,1,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,1
};

static u8 option_allowed_cmd_FILETYPE[23] = // cmd #7
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_FILEATTRIB[23] = // cmd #8
{
    0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_LIST[23] = // cmd #9
{
    0,1,1,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_LIST_L[23] = // cmd #10
{
    0,1,1,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_LIST_LL[23] = // cmd #11
{
    0,1,1,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_DECODE[23] = // cmd #12
{
    0,0,0,0,1, 1,1,1,1,1,  1,1,1,0,1, 1,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_ENCODE[23] = // cmd #13
{
    0,0,0,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_CONVERT[23] = // cmd #14
{
    0,0,0,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_COPY[23] = // cmd #15
{
    0,0,0,0,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                 InfoOption tabs                 ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t * option_tab_tool[] =
{
	OptionInfo + OPT_VERSION,
	OptionInfo + OPT_HELP,
	OptionInfo + OPT_XHELP,
	OptionInfo + OPT_ALLOW_ALL,
	OptionInfo + OPT_COMPATIBLE,
	OptionInfo + OPT_WIDTH,
	OptionInfo + OPT_QUIET,
	OptionInfo + OPT_VERBOSE,
	OptionInfo + OPT_DE,
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	OptionInfo + OPT_CT_CODE,
	OptionInfo + OPT_CHDIR,
	OptionInfo + OPT_CONST,
	OptionInfo + OPT_MAX_FILE_SIZE,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TEST,
	OptionInfo + OPT_FORCE,

	0
};

static const InfoOption_t * option_tab_cmd_VERSION[] =
{
	&option_cmd_VERSION_BRIEF,
	OptionInfo + OPT_SECTIONS,
	&option_cmd_VERSION_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_HELP[] =
{
	OptionInfo + OPT_WIDTH,

	0
};

static const InfoOption_t * option_tab_cmd_ARGTEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_TEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_COLORS[] =
{
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	&option_cmd_COLORS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_ERROR[] =
{
	OptionInfo + OPT_SECTIONS,
	OptionInfo + OPT_NO_HEADER,
	&option_cmd_ERROR_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_FILETYPE[] =
{
	&option_cmd_FILETYPE_LONG,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_FILEATTRIB[] =
{
	OptionInfo + OPT_NO_HEADER,

	0
};

static const InfoOption_t * option_tab_cmd_LIST[] =
{
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_L[] =
{
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_LL[] =
{
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_DECODE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_PRE_CONVERT,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PATCH,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_TRANSFORM,

	0
};

static const InfoOption_t * option_tab_cmd_ENCODE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_IGNORE,
	&option_cmd_ENCODE_ALL,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_PRE_CONVERT,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PATCH,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_TRANSFORM,

	0
};

static const InfoOption_t * option_tab_cmd_CONVERT[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_IGNORE,
	&option_cmd_ENCODE_ALL,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_PRE_CONVERT,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PATCH,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_TRANSFORM,

	0
};

static const InfoOption_t * option_tab_cmd_COPY[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_IGNORE,
	&option_cmd_ENCODE_ALL,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_PRE_CONVERT,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PATCH,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_TRANSFORM,

	0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                   InfoCommand                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoCommand_t CommandInfo[CMD__N+1] =
{
    {	0,
	false,
	false,
	false,
	"wimgt",
	0,
	"wimgt [option]... command [option|parameter|file]...",
	"Wiimms Image Tool : Extract and convert graphic images. The file"
	" formats TPL, TEX, BTI, BREFT and PNG are supported.",
	0,
	17,
	option_tab_tool,
	0
    },

    {	CMD_VERSION,
	false,
	false,
	false,
	"VERSION",
	0,
	"wimgt VERSION [ignored]...",
	"Print program name and version and exit.",
	0,
	3,
	option_tab_cmd_VERSION,
	option_allowed_cmd_VERSION
    },

    {	CMD_HELP,
	false,
	false,
	false,
	"HELP",
	"H",
	"wimgt HELP [--width=wd] OPT|OPTION ...\n"
	"wimgt HELP [--width=wd] CMD|COMMAND [ignored]...\n"
	"wimgt HELP [--width=wd] command [-b] [ignored]...\n"
	"wimgt HELP [--width=wd] [ignored]...",
	"Print help for commands and options.",
	"Print help for commands and options.\n"
	"  The first variant (with keyword OPT or OPTION) prints a list of all"
	" global and command specific options. If at least one option is set,"
	" only infos about the declared options are printed. The second"
	" variant (with keyword CMD or COMMAND) prints an overview about all"
	" commands. The third variant (with a valid command name) prints"
	" details about the declared command. The fourth variant prints an"
	" overview about all commands and all global options.",
	1,
	option_tab_cmd_HELP,
	option_allowed_cmd_HELP
    },

    {	CMD_ARGTEST,
	false,
	false,
	false,
	"ARGTEST",
	0,
	"wimgt ARGTEST ...",
	"This debug command accepts all kinds of parameters and prints one"
	" line for each parameter.",
	0,
	0,
	option_tab_cmd_ARGTEST,
	option_allowed_cmd_ARGTEST
    },

    {	CMD_TEST,
	false,
	false,
	false,
	"TEST",
	0,
	"wimgt TEST [options]... [ignored]...",
	"This debugging command accepts all options and parameters and prints"
	" a list of the internal option values. The command is designed to"
	" test the option parameters. The non option parameters are completly"
	" ignored.",
	0,
	0,
	option_tab_cmd_TEST,
	option_allowed_cmd_TEST
    },

    {	CMD_COLORS,
	false,
	false,
	false,
	"COLORS",
	0,
	"wimgt COLORS",
	"Ignore all parameters and print clored text for testing.",
	0,
	3,
	option_tab_cmd_COLORS,
	option_allowed_cmd_COLORS
    },

    {	CMD_ERROR,
	false,
	false,
	false,
	"ERROR",
	"ERR",
	"wimgt ERROR [error_code]",
	"Translate an exit code to a message name. If no exit code is entered,"
	" print a table with all error messages.",
	0,
	3,
	option_tab_cmd_ERROR,
	option_allowed_cmd_ERROR
    },

    {	CMD_FILETYPE,
	false,
	false,
	false,
	"FILETYPE",
	"FT",
	"wimgt FILETYPE file...",
	"Scan the header of the entered files and print file type and path for"
	" each file as list.",
	0,
	2,
	option_tab_cmd_FILETYPE,
	option_allowed_cmd_FILETYPE
    },

    {	CMD_FILEATTRIB,
	false,
	false,
	false,
	"FILEATTRIB",
	"FA",
	"wimgt FILEATTRIB [keyword]...",
	"Print a table with attributes for all known file types. If at least"
	" one keyword is entered, only matching file types are printed. A"
	" keyword is either a file type (like 'BRRES' or 'BMG') or one of the"
	" printed keywords (like 'ARCHIVE' or 'EXTRACT').",
	0,
	1,
	option_tab_cmd_FILEATTRIB,
	option_allowed_cmd_FILEATTRIB
    },

    {	CMD_LIST,
	false,
	false,
	true,
	"LIST",
	"LS",
	"wimgt LIST [source]...",
	"List images files and print file and image type.",
	0,
	3,
	option_tab_cmd_LIST,
	option_allowed_cmd_LIST
    },

    {	CMD_LIST_L,
	false,
	false,
	false,
	"LIST-L",
	"LL",
	"wit LIST-L [source]...",
	"List images files and print file and image type and geometry data."
	" 'LIST-L' is a short cut for 'LIST --long'.",
	0,
	3,
	option_tab_cmd_LIST_L,
	option_allowed_cmd_LIST_L
    },

    {	CMD_LIST_LL,
	false,
	false,
	false,
	"LIST-LL",
	"LLL",
	"wit LIST-LL [source]...",
	"List images files and print file and image type and advanced geometry"
	" data. 'LIST-LL' is a short cut for 'LIST --long --long'.",
	0,
	3,
	option_tab_cmd_LIST_LL,
	option_allowed_cmd_LIST_LL
    },

    {	CMD_DECODE,
	false,
	false,
	true,
	"DECODE",
	"DEC",
	"wimgt DECODE [source]...",
	"Decode (export) the entered image files into PNG files. The default"
	" destination is '%P/%F.png'.",
	0,
	17,
	option_tab_cmd_DECODE,
	option_allowed_cmd_DECODE
    },

    {	CMD_ENCODE,
	false,
	false,
	false,
	"ENCODE",
	"ENC",
	"wimgt ENCODE [source]...",
	"Encode (import) the entered PNG files and convert them to to an"
	" internal image format (TPL, TEX, BREFT). The default destination is"
	" '%P/%N' (removed extension).",
	0,
	18,
	option_tab_cmd_ENCODE,
	option_allowed_cmd_ENCODE
    },

    {	CMD_CONVERT,
	false,
	false,
	false,
	"CONVERT",
	"CV",
	"wimgt CONVERT [source]...",
	"Convert the entered image files into new file and image formats. The"
	" old file is replaced by the new one. The difference to ENCODE is"
	" only the default file name handling.",
	0,
	18,
	option_tab_cmd_CONVERT,
	option_allowed_cmd_CONVERT
    },

    {	CMD_COPY,
	false,
	false,
	false,
	"COPY",
	"CP",
	"wimgt COPY source dest\n"
	"wimgt COPY source... [-d|-D] dest",
	"Copy and convert an image from 'source' to 'dest'. Multiple sources"
	" can be used, if 'dest' is a directory or contains at least one"
	" %-pattern.\n"
	"  This is an alternative for the ENCODE and DECODE commands. The"
	" default destination file format is selected by scanning the file"
	" extension of the destination. Option --transform may override this.",
	0,
	18,
	option_tab_cmd_COPY,
	option_allowed_cmd_COPY
    },

    {0,0,0,0,0,0,0,0,0,00,}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                     InfoUI                      ///////////////
///////////////////////////////////////////////////////////////////////////////

const InfoUI_t InfoUI_wimgt =
{
	"wimgt",
	CMD__N,
	CommandTab,
	CommandInfo,
	OPT__N_SPECIFIC,
	OPT__N_TOTAL,
	OptionInfo,
	OptionUsed,
	OptionIndex,
	OptionShort,
	OptionLong
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                       END                       ///////////////
///////////////////////////////////////////////////////////////////////////////

