
/***************************************************************************
 *                       _______ _______ _______                           *
 *                      |  ___  |____   |  ___  |                          *
 *                      | |   |_|    / /| |   |_|                          *
 *                      | |_____    / / | |_____                           *
 *                      |_____  |  / /  |_____  |                          *
 *                       _    | | / /    _    | |                          *
 *                      | |___| |/ /____| |___| |                          *
 *                      |_______|_______|_______|                          *
 *                                                                         *
 *                           Wiimms SZS Tools                              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This file is part of the SZS project.                                 *
 *   Visit http://szs.wiimm.de/ for project details and sources.           *
 *                                                                         *
 *   Copyright (c) 2011-2015 by Dirk Clemens <wiimm@wiimm.de>              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   See file gpl-2.0.txt or http://www.gnu.org/licenses/gpl-2.0.txt       *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   >>>  This file is automatically generated by './src/gen-ui.c'.  <<<   *
 *   >>>                   Do not edit this file!                    <<<   *
 *                                                                         *
 ***************************************************************************/

#include <getopt.h>
#include "ui-wstrt.h"

//
///////////////////////////////////////////////////////////////////////////////
///////////////                  OptionInfo[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t OptionInfo[OPT__N_TOTAL+1] =
{
    {0,0,0,0,0,0,0,0}, // OPT_NONE,

    //----- command specific options -----

    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print long numeric message IDs instead of alternative message names"
	" like Txx, Uxx or Mxx."
    },

    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"List only the track file names and suppress table header and footer."
    },

    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in BMG text files."
    },

    {	OPT_CHEAT, true, false, false, false, 0, "cheat",
	"region",
	"Change the output format and create a cheat code for the region."
	" Allowed keywords: JAPAN; AMERICA, NTSC; EUROPE, AUSTRALIA, PAL;"
	" KOREA."
    },

    {	OPT_DEST, false, false, false, true, 'd', "dest",
	"path",
	"Define a destination path (directory/file). The destination - means:"
	" write to standard output.\n"
	"  The path may contain escape sequences: %Q is replaced by the fully"
	" qualified source name. %P and %F are replaced by the source path or"
	" by the filename. %N and %E are replaced by source filename without"
	" extension or by the source extension. Finally, %T is replaced by the"
	" default extension of the destination format.\n"
	"  A '?' direct behind '%' in %E and %T conversions avoid that the"
	" same extension is used twice in row. Read"
	" http://szs.wiimm.de/opt/dest for more details."
    },

    {	OPT_DEST2, false, false, false, false, 'D', "DEST",
	"path",
	"Like --dest, but create the directory path automatically."
    },

    {	OPT_ESC, false, false, false, false, 'E', "esc",
	"char",
	"Define an alternative escape character for destination files. The"
	" default is '%'. For Windows batch files it is a good choice to set"
	" '-E$'."
    },

    {	OPT_OVERWRITE, false, false, false, false, 'o', "overwrite",
	0,
	"Overwrite already existing files without warning and ignore option"
	" --number."
    },

    {	OPT_NUMBER, false, false, false, false, 0, "number",
	0,
	"If a file already exist, append a number directly before the file"
	" extension to make the filename unique. If other numbered files"
	" already exist (ignoring case), use the maximum existing index+1."
	" --num is a short cut."
    },

    {	OPT_REMOVE_DEST, false, false, false, false, 'r', "remove-dest",
	0,
	"Remove already existing files before creating it. If set, --overwrite"
	" is ignored. --rm-dest is a short cut."
    },

    {	OPT_UPDATE, false, false, false, false, 'u', "update",
	0,
	"Create only files that do not exist. Already existing files are"
	" ignored without warning. If set, --overwrite and --remove-dest are"
	" ignored."
    },

    {	OPT_PRESERVE, false, false, false, false, 'p', "preserve",
	0,
	"Preserve file times (atime+mtime) while converting or copying files."
    },

    {	OPT_IGNORE, false, false, false, false, 'i', "ignore",
	0,
	"Ignore non existing source files without warning."
    },

    {	OPT_ADD_CTCODE, false, false, false, false, 0, "add-ctcode",
	0,
	"If source is an original main.dol file of MKWii, then append 2"
	" sections (usually T2 and D8) with CT-CODE. The CTCODE is inserted"
	" after sections defined by --add-section and then only, if there are"
	" no address collisions.\n"
	"  If --ct-dir is used, then files named rmc[ejp]/boot_code.bin and"
	" boot_code.bin for T2, and rmc[ejp]/boot_data.bin and boot_data.bin"
	" for D8 are searched."
    },

    {	OPT_MOVE_D8, true, false, false, false, 0, "move-d8",
	0,
	"Move the CT-CODE section D8 to another place at the middle of binary."
	" It is done automatically, if the original place overlaps other"
	" existing sections."
    },

    {	OPT_ADD_SECTION, false, false, false, false, 0, "add-section",
	"file",
	"Each option call adds the filename to an internal list. Each file"
	" must be of type GCT, GCH or WCH. All GCT files together are combined"
	" with an internal code handler to one section (like a GCH file). GCH"
	" and WCH define sections and patches. The defined sections are added"
	" and VBI hooks are optionally initialized. Use option --force to"
	" allow overlapped sections. Use option --verbose up to 2 times for a"
	" log.\n"
	"  The intention of this option is to add a Gecko Code Handler and"
	" cheat codes to a main.dol for automatic execution. See"
	" http://szs.wiimm.de/doc/addsect for details."
    },

    {	OPT_FULL_GCH, true, false, false, false, 0, "full-gch",
	0,
	"Use the full 'codehandler' instead of 'codehandleronly'."
    },

    {	OPT_GCT_NO_SEP, true, false, false, false, 0, "gct-no-sep",
	0,
	"Ignore cheat code separators completly and don't filter 'F0000001"
	" 0000xxxx' codes. Options --gct-sep and --gct-asm-sep are ignored"
	" too."
    },

    {	OPT_GCT_SEP, true, false, false, false, 0, "gct-sep",
	0,
	"Detect and remove cheat code separators of format 'F0000001"
	" 0000xxxx'. The separators are used to split the cheat codes into"
	" several blocks if the total size is too large. ASM blocks are"
	" skipped if searching separators."
    },

    {	OPT_GCT_ASM_SEP, true, false, false, false, 0, "gct-asm-sep",
	0,
	"Detect the beginning of ASM blocks and use them as cheat code"
	" separators. The separators are used to split the cheat codes into"
	" several blocks if the total size is too large."
    },

    {	OPT_GCT_LIST, true, false, false, false, 0, "gct-list",
	0,
	"If GCT separators active, print a summary table about the"
	" distribution of the segments. Be more verbose if set twice."
    },

    {	OPT_GCT_MOVE, false, false, false, false, 0, "gct-move",
	0,
	"If a section is of type gecko code handler + cheat code, and the"
	" space for the cheat codes is too small, then make the heap smaller"
	" and move the cheat codes before the FST section. If set twice, move"
	" the cheat codes always."
    },

    {	OPT_GCT_ADDR, false, false, false, false, 0, "gct-addr",
	"address",
	"If --gct-move is active, a text section is created to manage the code"
	" handling. This section is only needed at start and is placed by"
	" default at address 0c802c0000 (good address for all 4 regions) as"
	" part of BSS. This option changes the start address of the section."
	" If address is 0 or invalid, then unused BSS space is searched."
    },

    {	OPT_GCT_SPACE, false, false, false, false, 0, "gct-space",
	"size",
	"Define the minimal space for the code part of --gct-move. This value"
	" is ignored, if it is smaller than the size of the cheat codes. This"
	" option was only implemented to test the  memory allocation by"
	" --gct-move with large blocks."
    },

    {	OPT_CREATE_SECT, true, false, false, false, 0, "create-sect",
	"mode=file",
	"Create a new DOL section by loading the binary file. MODE is a list"
	" of 'P' (parameter support), 'T' or 'D' with optional digit (define"
	" section) and an address (auto if not set). The parts are separated"
	" by spaces or commas.\n"
	"  If MODE is 'P', then 4 32-bit parameters are expected at offset"
	" 0x10: The section address at 0x10 (read), the relative entry point"
	" at 0x14 (read, used if >0), the original DOL entry point at 0x18"
	" (written), the address of the last defined '.dol' section at 0x1c"
	" (written).\n"
	"  If the file name is '.dol', then it points not to a file. Instead a"
	" copy of the DOL header beginning with the section addresses and"
	" ending behind the entry point (156B total) is copied. MODE 'P' is"
	" ignored for this section. All other MODE 'P' sections are updated at"
	" offset 0x1c.\n"
	"  --cs is a short cut."
    },

    {	OPT_WPF, true, false, false, false, 0, "wpf",
	"file",
	"Each option call adds the filename to an internal list. Each file"
	" must be of type WPF (Wiimms Patch File) and defines a list of"
	" conditionals and patches for staticr.rel and main.dol."
    },

    {	OPT_SECTIONS, false, false, false, true, 0, "sections",
	0,
	"Print in machine readable sections and parameter lines."
    },

    {0,0,0,0,0,0,0,0}, // OPT__N_SPECIFIC == 28

    //----- global options -----

    {	OPT_VERSION, false, false, false, false, 'V', "version",
	0,
	"Stop parsing the command line, print a version info and exit."
    },

    {	OPT_HELP, false, false, false, false, 'h', "help",
	0,
	"Stop parsing the command line, print a help message and exit."
    },

    {	OPT_XHELP, false, false, false, false, 0, "xhelp",
	0,
	"Stop parsing the command line and print a help message with all"
	" commands included. Exit after printing."
    },

    {	OPT_ALLOW_ALL, false, false, false, false, 0, "allow-all",
	0,
	"Usually commands accept only options with impact to the command. All"
	" other options fire a syntax error. But if --allow-all is set, all"
	" commands accept all options.\n"
	"  This makes changing the command of a long command line without"
	" removing useless options easier. It also helps to override wrong"
	" option permissions."
    },

    {	OPT_COMPATIBLE, false, false, false, false, 0, "compatible",
	"vers",
	"The option expects a version number (format '#.##' or 'v#.##') or a"
	" revision number (format 'r#') as parameter. If set, the tools try to"
	" create BMG and KMP text files, that are compatible to the entered"
	" version of the tools. This may override other legacy options."
    },

    {	OPT_WIDTH, false, false, true, false, 0, "width",
	"width",
	"Define the width (number of columns) for help and some other messages"
	" and disable the automatic detection of the terminal width."
    },

    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Be quiet and print only error messages. Multiple usage is possible."
	" The impact is command dependent."
    },

    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Be verbose and print more progress information. Multiple usage is"
	" possible. The impact is command dependent."
    },

    {	OPT_DE, false, false, false, false, 0, "de",
	0,
	"Use german track and arena names."
    },

    {	OPT_COLOR, false, false, true, false, 0, "color",
	0,
	"Force colorized text. This is the default, if an output file is a"
	" terminal. But colorized text is only supported for a few messages.\n"
	"  If a command is prefixed by 'C-', then this option is set"
	" automatically."
    },

    {	OPT_NO_COLOR, false, false, true, false, 0, "no-color",
	0,
	"Deactive colorized text. This is the default, if an output file is"
	" not a terminal."
    },

    {	OPT_CT_CODE, false, false, false, false, 0, "ct-code",
	0,
	"Enable the CT-CODE modus. See http://szs.wiimm.de/opt/ctcode for"
	" details."
    },

    {	OPT_CHDIR, false, false, false, false, 0, "chdir",
	"dir",
	"Set a new working directory for all following options, for all"
	" parameters and for the command execution. This option can be used"
	" multiple times, but for parameter parsing and for command execution"
	" only the last usage is relevant. Nevertheless, '@param' values are"
	" scanned while reading the command line."
    },

    {	OPT_CONST, false, false, false, false, 'c', "const",
	"list",
	"Define constant values, that are used by the internal encoders and by"
	" the numeric options as predefined global variables. This option"
	" allows a conditional encoding of text files. It can be used multiple"
	" times for multiple definitions.\n"
	"  The Parameter is a comma separated list of terms and a term is"
	" 'name=expression'. The expression is calculated by the text parser."
    },

    {	OPT_TRACKS, false, false, false, false, 'T', "tracks",
	"tracks",
	"Define a new track order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are track names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned track. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Tracks will only be exchanged so that always all tracks are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_ARENAS, false, false, false, false, 'A', "arenas",
	"arenas",
	"Define a new arena order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are arena names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned arena. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Arenas will only be exchanged so that always all arenas are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_REGION, false, false, false, false, 'R', "region",
	"region",
	"If 'region' is an unsigned number, the region for online versus races"
	" and for battles is patched to the entered number. If the number is"
	" prefixed by the letter 't', a test mode is enabled and the places"
	" are patched with ascending numbers.\n"
	"  Otherwise a keyword is expected. Official regions are: JAPAN(0),"
	" AMERICA(1), EUROPE(2), AUSTRALIA(OCEANIA,3), KOREA(4), TAIWAN(5) and"
	" CHINA(6). RESTORE restores the original Nintendo values and NONE"
	" disables region patching (default).\n"
	"  See http://wiimm.de/r/ctw/Custom_Track_Regions for other regions."
    },

    {	OPT_VS_REGION, false, false, false, false, 0, "vs-region",
	"region",
	"Same as --region, but only for online versus races."
    },

    {	OPT_BT_REGION, false, false, false, false, 0, "bt-region",
	"region",
	"Same as --region, but only for online battles."
    },

    {	OPT_ALL_RANKS, false, false, false, false, 0, "all-ranks",
	"[=mode]",
	"If set to ON (default without parameter), the server query to"
	" Nintendos servers is manipulated, so that the player will find all"
	" players in online races independent of their ranking points. Value"
	" RESTORE disables this feature and restores Nintendos original query."
	" Value NONE disables this kind of patching (default)."
    },

    {	OPT_POINTS, false, false, false, false, 0, "points",
	"list",
	"This patch option defines a new table for the points assigned to"
	" players after a versus or room race. The parameter is a blank or"
	" comma and slash (next row) separated list with numbers (points)"
	" between 0 and 255 and the following keywords: NINTENDO, LINEAR, WIN,"
	" WIN15, WIN25 to select a predefined table; NO-BONUS, BONUS, NULL,"
	" ONE as options; N1..N12 to select the row for N players. See"
	" http://szs.wiimm.de/opt/points for details."
    },

    {	OPT_HTTPS, false, false, false, false, 0, "https",
	"mode",
	"Patch the https strings of REL and DOL files. 'mode' is one of the"
	" following keywords:\n"
	"RESTORE restores the original URLs and domains.\n"
	"HTTP replaces HTTPS requests by HTTP and sub-domain 'naswii.' by"
	" 'nas.'.\n"
	"DOMAIN replace HTTPS requests by HTTP and the domain"
	" 'nintendowifi.net' by a domain specified by option --domain.\n"
	"SAKE0 same as DOMAIN, but don't replace URLs with SAKE domain.\n"
	"SAKE1 same as SAKE0, but replace HTTPS of SAKE domains."
    },

    {	OPT_DOMAIN, false, false, false, false, 0, "domain",
	"dom",
	"Define a domain for option --https. The default is 'wiimmfi.de'."
    },

    {	OPT_WIIMMFI, false, false, false, false, 0, "wiimmfi",
	0,
	"Patch the files for the new custom server. It is a short cut for"
	" '--https domain --domain wiimmfi.de'."
    },

    {	OPT_TWIIMMFI, true, false, false, false, 0, "twiimmfi",
	0,
	"Patch the files for the test server. It is a short cut for '--https"
	" domain --domain test.wiimmfi.de'."
    },

    {	OPT_VS, false, false, false, false, 0, "vs",
	"char",
	"Reset (str is empty) or replace the second character of 'vs' to"
	" create an own online world for versus races. The file StaticR.rel"
	" will be patched at 4 places."
    },

    {	OPT_VS2, true, false, false, false, 0, "vs2",
	"str",
	"Reset (str is empty) or replace the 2 characters of 'vs' to create an"
	" own online world for versus races. If the parameter contains only 1"
	" character, use 'v' as first character. The file StaticR.rel will be"
	" patched at 4 places.\n"
	"  Wiimmfi will only detect 'Versus' if the first letter is 'v' or"
	" 'V'."
    },

    {	OPT_BT, false, false, false, false, 0, "bt",
	"char",
	"Reset (str is empty) or replace the second character of 'bt' to"
	" create an own online world for battles. The file StaticR.rel will be"
	" patched at 4 places."
    },

    {	OPT_BT2, true, false, false, false, 0, "bt2",
	"str",
	"Reset (str is empty) or replace the 2 characters of 'bt' to create an"
	" own online world for battles. If the parameter contains only 1"
	" character, use 'b' as first character. The file StaticR.rel will be"
	" patched at 4 places.\n"
	"  Wiimmfi will only detect 'Battle' if the first letter is 'b' or"
	" 'B'."
    },

    {	OPT_MENO, false, false, false, false, 0, "meno",
	0,
	"Patch some 'MenuSingle' and 'MenuMulti' strings of file StaticR.rel"
	" for online usage to 'MenO*' (MenuOnline) to distinguish between"
	" offline and online races."
    },

    {	OPT_UTF_8, true, false, false, true, 0, "utf-8",
	0,
	"Enables UTF-8 support for filenames (default)."
    },

    {	OPT_NO_UTF_8, true, false, false, false, 0, "no-utf-8",
	0,
	"Disables UTF-8 support for filenames."
    },

    {	OPT_TEST, false, false, false, true, 't', "test",
	0,
	"Run in test mode, modify nothing.\n"
	">>> USE THIS OPTION IF UNSURE! <<<"
    },

    {	OPT_FORCE, false, false, false, false, 0, "force",
	0,
	"The tools analyse input files and reject files with invalid data"
	" structures. If --force is set, little repairable issues are ignored"
	" and a warning is printed.\n"
	"Option '--kmp force' does the same, but only for KMP files.\n"
	">>> THE RESULT MAY BE INVALID OUTPUT FILES! <<<"
    },

    {	OPT_OLD, true, false, false, false, 0, "OLD",
	0,
	"Use old implemenation if available."
    },

    {	OPT_NEW, true, false, false, false, 0, "NEW",
	0,
	"Use new implemenation if available."
    },

    {	OPT_EXTRACT, true, false, false, false, 0, "EXTRACT",
	0,
	"Create the directory and extract different objects in different"
	" formats at the moment when they are seen. This is a development"
	" helper option."
    },

    {	OPT_CT_DIR, false, false, false, false, 0, "ct-dir",
	"dir",
	"Define a search directory for CT-CODE parts and use the internal"
	" copies only, if no valid file is found. Each file is searched"
	" without and then with extension '.bz2'. For both cases bzip2 files"
	" are detected and decompressed. Only files with correct file type are"
	" accepted.\n"
	"  Use this option multiple times to define more than one search"
	" directory."
    },

    {0,0,0,0,0,0,0,0} // OPT__N_TOTAL == 66

};

//
///////////////////////////////////////////////////////////////////////////////
///////////////             alternate option infos              ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t option_cmd_VERSION_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print only the version number, revision and system. If set twice,"
	" print only the version number."
    };

static const InfoOption_t option_cmd_VERSION_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print in long format. Ignored if option --sections is set."
    };

static const InfoOption_t option_cmd_COLORS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print also a list of all colored text types."
    };

static const InfoOption_t option_cmd_ERROR_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print a message text instead of a message name."
    };

static const InfoOption_t option_cmd_FILETYPE_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print an additional column with the decompressed file type and"
	" version. If entered twice, a validation status column is added."
    };

static const InfoOption_t option_cmd_DUMP_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"For DOL files: If set, a second table with the image map is printed."
	" If set twice, a third table with delta values is printed too."
    };

static const InfoOption_t option_cmd_HTTPS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	" Print output a C source"
    };

static const InfoOption_t option_cmd_HTTPS_VERBOSE =
    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	" Print hex dump if an entry differs."
    };

static const InfoOption_t option_cmd_TRACKS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Add columns for music slot and short name."
    };

static const InfoOption_t option_cmd_FIND_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Add a user friendly track or arena name at the end of each line. If"
	" set twice, add also the file names of the track and sound files"
	" before the track name. If set three times, add the slot index and"
	" the internal index (both zero based) before the file names."
    };

static const InfoOption_t option_cmd_POINTS_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print the table as comma separated lists in C notation."
    };

static const InfoOption_t option_cmd_POINTS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Append a string in --points format that defines the table. If set"
	" twice, append up to 3 strings in different modes."
    };

static const InfoOption_t option_cmd_ANALYZE_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print different lists if bugs found. If set twice, print the lists"
	" always."
    };

static const InfoOption_t option_cmd_PATCH_FORCE =
    {	OPT_FORCE, false, false, false, false, 0, "force",
	0,
	"Accept overlapped sections."
    };


//
///////////////////////////////////////////////////////////////////////////////
///////////////                  CommandTab[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const KeywordTab_t CommandTab[] =
{
    { CMD_VERSION,	"VERSION",	0,		0 },
    { CMD_HELP,		"HELP",		"H",		0 },
    { CMD_HELP,		"?",		0,		0 },
    { CMD_ARGTEST,	"ARGTEST",	0,		0 },
    { CMD_TEST,		"TEST",		0,		0 },
    { CMD_COLORS,	"COLORS",	0,		0 },
    { CMD_ERROR,	"ERROR",	"ERR",		0 },
    { CMD_FILETYPE,	"FILETYPE",	"FT",		0 },
    { CMD_FILEATTRIB,	"FILEATTRIB",	"FA",		0 },
    { CMD_RAWDUMP,	"_RAWDUMP",	0,		0 },
    { CMD_DUMP,		"DUMP",		0,		0 },
    { CMD_CDUMP,	"_CDUMP",	0,		0 },
    { CMD_HTTPS,	"_HTTPS",	0,		0 },
    { CMD_EXTRACT,	"EXTRACT",	"X",		0 },
    { CMD_TRACKS,	"TRACKS",	0,		0 },
    { CMD_ARENAS,	"ARENAS",	0,		0 },
    { CMD_FILES,	"FILES",	0,		0 },
    { CMD_FIND,		"FIND",		0,		0 },
    { CMD_POINTS,	"POINTS",	"PTS",		0 },
    { CMD_ANALYZE,	"ANALYZE",	"ANA",		0 },
    { CMD_ANALYZE,	"ANALYSE",	0,		0 },
    { CMD_PATCH,	"PATCH",	0,		0 },

    { CMD__N,0,0,0 }
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionShort & OptionLong             ///////////////
///////////////////////////////////////////////////////////////////////////////

static const char OptionShort[] = "Vhqvc:lBHT:A:R:td:D:E:orupi";

static const struct option OptionLong[] =
{
	{ "version",		0, 0, 'V' },
	{ "help",		0, 0, 'h' },
	{ "xhelp",		0, 0, GO_XHELP },
	{ "allow-all",		0, 0, GO_ALLOW_ALL },
	 { "allowall",		0, 0, GO_ALLOW_ALL },
	{ "compatible",		1, 0, GO_COMPATIBLE },
	{ "width",		1, 0, GO_WIDTH },
	{ "quiet",		0, 0, 'q' },
	{ "verbose",		0, 0, 'v' },
	{ "de",			0, 0, GO_DE },
	{ "color",		0, 0, GO_COLOR },
	{ "no-color",		0, 0, GO_NO_COLOR },
	 { "nocolor",		0, 0, GO_NO_COLOR },
	{ "ct-code",		0, 0, GO_CT_CODE },
	 { "ctcode",		0, 0, GO_CT_CODE },
	{ "chdir",		1, 0, GO_CHDIR },
	{ "const",		1, 0, 'c' },
	{ "long",		0, 0, 'l' },
	{ "brief",		0, 0, 'B' },
	{ "no-header",		0, 0, 'H' },
	 { "noheader",		0, 0, 'H' },
	{ "tracks",		1, 0, 'T' },
	{ "arenas",		1, 0, 'A' },
	{ "region",		1, 0, 'R' },
	{ "vs-region",		1, 0, GO_VS_REGION },
	 { "vsregion",		1, 0, GO_VS_REGION },
	 { "vregion",		1, 0, GO_VS_REGION },
	{ "bt-region",		1, 0, GO_BT_REGION },
	 { "btregion",		1, 0, GO_BT_REGION },
	 { "bregion",		1, 0, GO_BT_REGION },
	{ "all-ranks",		2, 0, GO_ALL_RANKS },
	 { "allranks",		2, 0, GO_ALL_RANKS },
	{ "points",		1, 0, GO_POINTS },
	 { "pts",		1, 0, GO_POINTS },
	{ "cheat",		1, 0, GO_CHEAT },
	{ "https",		1, 0, GO_HTTPS },
	{ "domain",		1, 0, GO_DOMAIN },
	{ "wiimmfi",		0, 0, GO_WIIMMFI },
	{ "twiimmfi",		0, 0, GO_TWIIMMFI },
	{ "vs",			1, 0, GO_VS },
	{ "vs2",		1, 0, GO_VS2 },
	{ "bt",			1, 0, GO_BT },
	{ "bt2",		1, 0, GO_BT2 },
	{ "meno",		0, 0, GO_MENO },
	{ "utf-8",		0, 0, GO_UTF_8 },
	 { "utf8",		0, 0, GO_UTF_8 },
	{ "no-utf-8",		0, 0, GO_NO_UTF_8 },
	 { "no-utf8",		0, 0, GO_NO_UTF_8 },
	 { "noutf8",		0, 0, GO_NO_UTF_8 },
	{ "test",		0, 0, 't' },
	{ "force",		0, 0, GO_FORCE },
	{ "OLD",		0, 0, GO_OLD },
	{ "NEW",		0, 0, GO_NEW },
	{ "EXTRACT",		0, 0, GO_EXTRACT },
	{ "dest",		1, 0, 'd' },
	{ "DEST",		1, 0, 'D' },
	{ "esc",		1, 0, 'E' },
	{ "overwrite",		0, 0, 'o' },
	{ "number",		0, 0, GO_NUMBER },
	 { "num",		0, 0, GO_NUMBER },
	{ "remove-dest",	0, 0, 'r' },
	 { "removedest",	0, 0, 'r' },
	 { "rm-dest",		0, 0, 'r' },
	 { "rmdest",		0, 0, 'r' },
	 { "remove",		0, 0, 'r' },
	{ "update",		0, 0, 'u' },
	{ "preserve",		0, 0, 'p' },
	{ "ignore",		0, 0, 'i' },
	{ "add-ctcode",		0, 0, GO_ADD_CTCODE },
	 { "addctcode",		0, 0, GO_ADD_CTCODE },
	{ "ct-dir",		1, 0, GO_CT_DIR },
	 { "ctdir",		1, 0, GO_CT_DIR },
	{ "move-d8",		0, 0, GO_MOVE_D8 },
	 { "moved8",		0, 0, GO_MOVE_D8 },
	{ "add-section",	1, 0, GO_ADD_SECTION },
	 { "addsection",	1, 0, GO_ADD_SECTION },
	{ "full-gch",		0, 0, GO_FULL_GCH },
	 { "fullgch",		0, 0, GO_FULL_GCH },
	{ "gct-no-sep",		0, 0, GO_GCT_NO_SEP },
	 { "gctnosep",		0, 0, GO_GCT_NO_SEP },
	{ "gct-sep",		0, 0, GO_GCT_SEP },
	 { "gctsep",		0, 0, GO_GCT_SEP },
	{ "gct-asm-sep",	0, 0, GO_GCT_ASM_SEP },
	 { "gctasmsep",		0, 0, GO_GCT_ASM_SEP },
	{ "gct-list",		0, 0, GO_GCT_LIST },
	 { "gctlist",		0, 0, GO_GCT_LIST },
	{ "gct-move",		0, 0, GO_GCT_MOVE },
	 { "gctmove",		0, 0, GO_GCT_MOVE },
	{ "gct-addr",		1, 0, GO_GCT_ADDR },
	 { "gctaddr",		1, 0, GO_GCT_ADDR },
	{ "gct-space",		1, 0, GO_GCT_SPACE },
	 { "gctspace",		1, 0, GO_GCT_SPACE },
	{ "create-sect",	1, 0, GO_CREATE_SECT },
	 { "createsect",	1, 0, GO_CREATE_SECT },
	 { "cs",		1, 0, GO_CREATE_SECT },
	{ "wpf",		1, 0, GO_WPF },
	{ "sections",		0, 0, GO_SECTIONS },

	{0,0,0,0}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionUsed & OptionIndex             ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 OptionUsed[OPT__N_TOTAL+1] = {0};

static const u8 OptionIndex[OPT_INDEX_SIZE] = 
{
	/* 0x00   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x10   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x20   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x30   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x40   */	 0,
	/* 0x41 A */	OPT_ARENAS,
	/* 0x42 B */	OPT_BRIEF,
	/* 0x43   */	 0,
	/* 0x44 D */	OPT_DEST2,
	/* 0x45 E */	OPT_ESC,
	/* 0x46   */	 0,0,
	/* 0x48 H */	OPT_NO_HEADER,
	/* 0x49   */	 0,0,0,0, 0,0,0,0, 0,
	/* 0x52 R */	OPT_REGION,
	/* 0x53   */	 0,
	/* 0x54 T */	OPT_TRACKS,
	/* 0x55   */	 0,
	/* 0x56 V */	OPT_VERSION,
	/* 0x57   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 
	/* 0x63 c */	OPT_CONST,
	/* 0x64 d */	OPT_DEST,
	/* 0x65   */	 0,0,0,
	/* 0x68 h */	OPT_HELP,
	/* 0x69 i */	OPT_IGNORE,
	/* 0x6a   */	 0,0,
	/* 0x6c l */	OPT_LONG,
	/* 0x6d   */	 0,0,
	/* 0x6f o */	OPT_OVERWRITE,
	/* 0x70 p */	OPT_PRESERVE,
	/* 0x71 q */	OPT_QUIET,
	/* 0x72 r */	OPT_REMOVE_DEST,
	/* 0x73   */	 0,
	/* 0x74 t */	OPT_TEST,
	/* 0x75 u */	OPT_UPDATE,
	/* 0x76 v */	OPT_VERBOSE,
	/* 0x77   */	 0,0,0,0, 0,0,0,0, 0,
	/* 0x80   */	OPT_XHELP,
	/* 0x81   */	OPT_ALLOW_ALL,
	/* 0x82   */	OPT_COMPATIBLE,
	/* 0x83   */	OPT_WIDTH,
	/* 0x84   */	OPT_DE,
	/* 0x85   */	OPT_COLOR,
	/* 0x86   */	OPT_NO_COLOR,
	/* 0x87   */	OPT_CT_CODE,
	/* 0x88   */	OPT_CHDIR,
	/* 0x89   */	OPT_VS_REGION,
	/* 0x8a   */	OPT_BT_REGION,
	/* 0x8b   */	OPT_ALL_RANKS,
	/* 0x8c   */	OPT_POINTS,
	/* 0x8d   */	OPT_CHEAT,
	/* 0x8e   */	OPT_HTTPS,
	/* 0x8f   */	OPT_DOMAIN,
	/* 0x90   */	OPT_WIIMMFI,
	/* 0x91   */	OPT_TWIIMMFI,
	/* 0x92   */	OPT_VS,
	/* 0x93   */	OPT_VS2,
	/* 0x94   */	OPT_BT,
	/* 0x95   */	OPT_BT2,
	/* 0x96   */	OPT_MENO,
	/* 0x97   */	OPT_UTF_8,
	/* 0x98   */	OPT_NO_UTF_8,
	/* 0x99   */	OPT_FORCE,
	/* 0x9a   */	OPT_OLD,
	/* 0x9b   */	OPT_NEW,
	/* 0x9c   */	OPT_EXTRACT,
	/* 0x9d   */	OPT_NUMBER,
	/* 0x9e   */	OPT_ADD_CTCODE,
	/* 0x9f   */	OPT_CT_DIR,
	/* 0xa0   */	OPT_MOVE_D8,
	/* 0xa1   */	OPT_ADD_SECTION,
	/* 0xa2   */	OPT_FULL_GCH,
	/* 0xa3   */	OPT_GCT_NO_SEP,
	/* 0xa4   */	OPT_GCT_SEP,
	/* 0xa5   */	OPT_GCT_ASM_SEP,
	/* 0xa6   */	OPT_GCT_LIST,
	/* 0xa7   */	OPT_GCT_MOVE,
	/* 0xa8   */	OPT_GCT_ADDR,
	/* 0xa9   */	OPT_GCT_SPACE,
	/* 0xaa   */	OPT_CREATE_SECT,
	/* 0xab   */	OPT_WPF,
	/* 0xac   */	OPT_SECTIONS,
	/* 0xad   */	 0,0,0,
	/* 0xb0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xc0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xd0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xe0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0xf0   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                opt_allowed_cmd_*                ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 option_allowed_cmd_VERSION[28] = // cmd #1
{
    0,1,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1
};

static u8 option_allowed_cmd_HELP[28] = // cmd #2
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1
};

static u8 option_allowed_cmd_ARGTEST[28] = // cmd #3
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1
};

static u8 option_allowed_cmd_TEST[28] = // cmd #4
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1
};

static u8 option_allowed_cmd_COLORS[28] = // cmd #5
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_ERROR[28] = // cmd #6
{
    0,1,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1
};

static u8 option_allowed_cmd_FILETYPE[28] = // cmd #7
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_FILEATTRIB[28] = // cmd #8
{
    0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_RAWDUMP[28] = // cmd #9
{
    0,0,0,0,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_DUMP[28] = // cmd #10
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_CDUMP[28] = // cmd #11
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_HTTPS[28] = // cmd #12
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_EXTRACT[28] = // cmd #13
{
    0,0,0,0,0, 1,1,0,1,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_TRACKS[28] = // cmd #14
{
    0,1,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_ARENAS[28] = // cmd #15
{
    0,1,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_FILES[28] = // cmd #16
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_FIND[28] = // cmd #17
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_POINTS[28] = // cmd #18
{
    0,1,1,0,1, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_ANALYZE[28] = // cmd #19
{
    0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0
};

static u8 option_allowed_cmd_PATCH[28] = // cmd #20
{
    0,0,0,0,0, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                 InfoOption tabs                 ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t * option_tab_tool[] =
{
	OptionInfo + OPT_VERSION,
	OptionInfo + OPT_HELP,
	OptionInfo + OPT_XHELP,
	OptionInfo + OPT_ALLOW_ALL,
	OptionInfo + OPT_COMPATIBLE,
	OptionInfo + OPT_WIDTH,
	OptionInfo + OPT_QUIET,
	OptionInfo + OPT_VERBOSE,
	OptionInfo + OPT_DE,
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	OptionInfo + OPT_CT_CODE,
	OptionInfo + OPT_CHDIR,
	OptionInfo + OPT_CONST,
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_POINTS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TEST,
	OptionInfo + OPT_FORCE,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CT_DIR,

	0
};

static const InfoOption_t * option_tab_cmd_VERSION[] =
{
	&option_cmd_VERSION_BRIEF,
	OptionInfo + OPT_SECTIONS,
	&option_cmd_VERSION_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_HELP[] =
{
	OptionInfo + OPT_WIDTH,

	0
};

static const InfoOption_t * option_tab_cmd_ARGTEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_TEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_COLORS[] =
{
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	&option_cmd_COLORS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_ERROR[] =
{
	OptionInfo + OPT_SECTIONS,
	OptionInfo + OPT_NO_HEADER,
	&option_cmd_ERROR_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_FILETYPE[] =
{
	&option_cmd_FILETYPE_LONG,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_FILEATTRIB[] =
{
	OptionInfo + OPT_NO_HEADER,

	0
};

static const InfoOption_t * option_tab_cmd_RAWDUMP[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,

	0
};

static const InfoOption_t * option_tab_cmd_DUMP[] =
{
	&option_cmd_DUMP_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_CDUMP[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_HTTPS[] =
{
	&option_cmd_HTTPS_LONG,
	&option_cmd_HTTPS_VERBOSE,

	0
};

static const InfoOption_t * option_tab_cmd_EXTRACT[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_OVERWRITE,

	0
};

static const InfoOption_t * option_tab_cmd_TRACKS[] =
{
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	&option_cmd_TRACKS_LONG,
	OptionInfo + OPT_DE,
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,

	0
};

static const InfoOption_t * option_tab_cmd_ARENAS[] =
{
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	&option_cmd_TRACKS_LONG,
	OptionInfo + OPT_DE,
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,

	0
};

static const InfoOption_t * option_tab_cmd_FILES[] =
{
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,

	0
};

static const InfoOption_t * option_tab_cmd_FIND[] =
{
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,
	&option_cmd_FIND_LONG,
	OptionInfo + OPT_DE,

	0
};

static const InfoOption_t * option_tab_cmd_POINTS[] =
{
	OptionInfo + OPT_POINTS,
	&option_cmd_POINTS_BRIEF,
	&option_cmd_POINTS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_ANALYZE[] =
{
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,
	&option_cmd_ANALYZE_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_PATCH[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_IGNORE,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_REGION,
	OptionInfo + OPT_VS_REGION,
	OptionInfo + OPT_BT_REGION,
	OptionInfo + OPT_ALL_RANKS,
	OptionInfo + OPT_HTTPS,
	OptionInfo + OPT_DOMAIN,
	OptionInfo + OPT_WIIMMFI,
	OptionInfo + OPT_VS,
	OptionInfo + OPT_BT,
	OptionInfo + OPT_MENO,
	OptionInfo + OPT_ADD_CTCODE,
	OptionInfo + OPT_CT_DIR,
	OptionInfo + OPT_ADD_SECTION,
	OptionInfo + OPT_GCT_MOVE,
	OptionInfo + OPT_GCT_ADDR,
	OptionInfo + OPT_GCT_SPACE,
	&option_cmd_PATCH_FORCE,

	0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                   InfoCommand                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoCommand_t CommandInfo[CMD__N+1] =
{
    {	0,
	false,
	false,
	false,
	"wstrt",
	0,
	"wstrt [option]... command [option|parameter|file]...",
	"Wiimms StaticR Tool : Manipulate the 'main.dol' and 'StaticR.rel'"
	" files of Mario Kart Wii.",
	0,
	30,
	option_tab_tool,
	0
    },

    {	CMD_VERSION,
	false,
	false,
	false,
	"VERSION",
	0,
	"wstrt VERSION [ignored]...",
	"Print program name and version and exit.",
	0,
	3,
	option_tab_cmd_VERSION,
	option_allowed_cmd_VERSION
    },

    {	CMD_HELP,
	false,
	false,
	false,
	"HELP",
	"H",
	"wstrt HELP [--width=wd] OPT|OPTION ...\n"
	"wstrt HELP [--width=wd] CMD|COMMAND [ignored]...\n"
	"wstrt HELP [--width=wd] command [-b] [ignored]...\n"
	"wstrt HELP [--width=wd] [ignored]...",
	"Print help for commands and options.",
	"Print help for commands and options.\n"
	"  The first variant (with keyword OPT or OPTION) prints a list of all"
	" global and command specific options. If at least one option is set,"
	" only infos about the declared options are printed. The second"
	" variant (with keyword CMD or COMMAND) prints an overview about all"
	" commands. The third variant (with a valid command name) prints"
	" details about the declared command. The fourth variant prints an"
	" overview about all commands and all global options.",
	1,
	option_tab_cmd_HELP,
	option_allowed_cmd_HELP
    },

    {	CMD_ARGTEST,
	false,
	false,
	false,
	"ARGTEST",
	0,
	"wstrt ARGTEST ...",
	"This debug command accepts all kinds of parameters and prints one"
	" line for each parameter.",
	0,
	0,
	option_tab_cmd_ARGTEST,
	option_allowed_cmd_ARGTEST
    },

    {	CMD_TEST,
	false,
	false,
	false,
	"TEST",
	0,
	"wstrt TEST [options]... [ignored]...",
	"This debugging command accepts all options and parameters and prints"
	" a list of the internal option values. The command is designed to"
	" test the option parameters. The non option parameters are completly"
	" ignored.",
	0,
	0,
	option_tab_cmd_TEST,
	option_allowed_cmd_TEST
    },

    {	CMD_COLORS,
	false,
	false,
	false,
	"COLORS",
	0,
	"wstrt COLORS",
	"Ignore all parameters and print clored text for testing.",
	0,
	3,
	option_tab_cmd_COLORS,
	option_allowed_cmd_COLORS
    },

    {	CMD_ERROR,
	false,
	false,
	false,
	"ERROR",
	"ERR",
	"wstrt ERROR [error_code]",
	"Translate an exit code to a message name. If no exit code is entered,"
	" print a table with all error messages.",
	0,
	3,
	option_tab_cmd_ERROR,
	option_allowed_cmd_ERROR
    },

    {	CMD_FILETYPE,
	false,
	false,
	false,
	"FILETYPE",
	"FT",
	"wstrt FILETYPE file...",
	"Scan the header of the entered files and print file type and path for"
	" each file as list.",
	0,
	2,
	option_tab_cmd_FILETYPE,
	option_allowed_cmd_FILETYPE
    },

    {	CMD_FILEATTRIB,
	false,
	false,
	false,
	"FILEATTRIB",
	"FA",
	"wstrt FILEATTRIB [keyword]...",
	"Print a table with attributes for all known file types. If at least"
	" one keyword is entered, only matching file types are printed. A"
	" keyword is either a file type (like 'BRRES' or 'BMG') or one of the"
	" printed keywords (like 'ARCHIVE' or 'EXTRACT').",
	0,
	1,
	option_tab_cmd_FILEATTRIB,
	option_allowed_cmd_FILEATTRIB
    },

    {	CMD_RAWDUMP,
	true,
	false,
	false,
	"_RAWDUMP",
	0,
	"wszst _RAWDUMP [-d|-D] destdir",
	"This hidden command creates the destination directory  and create"
	" several files as copy of internal data.",
	0,
	2,
	option_tab_cmd_RAWDUMP,
	option_allowed_cmd_RAWDUMP
    },

    {	CMD_DUMP,
	false,
	false,
	true,
	"DUMP",
	0,
	"wstrt DUMP file...",
	"Dump the structure of 'StaticR.rel' (in development) and of DOL files"
	" as text.",
	0,
	1,
	option_tab_cmd_DUMP,
	option_allowed_cmd_DUMP
    },

    {	CMD_CDUMP,
	true,
	false,
	false,
	"_CDUMP",
	0,
	"wstrt _CDUMP file...",
	"Dump the structure of 'StaticR.rel' (in development) and of DOL files"
	" as C source fragments.",
	0,
	0,
	option_tab_cmd_CDUMP,
	option_allowed_cmd_CDUMP
    },

    {	CMD_HTTPS,
	true,
	false,
	false,
	"_HTTPS",
	0,
	"wstrt _HTTPS file...",
	"Collect data about https-requests and print a total summary for all"
	" accepted files.",
	0,
	2,
	option_tab_cmd_HTTPS,
	option_allowed_cmd_HTTPS
    },

    {	CMD_EXTRACT,
	false,
	false,
	false,
	"EXTRACT",
	"X",
	"wstrt EXTRACT dol...",
	"Extract the sections of a DOL file into a directory. StaticR.rel"
	" files are ignored.",
	0,
	3,
	option_tab_cmd_EXTRACT,
	option_allowed_cmd_EXTRACT
    },

    {	CMD_TRACKS,
	false,
	false,
	true,
	"TRACKS",
	0,
	"wstrt TRACKS [file]...",
	"Show track infos in the order of the 'StaticR.rel' files. If no file"
	" is entered, the standard order is used.",
	0,
	16,
	option_tab_cmd_TRACKS,
	option_allowed_cmd_TRACKS
    },

    {	CMD_ARENAS,
	false,
	false,
	false,
	"ARENAS",
	0,
	"wstrt ARENAS [file]...",
	"Show arena infos in the order of the 'StaticR.rel' files. If no file"
	" is entered, the standard order is used.",
	0,
	16,
	option_tab_cmd_ARENAS,
	option_allowed_cmd_ARENAS
    },

    {	CMD_FILES,
	false,
	false,
	false,
	"FILES",
	0,
	"wstrt FILES [file]...",
	"List track and arena file names in machine readable format. Use the"
	" order of the entered 'StaticR.rel' files. If no file is entered, the"
	" standard order is used.",
	0,
	12,
	option_tab_cmd_FILES,
	option_allowed_cmd_FILES
    },

    {	CMD_FIND,
	false,
	false,
	false,
	"FIND",
	0,
	"wstrt FIND [+]TRACK keyword...\n"
	"wstrt FIND [+]ARENA keyword...",
	"Find a track or arena by keyword and print one line for each keyword"
	" in machine readable format 'type slot' or, if not found, a simple"
	" '-'. The name is searched in the entered context (tracks or arenas)."
	" If TRACK or ARENA is prefixed by a plus, then a failed search will"
	" be continued in the other context. If at least one name is not"
	" found, the tool terminates with exit code NOT_EXISTS.",
	0,
	14,
	option_tab_cmd_FIND,
	option_allowed_cmd_FIND
    },

    {	CMD_POINTS,
	false,
	false,
	false,
	"POINTS",
	"PTS",
	"wstrt POINTS [--points=list] [file]...",
	"Print a table with the points assigned to player after a versus or"
	" room race for each entered file. If no file is entered, the standard"
	" table is used. However, if option --points is set only the resulting"
	" table is printed.",
	0,
	3,
	option_tab_cmd_POINTS,
	option_allowed_cmd_POINTS
    },

    {	CMD_ANALYZE,
	false,
	false,
	true,
	"ANALYZE",
	"ANA",
	"wstrt ANALYZE [file]...",
	"Open 'StaticR.rel' and DOL files and analyze them. The files will be"
	" classified using SHA1 checksums.",
	0,
	13,
	option_tab_cmd_ANALYZE,
	option_allowed_cmd_ANALYZE
    },

    {	CMD_PATCH,
	false,
	false,
	false,
	"PATCH",
	0,
	"wstrt PATCH [file]...",
	"Patch 'main.dol and 'StaticR.rel' files of Mario Kart Wii. No backup"
	" is made.",
	0,
	28,
	option_tab_cmd_PATCH,
	option_allowed_cmd_PATCH
    },

    {0,0,0,0,0,0,0,0,0,00,}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                     InfoUI                      ///////////////
///////////////////////////////////////////////////////////////////////////////

const InfoUI_t InfoUI_wstrt =
{
	"wstrt",
	CMD__N,
	CommandTab,
	CommandInfo,
	OPT__N_SPECIFIC,
	OPT__N_TOTAL,
	OptionInfo,
	OptionUsed,
	OptionIndex,
	OptionShort,
	OptionLong
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                       END                       ///////////////
///////////////////////////////////////////////////////////////////////////////

