
//
///////////////////////////////////////////////////////////////////////////////
//////   This file is created by a script. Modifications will be lost!   //////
///////////////////////////////////////////////////////////////////////////////


#include "db-object.h"

//
///////////////////////////////////////////////////////////////////////////////
/////////////////////////   characteristics strings   /////////////////////////
///////////////////////////////////////////////////////////////////////////////

const char obj_charact[] = "";
const char obj_charact_a[] = "no route, found in arenas";
const char obj_charact_o[] = "no route, found in other files";
const char obj_charact_or_s_t[] = "optional route, solid, found in tracks";
const char obj_charact_r_s_a[] = "route needed, solid, found in arenas";
const char obj_charact_r_s_o[] = "route needed, solid, found in other files";
const char obj_charact_r_s_t[] = "route needed, solid, found in tracks";
const char obj_charact_r_s_to[] = "route needed, solid, found in tracks + other files";
const char obj_charact_r_t[] = "route needed, found in tracks";
const char obj_charact_r_ta[] = "route needed, found in tracks + arenas";
const char obj_charact_r_to[] = "route needed, found in tracks + other files";
const char obj_charact_s[] = "solid";
const char obj_charact_s_a[] = "no route, solid, found in arenas";
const char obj_charact_s_o[] = "no route, solid, found in other files";
const char obj_charact_s_t[] = "no route, solid, found in tracks";
const char obj_charact_s_ta[] = "no route, solid, found in tracks + arenas";
const char obj_charact_s_tao[] = "no route, solid, found in tracks + arenas + other files";
const char obj_charact_s_to[] = "no route, solid, found in tracks + other files";
const char obj_charact_t[] = "no route, found in tracks";
const char obj_charact_ta[] = "no route, found in tracks + arenas";
const char obj_charact_to[] = "no route, found in tracks + other files";


//
///////////////////////////////////////////////////////////////////////////////
/////////////////////////////   format strings   //////////////////////////////
///////////////////////////////////////////////////////////////////////////////

const char settings_format_uuuu[] = "%6u %6u %6u %6u";
const char settings_format_uxuu[] = "%6u %#6x %6u %6u";
const char settings_format_uxxu[] = "%6u %#6x %#6x %6u";


//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////   struct ObjectInfo_t   ///////////////////////////
///////////////////////////////////////////////////////////////////////////////

const ObjectInfo_t ObjectInfo[N_KMP_GOBJ] =
{
    // names and infos are copied from
    // http://wiki.tockdom.de/index.php?title=Object

    /* 0x000 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x001 */
	{ "airblock", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x002 */
	{ "Psea", "The sea on GCN Peach Beach; for details see Object/Psea.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{116,-1,-1}, "Psea(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x003 */
	{ "lensFX", "Generates a lens flare object when looking at the sun; it's also highly recommended to place this object near or coincident to `sun'.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_ta,
		settings_format_uuuu, settings_format_uuuu,
		{203,-1,-1}, "lensFX",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x004 */
	{ "venice_nami", "The rising and dropping sea on Delfino Pier.<br>This object is different than `Psea' because it raises after a certain time to a higher level and stays there after a few raises; further the same settings as Psea.<br>First the water drops up and down and then after a certain time it goes up with a fast speed; this cycle is done until the max height is reached.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{250,-1,-1}, "venice_nami(B)",
		{ "Rising height per cyclus",
		  "Reset height (relative to placement Y)",
		  "No visible changes (tested with 0x0000, 0x0001 and 0xF000)",
		  "Time to rise X units",
		  "Max height (relative to placement Y)",
		  "Controls when to reset, unknown values",
		  "Starting height<br>(= X?)",
		  0 }},
    /* 0x005 */
	{ "sound_river", "Generates a river sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x006 */
	{ "sound_water_fall", "Generates a waterfall sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x007 */
	{ "pocha", "Generates a water splash effect when a player falls in the water with the same assigned KCL id.<br>Location doesn't matter, you have only to set the height (Y coordinate) where you want to get the effect.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_ta,
		settings_format_uuuu, settings_format_uuuu,
		{225,-1,-1}, "pocha(BE)",
		{ "KCL Index:<br>1 = Water fall;<br>3 = Icy Water fall<br>(needs `ice' object)",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x008 */
	{ "sound_lake", "Generates a lake sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x009 */
	{ "sound_big_fall", "Generates a louder waterfall sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x00a */
	{ "sound_sea", "Generates a sea sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x00b */
	{ "sound_fountain", "Generates a fountain sound effect, the range where the sound comes from is controlled by the route, so makes use of it.<br>It seems this object doesn't work on all slots; it seems to work on slot 2.2 and not working on slots 1.1 and 1.2.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x00c */
	{ "sound_volcano", "Generates a volcano sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x00d */
	{ "sound_audience", "Generates an audience sound effect, the range where the sound comes from is controlled by the route, so makes use of it.<br>Works on slots 1.1, 1.4, 2.3, 3.1 and 5.4; slot 3.1 doesn't feature slot-based audience ambience.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x00e */
	{ "sound_big_river", "Generates a louder river sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x00f */
	{ "sound_sand_fall", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x010 */
	{ "sound_lift", "Generates a lift sound effect, the range where the sound comes from is controlled by the route, so makes use of it.<br>Route Setting 1 is always 1 in all Nintendo tracks.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x011 */
	{ "pochaYogan", "Generates a lava splash effect when a player falls trough the lava fall boundary with the same assigned KCL id.<br>Location doesn't matter, you have only to set the height (Y coordinate) where you want to get the effect.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{227,-1,-1}, "pochaYogan(BE)",
		{ "KCL Index:<br>2 = Lava fall",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x012 */
	{ "entry", "Generates a fire around the player when falls trough a burning air fall boundary flag.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{172,-1,-1}, "entry(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x013 */
	{ "pochaMori", "Generates a leaf splash effect when a player falls trough the tree with the same assigned fall boundary id.<br>Location doesn't matter, you have only to set the height (Y coordinate) where you want to get the effect.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_ta,
		settings_format_uuuu, settings_format_uuuu,
		{226,-1,-1}, "pochaMori(E)",
		{ "KCL Index",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x014 */
	{ "eline_control", "Enemy line controller. Multiple controllers can be chained together. The timer of the next controller in a chain beings after the end of the previous.<br>Controller ID 0 is reserved to indicate the end of a controller chain. Enemies can choose to not obey a controller unless the next EHPH Section is set to -1.<br>Found in slots 1.4, 2.2, 3.4 and 4.1 and in Arena 1.2.",
		OBF_OBJFLOW | OBF_NO_ROUTE | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_ta,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ "Entry Flag:<br>0 = Do Not Enter<br>1 = Enter",
		  "Time to Next Controller (seconds)",
		  "Controller ID",
		  "Next Controller ID",
		  0, 0, 0,
		  "ENPH Section; if -1, use ENPH of previous controller" }},
    /* 0x015 */
	{ "sound_Mii", "Generates a mii crowd sound effect, the range where the sound comes from is controlled by the route, so makes use of it.",
		OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x016 */
	{ "begoman_manager", "Galaxy Colosseum spinner manager; object not used in any track.",
		OBF_OBJFLOW | OBF_NO_ROUTE | OBF_F_OTHER,
		obj_charact_o,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ "Unknown",
		  0,
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x017 */
	{ "ice", "Generates ice around the player when respawned after falling in a icy water fall boundary flag; the location doesn't matter, the ice effect is always gotten.<br>This object works only on slot 6.1 and it's necessary to allow tracks to work on this slot.",
		OBF_OPTIONAL | OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{191,-1,-1}, "ice(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x018 */
	{ "startline2D", "Generates a finish line at given location, this object is used in competitions where you have to drive laps on a battle course and some others; object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x019 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x01a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x01b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x01c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x01d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x01e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x01f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x020 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x021 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x022 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x023 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x024 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x025 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x026 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x027 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x028 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x029 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x02a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x02b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x02c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x02d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x02e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x02f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x030 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x031 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x032 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x033 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x034 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x035 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x036 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x037 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x038 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x039 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x03a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x03b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x03c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x03d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x03e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x03f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x040 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x041 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x042 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x043 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x044 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x045 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x046 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x047 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x048 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x049 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x04a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x04b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x04c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x04d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x04e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x04f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x050 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x051 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x052 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x053 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x054 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x055 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x056 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x057 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x058 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x059 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x05a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x05b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x05c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x05d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x05e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x05f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x060 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x061 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x062 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x063 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x064 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x065 */
	{ "itembox", "Spinning box with a question mark in it. If touched it snaps and an item lottery begins; after the lottery the item shown is gotten.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_FOUND | OBF_ITEMBOX,
		obj_charact_s_tao,
		settings_format_uxxu, settings_format_uuuu,
		{192,-1,-1}, "itembox(B)",
		{ "Unknown",
		  "Item type (player)",
		  "Item type (enemy)",
		  "Unknown",
		  0,
		  "Timing lottery",
		  0,
		  "Unknown" }},
    /* 0x066 */
	{ "DummyPole", "Solidity of the poles of different courses. Deleting this object will cause the Dummy pole itself to be unsolid.",
		OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_s_to,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ "Wall KCL Variant",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x067 */
	{ "flag", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{175,-1,-1}, "flag",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x068 */
	{ "flagBlend", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{176,-1,-1}, "flagBlend",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x069 */
	{ "gnd_sphere", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x06a */
	{ "gnd_trapezoid", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x06b */
	{ "gnd_wave1", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x06c */
	{ "gnd_wave2", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x06d */
	{ "gnd_wave3", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x06e */
	{ "gnd_wave4", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x06f */
	{ "sun", "The sun in the vrcorn, often used with `lensFX'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_ta,
		settings_format_uuuu, settings_format_uuuu,
		{240,-1,-1}, "sun(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x070 */
	{ "woodbox", "Wooden box. When touched the player slows down and the box drops an item.<br>In Time Trial becomes an unbreakable `ironbox'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{256,-1,-1}, "woodbox(BE)",
		{ 0,
		  "Item to give",
		  "Chance to give an item",
		  0, 0, 0, 0, 0 }},
    /* 0x071 */
	{ "KmoonZ", "The moon of Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{73,-1,-1}, "KmoonZ(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x072 */
	{ "sunDS", "The Angry Sun from DS Desert Hills. It changes point of view and rotation of the crown according to player's position.<br>Route Setting 1 controls the behavior depending on the value X:<br>X < 30 (1E in hex) → Stays for X/60 seconds;<br>X ≥ 30 (1E in hex) → Drops a `FireSnake' staying for X/60 seconds.<br>In both cases the dropping animation is viewed; if the route start point is set to drop, it will drop at the second \"lap\" of the route.<br>Only slots 3.1 and 7.1 support this object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{241,-1,-1}, "sunDS(B)",
		{ "Speed",
		  "Delay before starting in 1/60 seconds after starting of countdown.<br>240 (F0 in hex) = Starts immediately after the \"GO!\"",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x073 */
	{ "coin", "Present in all battle courses, when touched it disappears and one point is gotten (only in coin runners).<br>Some coins don't appear at the start of the battle but show up later; this can be controlled by S3.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{159,-1,-1}, "coin(BE)",
		{ 0,
		  "Presence flag/coin ID",
		  "Min before showing up",
		  0, 0, 0, 0, 0 }},
    /* 0x074 */
	{ "ironbox", "Object not used in any track.<br>It seems to be born as an object separate from `woodenbox'. ",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x075 */
	{ "ItemDirect", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ "Item type",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x076 */
	{ "s_itembox", "Item box that acts like a kart, it moves with moving KCL. When placed high, it falls until it reaches the ground, and when placed on a steep surface, it falls.<br>Unlike other item boxes, this item box has no settings for the item type.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA | OBF_ITEMBOX,
		obj_charact_s_ta,
		settings_format_uxxu, settings_format_uuuu,
		{192,-1,-1}, "itembox(B)",
		{ "[?] Speed (?)",
		  0, 0, 0, 0, 0,
		  "Unknown",
		  0 }},
    /* 0x077 */
	{ "pile_coin", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{159,-1,-1}, "coin(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x078 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x079 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x07a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x07b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x07c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x07d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x07e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x07f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x080 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x081 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x082 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x083 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x084 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x085 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x086 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x087 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x088 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x089 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x08a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x08b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x08c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x08d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x08e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x08f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x090 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x091 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x092 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x093 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x094 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x095 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x096 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x097 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x098 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x099 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x09a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x09b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x09c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x09d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x09e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x09f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0a9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0aa */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0ab */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0ac */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0ad */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0ae */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0af */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0b9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0ba */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0bb */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0bc */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0bd */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0be */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0bf */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0c9 */
	{ "f_itembox", "Route controlled itembox. If any Route Setting 2 is 1, explodes mode is activated.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER | OBF_ITEMBOX,
		obj_charact_r_s_to,
		settings_format_uxxu, settings_format_uuuu,
		{192,-1,-1}, "itembox(B)",
		{ "Start speed in units per 1/60 seconds; if a Route Setting 1 > 0 a new speed is defined",
		  "Item type (player)",
		  "Item type (enemy)",
		  "Unknown (0 or 1 in Nintendo tracks)",
		  "Route start point",
		  0, 0, 0 }},
    /* 0x0ca */
	{ "MashBalloonGC", "Airballoon as seen on GCN Mario Circuit. It has an assigned route but also floats from Y to Y.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_r_to,
		settings_format_uuuu, settings_format_uuuu,
		{85,-1,-1}, "MashBalloonGC(B)",
		{ "Speed",
		  "Max Y difference",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0cb */
	{ "WLwallGC", "Horizontal moving Piranha Plant wall from GCN Waluigi Stadium. It moves like a sinus (inside → outside → inside); normally combined with `WLdokanGC'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{141,-1,-1}, "WLwallGC(BK)",
		{ "Time inside the pipe",
		  "Time outside the pipe",
		  "Speed",
		  "Lenght of going",
		  "Going out first time",
		  0, 0, 0 }},
    /* 0x0cc */
	{ "CarA1", "Moving Car from Coconut Mall. It moves exactly like `WLwallGC' but instead left → right.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{9,-1,-1}, "CarA1(B)",
		{ "Speed",
		  "Acceleration",
		  "Time of pause",
		  0, 0, 0, 0, 0 }},
    /* 0x0cd */
	{ "basabasa", "Bats following a route, when touched they act like a wall. The bats are released as groups which can be edited in any way.<br>When using this object it is recommed to use values seen in normal Nintendo tracks for S4 and S5 since the way to change them is very strange.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{145,-1,-1}, "basabasa(B)",
		{ "Speed in units per 1/60 seconds",
		  "Delay until start of the next group in 1/60 seconds.<br>Multiple groups can be on the way",
		  "Number of bats per group",
		  "How far they can get off the route (unknown values)",
		  "Strength (?)",
		  "Maximal amount of bats before terminating (not affected by S3)",
		  "Start delay in 1/60 seconds",
		  "Unknown" }},
    /* 0x0ce */
	{ "HeyhoShipGBA", "Shy Guy ship which shoots exploding cannonballs; cannonball object is `HeyhoBallGBA'.<br>This object is made for counterclockwise directed tracks, so if a track is clockwise directed this object must be modified with BrawlBox:<br>Cullmode from Materials must be set on Cull_Outside and Z scale in KMP must be -1.<br>Only slot 6.2 supports this object and it's necessary to allow tracks to work on this slot.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{61,-1,-1}, "HeyhoShipGBA(B)",
		{ "Speed",
		  "How strong it moves up and down",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0cf */
	{ "koopaBall", "Gigantic exploding fireball, used with `koopaFigure'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{198,-1,-1}, "koopaBall(BE)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0d0 */
	{ "kart_truck", "Truck from Moonview Highway.<br>Route Setting 1 is for blinking (1 = Left, 2 = Right).<br>Route Setting 2 selects the speed (0 or 1).",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{71,-1,-1}, "K_truck(B)",
		{ "Route start point",
		  "Speed 0 in 1/60 seconds",
		  "Speed 1 in 1/60 seconds",
		  "Texturing:<br>0 = MooMoo<br>1 = Fruit<br>2 = Factory",
		  0, 0, 0, 0 }},
    /* 0x0d1 */
	{ "car_body", "Car from Moonview Highway.<br>Route Setting 1 is for blinking (1 = Left, 2 = Right)<br>Route Setting 2 selects the speed (0 or 1)",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{68,-1,-1}, "K_car_body(B)",
		{ "Route start point",
		  "Speed 0 in 1/60 seconds",
		  "Speed 1 in 1/60 seconds",
		  "Color:<br>0 = Blue<br>1 = Red<br>2 = Yellow",
		  "Unknown",
		  0, 0, 0 }},
    /* 0x0d2 */
	{ "skyship", "Blimp from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_r_to,
		settings_format_uuuu, settings_format_uuuu,
		{237,-1,-1}, "skyship(B)",
		{ "Route start point",
		  "[?] Speed",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0d3 */
	{ "w_woodbox", "Box following route. Route setting 1 sets the speed (gets added to S1).",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{256,-1,-1}, "woodbox(BE)",
		{ "Speed",
		  "Item to give",
		  "Chance to give an item",
		  "Unknown",
		  "Start delay",
		  "Time between 2 boxes",
		  "Max amount of boxes",
		  0 }},
    /* 0x0d4 */
	{ "w_itembox", "Itembox following route.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_ITEMBOX,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{192,-1,-1}, "itembox(B)",
		{ "Unknown",
		  0, 0, 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0 }},
    /* 0x0d5 */
	{ "w_itemboxline", "`Press', block.brres and `itembox' combination from Toad's Factory.<br>Each block follows a route until it reach the press and the press converts it to an itembox which continues the route.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_TRACK | OBF_ITEMBOX,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{7,192,115}, "Block(BE);itembox(B);Press(BE)",
		{ "Unknown",
		  0, 0, 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0 }},
    /* 0x0d6 */
	{ "VolcanoBall1", "Firery rock from Grumble Volcano.<br>When created a volcano explosion occurs and it follows the route until it touches a solid part, then it becomes a fire; slot 3.4 enables its SFX.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{134,-1,-1}, "VolcanoBall1(BE)",
		{ "Fireball speed",
		  "Delay before starting",
		  "Time between 2 fireballs",
		  "Time until the fire goes out",
		  0, 0, 0, 0 }},
    /* 0x0d7 */
	{ "penguin_s", "Small penguin from N64 Sherbet Land, creates a symmetrical copy of itself under the ground to simulate ice reflection.<br>Route setting 1: 0 = Default; 1 = Glide; 2 = Animation faster; 3 = Default.<br>Route setting 2 describes the speed when route setting 1 ≠ 0, but is always required a value ≠ 0.<br>Slot 6.1 enables its SFX.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{223,-1,-1}, "penguin_s(BE3D)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0d8 */
	{ "penguin_m", "Medium penguin from N64 Sherbet Land.<br>Slot 6.1 enables its SFX.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{222,-1,-1}, "penguin_m(BED)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0d9 */
	{ "penguin_l", "Large penguin from N64 Sherbet Land.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{221,-1,-1}, "penguin_l(BE)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0da */
	{ "castleballoon1", "Balloon from Mario Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_r_to,
		settings_format_uuuu, settings_format_uuuu,
		{154,-1,-1}, "castleballoon1(B)",
		{ "Speed",
		  "Max Y difference",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0db */
	{ "dossunc",
		"Thwomp with optional route; without route, S1 and S2 must be 0.\n"
		"If S2 = 2 a 3 point route is needed to make effect:<br>1 → Start point, route setting 2 = 0;<br>2 → Rotation point, route setting 2 = 1;<br>3 → Going down point, route setting 2 = 0.<br>The couple starts, at the second point turns of 180° and goes left and right, going down around the third point according to player's direction, then goes back to the first point.<br>To make effect the object needs a rotation of ±90°, route points must have the same Y and Z coordinate and no other object must be near the start point.<br>In GP and VS Race the object is activated by the proximity of a main player (not a CPU) and the speed is proportional to the player's; in Time Trial speed and start delay are the same of respective settings in KMP file.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_OPT_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_or_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{170,-1,-1}, "dossun(BE)",
		{ "Route speed",
		  "Behaviour with route:<br>1 = Stomp on every route point<br>2 = Couple of Thwomps, goes left and right before going down; read the description<br>3 = Grounded Thwomp, goes left and right",
		  "Start delay in 1/60 seconds after start of countdown.<br>240 (F0 in hex) = Starts immediately after the \"GO!\"",
		  "Sleep time in 1/60 seconds after start of countdown",
		  0, 0, 0, 0 }},
    /* 0x0dc */
	{ "dossunc_soko", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0dd */
	{ "boble", "Podoboo from GBA Bowser Castle 3. Route Setting 1 controls the speed (gets added to S1), Route Setting 2 = 1 means that the model flips horizontally.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{149,-1,-1}, "boble(BE)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0de */
	{ "K_bomb_car", "Bomb car from Moonview Highway.<br>Route Setting 1 is for blinking (1 = Left, 2 = Right).<br>Route Setting 2 selects the speed (0 or 1).",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{65,-1,-1}, "K_bomb_car(BE)",
		{ "Route start point",
		  "Speed 0 in 1/60 seconds",
		  "Speed 1 in 1/60 seconds",
		  0, 0, 0, 0, 0 }},
    /* 0x0df */
	{ "K_bomb_car_dummy", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{67,-1,-1}, "K_bomb_car_dummy",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0e0 */
	{ "car_body_dummy", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{152,-1,-1}, "car_body_dummy",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0e1 */
	{ "kart_truck_dummy", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{194,-1,-1}, "kart_truck_dummy",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0e2 */
	{ "hanachan", "Wiggler from Maple Treeway.<br>Route Setting 1 sets the time in 1/60 seconds of stop in that point.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{187,-1,-1}, "hanachan(BE2D)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0e3 */
	{ "seagull", "Seagull route following from tracks with marine setting.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{236,-1,-1}, "seagull(B)",
		{ "Speed",
		  "Number of seagulls",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0e4 */
	{ "moray", "Unagi (eel) from Koopa Cape and Chain Chomp Wheel.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_r_ta,
		settings_format_uuuu, settings_format_uuuu,
		{211,-1,-1}, "moray(B)",
		{ "Unknown",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0e5 */
	{ "crab", "Crab from GBA Shy Guy Beach.<br>Route Setting 1 sets the time in 1/60 seconds of stop in that point.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{161,-1,-1}, "crab(BE3D)",
		{ "Speed in units per 1/60 seconds",
		  "Crab view direction:<br>0 = Left<br>1 = Right",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0e6 */
	{ "basabasa_dummy", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0e7 */
	{ "CarA2", "Moving Car from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{10,-1,-1}, "CarA2(B)",
		{ "Speed",
		  "Acceleration",
		  "Time of pause",
		  0, 0, 0, 0, 0 }},
    /* 0x0e8 */
	{ "CarA3", "Moving Car from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{11,-1,-1}, "CarA3(B)",
		{ "Speed",
		  "Acceleration",
		  "Time of pause",
		  0, 0, 0, 0, 0 }},
    /* 0x0e9 */
	{ "Hwanwan", "Route-following Chain Chomp from DS Peach Gardens.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{254,-1,-1}, "wanwan(BE)",
		{ "Speed",
		  "Amount of item boxes carried",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0ea */
	{ "HeyhoBallGBA", "Cannonball landing area, which explodes after 3 seconds, shot by `HeyhoShipGBA'; in GP and VS Race explodes also if touched.<br>Object's scale doesn't affect the explosion effect's dimension. Generally CPUs don't go against this object and they avoid it.<br>Because works with `HeyhoShipGBA', works only on slot 6.2.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{60,-1,-1}, "HeyhoBallGBA(BE)",
		{ "Route id from where `HeyhoShipGBA' shoots",
		  "Time between shot and arrival in 1/60 seconds",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0eb */
	{ "Twanwan", "Rolling Chain Chomp from Chain Chomp Wheel.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_r_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{130,-1,-1}, "Twanwan(B)",
		{ "Unknown",
		  "Unknown",
		  "Speed",
		  "Unknown",
		  "Start delay in 1/60 seconds",
		  "Unknown",
		  0, 0 }},
    /* 0x0ec */
	{ "cruiserR", "Route-following boat from Daisy Circuit and Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{162,-1,-1}, "cruiser(BE)",
		{ "Start speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0ed */
	{ "bird", "Eagle route following from GCN DK Mountain.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{148,-1,-1}, "bird(B)",
		{ "Speed",
		  "Number of eagles",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x0ee */
	{ "sin_itembox", "Item box following a route back and forth; speed is like sinus.<br>Route setting 2: 0 = Asymetric; 1 = Symetric.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_ITEMBOX,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{192,-1,-1}, "itembox(B)",
		{ "Cycle time in 1/60 seconds",
		  0, 0, 0,
		  "Start delay in 1/60 seconds",
		  0, 0, 0 }},
    /* 0x0ef */
	{ "Twanwan_ue", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{131,-1,-1}, "Twanwan_ue",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0f0 */
	{ "BossHanachan", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{187,-1,-1}, "hanachan(BE2D)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0f1 */
	{ "Kdossunc", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0f2 */
	{ "BossHanachanHead", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0f3 */
	{ "K_bomb_car1", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{66,-1,-1}, "K_bomb_car1",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x0f4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0f5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0f6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0f7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0f8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0f9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0fa */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0fb */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0fc */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0fd */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0fe */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x0ff */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x100 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x101 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x102 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x103 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x104 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x105 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x106 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x107 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x108 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x109 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x10a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x10b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x10c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x10d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x10e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x10f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x110 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x111 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x112 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x113 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x114 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x115 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x116 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x117 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x118 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x119 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x11a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x11b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x11c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x11d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x11e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x11f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x120 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x121 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x122 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x123 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x124 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x125 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x126 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x127 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x128 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x129 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x12a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x12b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x12c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x12d */
	{ "dummy", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{171,-1,-1}, "dummy",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x12e */
	{ "dokan_sfc", "Pipe from SNES Mario Circuit 3.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{167,-1,-1}, "dokan_sfc(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x12f */
	{ "castletree1", "Unsolid swaying tree from Moo Moo Meadows and Mario Circuit.",
		OBF_OBJECT | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{156,-1,-1}, "castletree1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x130 */
	{ "castletree1c", "Solid swaying tree from Moo Moo Meadows and Mario Circuit.",
		OBF_OBJECT | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_s_to,
		settings_format_uuuu, settings_format_uuuu,
		{156,-1,-1}, "castletree1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x131 */
	{ "castletree2", "Unsolid swaying tree from Moo Moo Meadows and Mario Circuit. The tree turns to look always to the player.",
		OBF_OBJECT | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{157,-1,-1}, "castletree2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x132 */
	{ "castleflower1", "Flower from Mario Circuit.",
		OBF_OBJECT | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{155,-1,-1}, "castleflower1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x133 */
	{ "mariotreeGC", "Unsolid swaying tree from GCN Mario Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{207,-1,-1}, "mariotreeGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x134 */
	{ "mariotreeGCc", "Solid swaying tree from GCN Mario Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_s_to,
		settings_format_uuuu, settings_format_uuuu,
		{207,-1,-1}, "mariotreeGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x135 */
	{ "donkytree1GC", "Unsolid tree from GCN DK Mountain.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{168,-1,-1}, "donkytree1GC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x136 */
	{ "donkytree2GC", "Unsolid tree from GCN DK Mountain.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{169,-1,-1}, "donkytree2GC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x137 */
	{ "peachtreeGC", "Unsolid swaying tree from GCN Peach Beach.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{220,-1,-1}, "peachtreeGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x138 */
	{ "peachtreeGCc", "Solid swaying tree from GCN Peach Beach.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{220,-1,-1}, "peachtreeGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x139 */
	{ "npc_mii_a", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{212,-1,-1}, "npc_mii_a",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x13a */
	{ "npc_mii_b", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{213,-1,-1}, "npc_mii_b",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x13b */
	{ "npc_mii_c", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{214,-1,-1}, "npc_mii_c",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x13c */
	{ "obakeblockSFCc", "Falling blocks from SNES Ghost Valley 2.<br>Only slot 5.3 supports the object's effect and in this slot it isn't scalable; in other slots is scalable but is unsolid and doesn't fall. If using many (>200) obake blocks, slot 5.3 is recommended.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{215,-1,-1}, "obakeblockSFC(B)",
		{ 0,
		  "Time trial and online: T = S2+S3/60. If T>0: delay for automatic fall down since begin of count down in seconds",
		  "Time trial and online: add value/60 to setting 2",
		  0, 0, 0, 0, 0 }},
    /* 0x13d */
	{ "WLarrowGC", "Arrow with eyes from GCN Waluigi Stadium.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{137,-1,-1}, "WLarrowGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x13e */
	{ "WLscreenGC", "TV from GCN Waluigi Stadium. Nintendo disables it online (PFlag = 9).",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{140,-1,-1}, "WLscreenGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x13f */
	{ "WLdokanGC", "Big pipe from GCN Waluigi Stadium, normally combined with `WLwallGC'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{138,-1,-1}, "WLdokanGC(BK)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x140 */
	{ "MarioGo64c", "The \"GO\" sign from N64 Mario Raceway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{84,-1,-1}, "MarioGo64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x141 */
	{ "PeachHunsuiGC", "Fountain from GCN Peach Beach.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{113,-1,-1}, "PeachHunsuiGC(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x142 */
	{ "kinokoT1", "Moving bouncy mushroom decoration from Mushroom Gorge.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{196,-1,-1}, "kinokoT1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x143 */
	{ "kinokoT2", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{197,-1,-1}, "kinokoT2",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x144 */
	{ "pylon01", "Street cone from Daisy Circuit. Only slots 3.1 and 7.1 support this object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{231,-1,-1}, "pylon01(B)",
		{ "Color:<br>0 = Red<br>1 = Blue<br>2 = Yellow",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x145 */
	{ "PalmTree", "Solid palm from Coconut Mall. It's the largest tree of Mario Kart Wii.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{112,-1,-1}, "PalmTree(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x146 */
	{ "parasol", "Parasol from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{219,-1,-1}, "parasol(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x147 */
	{ "cruiser", "Boat from Daisy Circuit and Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{162,-1,-1}, "cruiser(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x148 */
	{ "K_sticklift00", "Barrier gate from DK Summit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{70,-1,-1}, "K_sticklift00(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x149 */
	{ "heyho2", "Shy Guy that goes with a lift; the lift's model is K_chairlift00.brres.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_TRACK,
		obj_charact_r_t,
		settings_format_uuuu, settings_format_uuuu,
		{189,69,-1}, "heyho2(B);K_chairlift00(B)",
		{ "Unknown",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x14a */
	{ "HeyhoTreeGBAc", "Small solid tree from GBA Shy Guy Beach.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{62,-1,-1}, "HeyhoTreeGBA(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x14b */
	{ "MFaceBill", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{76,-1,-1}, "MFaceBill",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x14c */
	{ "truckChimSmk", "Smoke generator on Wario's Gold Mine and Maple Treeway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{244,-1,-1}, "truckChimSmk(BE)",
		{ "Time to start smoking",
		  "Unknown",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x14d */
	{ "MiiObj01", "Mii audience from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{88,-1,-1}, "MiiObj01(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x14e */
	{ "MiiObj02", "Mii audience from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{89,-1,-1}, "MiiObj02(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x14f */
	{ "MiiObj03", "Mii audience from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{90,-1,-1}, "MiiObj03(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x150 */
	{ "gardentreeDS", "Unsolid and thin tree from DS Peach Gardens.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{177,-1,-1}, "gardentreeDS(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x151 */
	{ "gardentreeDSc", "Solid and thin tree from DS Peach Gardens.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{177,-1,-1}, "gardentreeDS(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x152 */
	{ "FlagA1", "Starting line flag from Wario's Gold Mine.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{40,-1,-1}, "FlagA1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x153 */
	{ "FlagA2", "Starting line flag from Moo Moo Meadows.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{41,-1,-1}, "FlagA2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x154 */
	{ "FlagB1", "\"W\" flag from Wario's Gold Mine.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{45,-1,-1}, "FlagB1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x155 */
	{ "FlagB2", "\"L\" Flag from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{46,-1,-1}, "FlagB2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x156 */
	{ "FlagA3", "\"Mario Kart\" flag from DS Delfino Square [http://oi59.tinypic.com/2iabhub.jpg]. Strangely, scales must follow a precise proportion: Xscale < Yscale < Zscale, or game freezes.<br>It's a bit buggy, so it's better use another \"FlagA\" object and import the original texture.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{42,-1,-1}, "FlagA3(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x157 */
	{ "DKtreeA64", "Unsolid tree from N64 DK's Jungle Parkway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{20,-1,-1}, "DKtreeA64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x158 */
	{ "DKtreeA64c", "Solid tree from N64 DK's Jungle Parkway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{20,-1,-1}, "DKtreeA64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x159 */
	{ "DKtreeB64", "Usolid tree from N64 DK's Jungle Parkway with a small crown.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{21,-1,-1}, "DKtreeB64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x15a */
	{ "DKtreeB64c", "Solid tree from N64 DK's Jungle Parkway with a small crown.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{21,-1,-1}, "DKtreeB64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x15b */
	{ "TownTreeDSc", "Solid tree from DS Delfino Square with orange leaves.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{128,-1,-1}, "TownTreeDS(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x15c */
	{ "Piston", "Piston machine decoration from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{114,-1,-1}, "Piston(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x15d */
	{ "oilSFC", "Oil puddle from SNES Mario Circuit 3.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{216,-1,-1}, "oilSFC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x15e */
	{ "DKmarutaGCc", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{16,-1,-1}, "DKmarutaGC",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x15f */
	{ "DKropeGCc", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{18,-1,-1}, "DKropeGC",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x160 */
	{ "mii_balloon", "Floating balloon from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{208,-1,-1}, "mii_balloon(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x161 */
	{ "windmill", "Rotating windmill decoration from Moo Moo Meadows.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{255,-1,-1}, "windmill(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x162 */
	{ "dossun", "Thwomp caged in N64 Bowser's Castle growling when a player approaches; it's an unsolid decoration.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{170,-1,-1}, "dossun(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x163 */
	{ "TownTreeDS", "Unsolid tree from DS Delfino Square with orange leaves.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{128,-1,-1}, "TownTreeDS(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x164 */
	{ "Ksticketc", "Port, opens when approaching.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{75,-1,-1}, "Ksticketc(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x165 */
	{ "monte_a", "Pianta alone.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{210,-1,-1}, "monte_a(B)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x166 */
	{ "MiiStatueM1", "Mario statue from Block Plaza.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{108,-1,-1}, "MiiStatueM1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x167 */
	{ "ShMiiObj01", "Mii audience from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{120,-1,-1}, "ShMiiObj01(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x168 */
	{ "ShMiiObj02", "Mii audience from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{121,-1,-1}, "ShMiiObj02(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x169 */
	{ "ShMiiObj03", "Mii audience from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{122,-1,-1}, "ShMiiObj03(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x16a */
	{ "Hanabi", "Fireworks used in cutsene tracks.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{59,-1,-1}, "Hanabi(E)",
		{ "Unknown",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x16b */
	{ "miiposter", "Mii posters from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{209,-1,-1}, "miiposter(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x16c */
	{ "dk_miiobj00", "Mii audience from DK Summit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{165,-1,-1}, "dk_miiobj00(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x16d */
	{ "light_house", "Lighthouse from Daisy Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{204,-1,-1}, "light_house(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x16e */
	{ "r_parasol", "Parasol from GBA Shy Guy Beach; it opens or closes itself when is hit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{233,-1,-1}, "r_parasol(B)",
		{ "Starting state:<br>0 = Open <br>1 = Closed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x16f */
	{ "obakeblock2SFCc", "Falling blocks from SNES Ghost Valley 2.<br>Only slot 5.3 supports the object's effect and in this slot it isn't scalable; in other slots is scalable but is unsolid and doesn't fall. If using many (>200) obake blocks, slot 5.3 is recommended.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{215,-1,-1}, "obakeblockSFC(B)",
		{ 0,
		  "Time trial and online: T = S2+S3/60. If T>0: delay for automatic fall down since begin of count down in seconds",
		  "Time trial and online: add value/60 to setting 2",
		  0, 0, 0, 0, 0 }},
    /* 0x170 */
	{ "obakeblock3SFCc", "Falling blocks from SNES Ghost Valley 2.<br>Only slot 5.3 supports the object's effect and in this slot it isn't scalable; in other slots is scalable but is unsolid and doesn't fall. If using many (>200) obake blocks, slot 5.3 is recommended.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{215,-1,-1}, "obakeblockSFC(B)",
		{ "If this value is not 0, this block will fall when touched in Grand Prix or VS mode.",
		  "Time trial and online: T = S2+S3/60. If T>0: delay for automatic fall down since begin of count down in seconds",
		  "Time trial and online: add value/60 to setting 2",
		  0, 0, 0, 0, 0 }},
    /* 0x171 */
	{ "koopaFigure", "Bowser statue from Bowser's Castle.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_BRASD | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{199,-1,-1}, "koopaFigure(B2D)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x172 */
	{ "pukupuku", "Cheep Cheep fish.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_M_ARENA,
		obj_charact_ta,
		settings_format_uuuu, settings_format_uuuu,
		{230,-1,-1}, "pukupuku(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x173 */
	{ "v_stand1", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{246,-1,-1}, "v_stand1",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x174 */
	{ "v_stand2", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{247,-1,-1}, "v_stand2",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x175 */
	{ "leaf_effect", "Leaf effect when player drives or flies through tree leafs (use AREA).",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{202,-1,-1}, "leaf_effect(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x176 */
	{ "karehayama", "Leaf pile from Maple Treeway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uxuu, settings_format_uuuu,
		{193,-1,-1}, "karehayama(BE)",
		{ 0,
		  "Item to give",
		  "Chance to give an item",
		  0, 0, 0, 0, 0 }},
    /* 0x177 */
	{ "EarthRing", "Earth luminous ring from Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{28,-1,-1}, "EarthRing(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x178 */
	{ "SpaceSun", "The sun in Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{123,-1,-1}, "SpaceSun(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x179 */
	{ "BlackHole", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{6,-1,-1}, "BlackHole",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x17a */
	{ "StarRing", "The Launch Star from Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{125,-1,-1}, "StarRing(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x17b */
	{ "M_obj_kanban", "Yellow/black fence, can be found in competitions; object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{79,-1,-1}, "M_obj_kanban",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x17c */
	{ "MiiStatueL1", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{105,-1,-1}, "MiiStatueL1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x17d */
	{ "MiiStatueD1", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{102,-1,-1}, "MiiStatueD1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x17e */
	{ "MiiSphinxY1", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{97,-1,-1}, "MiiSphinxY1",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x17f */
	{ "MiiSphinxY2", "Yoshi Sphinx from Dry Dry Ruins.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{98,-1,-1}, "MiiSphinxY2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x180 */
	{ "FlagA5", "Start line flag from Koopa Cape. It's less buggy than `FlagA3'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{44,-1,-1}, "FlagA5(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x181 */
	{ "CarB", "Unsolid car decoration from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{12,-1,-1}, "CarB(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x182 */
	{ "FlagA4", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{43,-1,-1}, "FlagA4",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x183 */
	{ "Steam", "Steam effect from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{126,-1,-1}, "Steam(E)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x184 */
	{ "Alarm", "Alarm effect from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{0,-1,-1}, "Alarm(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x185 */
	{ "group_monte_a", "Pianta audience.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{185,-1,-1}, "group_monte_a(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x186 */
	{ "MiiStatueL2", "Luigi statue from Block Plaza.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{106,-1,-1}, "MiiStatueL2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x187 */
	{ "MiiStatueD2", "Daisy statue from Block Plaza.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{103,-1,-1}, "MiiStatueD2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x188 */
	{ "MiiStatueP1", "Peach statue from Block Plaza.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{110,-1,-1}, "MiiStatueP1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x189 */
	{ "SentakuDS", "Hanging clothes decoration.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{119,-1,-1}, "SentakuDS(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x18a */
	{ "fks_screen_wii", "TV from Funky Stadium.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{174,-1,-1}, "fks_screen_wii(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x18b */
	{ "KoopaFigure64", "Bowser statue from N64 Bowser's Castle; it spits fire for 5 seconds, then doesn't nothing for 3 second, then spits fire again.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{74,-1,-1}, "KoopaFigure64(BE)",
		{ "Unknown, no visible changes",
		  "Fire function:<br>0 = Decoration<br>1 = Obstacle",
		  "Spitting fire start delay in 1/60 seconds after start of countdown.<br>0 = Freeze of the game;<br>240 (F0 in hex) = Starts spitting fire immediately after the \"GO!\"",
		  0, 0, 0, 0, 0 }},
    /* 0x18c */
	{ "b_teresa", "Flying Boos from SNES Ghost Valley 2 controlled by AREA type 07, using exactly one object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{144,-1,-1}, "b_teresa(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x18d */
	{ "MiiStatueDK1", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{104,-1,-1}, "MiiStatueDK1",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x18e */
	{ "MiiKanban", "Luigi face sign from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{87,-1,-1}, "MiiKanban(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x18f */
	{ "BGteresaSFC", "Flying Boo from SNES Ghost Valley 2.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{1,-1,-1}, "BGteresaSFC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x190 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x191 */
	{ "kuribo", "Goomba.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_r_s_to,
		settings_format_uuuu, settings_format_uuuu,
		{201,-1,-1}, "kuribo(B2D)",
		{ "Respawn time",
		  "Speed",
		  "Animation speed",
		  0, 0, 0, 0, 0 }},
    /* 0x192 */
	{ "choropu", "Moving Monty Mole from Moo Moo Meadows.<br>Can't be used together with `choropu2'.<br>Route setting 2: 0 = Burrow, 1 = Pop out.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{158,-1,-1}, "choropu(BE)",
		{ "Speed",
		  "Start delay in 1/60 seconds",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x193 */
	{ "cow", "Master cow following a route followed by some more cows (from Moo Moo Meadows).<br>The master cow starts at the first point of the route, all other cows around the object position.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{160,-1,-1}, "cow(B5D)",
		{ "Number of slave cows following the master cow unordered",
		  "Unknown",
		  "Start delay of the slave cows in 1/60 seconds.<br>The master cow starts a few seconds earlier",
		  0, 0, 0, 0, 0 }},
    /* 0x194 */
	{ "pakkun_f", "Piranha Plant from GCN Mario Circuit, normally combined with `pakkun_dokan'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_s_to,
		settings_format_uuuu, settings_format_uuuu,
		{218,-1,-1}, "pakkun_f(B2D)",
		{ "Idle time in 1/60 seconds between 2 attacks in time trial and online",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x195 */
	{ "WLfirebarGC", "Rotating fire bars from GCN Waluigi Stadium.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{139,-1,-1}, "WLfirebarGC(B)",
		{ "Fireballs per arm",
		  "Rotations X per 360 seconds.<br>Counterclockwise = X<br>Clockwise = 65536 - X",
		  "Fireball distance",
		  "Number or arms",
		  0, 0, 0, 0 }},
    /* 0x196 */
	{ "wanwan", "Chain Chomp. Snaps in a wedge shape that is directed to a given point.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{254,-1,-1}, "wanwan(BE)",
		{ "Length of chain in game units",
		  "Unknown",
		  0,
		  "Let (X,Y) be the the center of the wedge points to, then (X/10) if X positive, 65536+(X/10) if X negative",
		  "Let (X,Y) be the the center of the wedge points to, then (Y/10) if Y positive, 65536+(Y/10) if Y negative",
		  "Time to wander around (in 1/60 seconds); if 0, about 5 seconds is used. Add 3,5 seconds for full cycle time",
		  "(Width of wedge in degrees-35)/2",
		  0 }},
    /* 0x197 */
	{ "poihana", "Cataquack from GCN Peach Beach. It flings players into the air. In GP and VS race, it looks for players. In Time Trials, it flings only if touched.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{228,-1,-1}, "poihana(BE2D)",
		{ "Color.<br>Normal settings:<br>1 = Red:<br>2 = Violet<br>3 = Green<br>Other settings:<br>0 = Violet<br>≥4 = Green",
		  "Units of distance from where `poihana' starts looking for players",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x198 */
	{ "DKrockGC", "Falling rock from GCN DK Mountain, it respawns only if its Route's header has Cycle set to 01. Slot 8.3 enables its SFX.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{17,-1,-1}, "DKrockGC(BE)",
		{ "Not 0: Delay of ~1.5 seconds for the second rock",
		  "Minimal cycle time in 1/60 seconds",
		  "Speed",
		  "Bouncing factor",
		  0, 0, 0, 0 }},
    /* 0x199 */
	{ "sanbo", "Pokey from Dry Dry Desert and DS Desert Hills.<br>Route Setting 1 sets the time in 1/60 seconds of stop in that point.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{235,-1,-1}, "sanbo(BED)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x19a */
	{ "choropu2", "Monty Mole from DS Peach Gardens.<br>Can't be used together with `choropu'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{158,-1,-1}, "choropu(BE)",
		{ "Hide time in 1/60 seconds",
		  "Start delay in 1/60 seconds",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x19b */
	{ "TruckWagon", "Truck from Wario's Gold Mine.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{129,-1,-1}, "TruckWagon(BE)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x19c */
	{ "heyho", "Shy Guy obstacle from DK Summit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{188,-1,-1}, "heyho(B)",
		{ "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x19d */
	{ "Press", "Press from Toad's Factory (over the belts).<br>The entered position is the sleeping position, so must be placed over the ground (600 is the default value); the total cycle time depends on the sleep time and the falling height.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{115,-1,-1}, "Press(BE)",
		{ 0,
		  "Start delay in 1/60 seconds",
		  "Sleep time in 1/60 seconds;<br>Special case 0 = One time shoot",
		  0, 0, 0, 0, 0 }},
    /* 0x19e */
	{ "Press_soko", "Object not used in any track.",
		OBF_OBJFLOW,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x19f */
	{ "pile", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{224,-1,-1}, "pile",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1a0 */
	{ "choropu_ground", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1a1 */
	{ "WLfireringGC", "Rotating fire ring from GCN Waluigi Stadium. Scale settings refer to fireballs' dimensions and position coordinates to center's coordinates.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{139,-1,-1}, "WLfirebarGC(B)",
		{ "Number of fireballs",
		  "Rotations X in 1/60 seconds.<br>Counterclockwise = X<br>Clockwise = 65536 - X",
		  "Pulsation factor, shrinks and enlarges the radius.<br>Special cases:<br> S3 = 0 or S4 = 0 no pulsation;<br> S3 ≥ S4 negative pulsation",
		  "Radius",
		  0, 0, 0, 0 }},
    /* 0x1a2 */
	{ "pakkun_dokan", "Pipe of potted Piranha Plant, normally combined with `pakkun_f'.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{217,-1,-1}, "pakkun_dokan(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1a3 */
	{ "begoman_spike", "Topman from Galaxy Colosseum; object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_s_o,
		settings_format_uuuu, settings_format_uuuu,
		{147,-1,-1}, "begoman_spike(BE)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown" }},
    /* 0x1a4 */
	{ "FireSnake", "Grounded Podoboo from DS Desert Hills. It bounces casually around its position point.<br>It works with the object `sunDS', so it only works on slots 3.1 and 7.1.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{39,-1,-1}, "FireSnake(BE)",
		{ "Route id from where `sunDS' drops",
		  "Time before vanishing in 1/60 seconds",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x1a5 */
	{ "koopaFirebar", "Rotating firebar from Bowser's Castle.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{200,139,-1}, "koopaFirebar(B);WLfirebarGC(B)",
		{ "Number of fireballs per hand",
		  "Rotations X per 1/360 seconds.<br>Counterclockwise = X<br>Clockwise = 65536 - X",
		  "Distance between fireballs",
		  "Number of hands",
		  0, 0, 0, 0 }},
    /* 0x1a6 */
	{ "Epropeller", "Electric propeller from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{33,-1,-1}, "Epropeller(BE)",
		{ "Rotations per 12 seconds",
		  "Direction:<br>0 = Clockwise<br>1 = Counterclockwise",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x1a7 */
	{ "dc_pillar_c", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1a8 */
	{ "FireSnake_v", "Grounded Podoboo from Grumble Volcano. It jump from its position point describing a parabola and after landing bounces casually around the arrival point.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{39,-1,-1}, "FireSnake(BE)",
		{ "Start delay in 1/60 seconds after starting of countdown.<br>240 (F0 in hex) = Starts immediately after the \"GO!\"",
		  "Duration and respawn factor, K reference value is 600 (258 in hex):<br>X < K → Duration time in 1/60 seconds, then respawn without loading vanishing animation;<br>X = K → 10 seconds of duration, then respawn after other 10 seconds;<br>X > K → 10 seconds of duration, then respawn after (X - 600)/60 seconds.<br>Normally is used the third option",
		  "Units of distance from position point to landing point following the Y angulation",
		  0, 0, 0, 0, 0 }},
    /* 0x1a9 */
	{ "honeBall", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{190,-1,-1}, "honeBall",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1aa */
	{ "puchi_pakkun", "Small Pirahna Plant from N64 Mario Raceway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{229,-1,-1}, "puchi_pakkun(BD)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1ab */
	{ "sanbo_big", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{235,-1,-1}, "sanbo(BED)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1ac */
	{ "sanbo_big.2", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{235,-1,-1}, "sanbo(BED)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1ad */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ae */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1af */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1b9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ba */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1bb */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1bc */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1bd */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1be */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1bf */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1c9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ca */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1cb */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1cc */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1cd */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ce */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1cf */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1d9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1da */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1db */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1dc */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1dd */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1de */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1df */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1e9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ea */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1eb */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ec */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ed */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ee */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1ef */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1f0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1f1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1f2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1f3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1f4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x1f5 */
	{ "kinoko_ud", "Moving decoration mushroom from Mushroom Gorge.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_SCALE | OBF_ROTATE | OBF_FALLDOWN | OBF_OBJFLOW | OBF_SOLID | OBF_ROAD | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{195,-1,-1}, "kinoko(B4K)",
		{ "[?] Texturing: <br>0 = Light<br>1 = Dark",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1f6 */
	{ "kinoko_bend", "Bouncy mushroom.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_SCALE | OBF_ROTATE | OBF_FALLDOWN | OBF_OBJFLOW | OBF_SOLID | OBF_ROAD | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{195,-1,-1}, "kinoko(B4K)",
		{ "Texturing: <br>0 = Light<br>1 = Dark",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1f7 */
	{ "VolcanoRock1", "Floating drivable rock (at Grumble Volcano in the lava), it goes up and down and left and right.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{136,-1,-1}, "VolcanoRock1(B2K)",
		{ "Model/Effect/KCL file to use (0 or 1)",
		  "Time to go from x1 to x2 and back in 1/60 seconds",
		  "Max X movement in both directions",
		  "Unknown",
		  "Y movement speed in units/seconds",
		  "Max Y movement",
		  0, 0 }},
    /* 0x1f8 */
	{ "bulldozer_left", "The moving bulldozer from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{150,-1,-1}, "bulldozer_left(BK)",
		{ 0,
		  "Movement Distance",
		  "Movement Time",
		  "Time before starting",
		  "Time of standing still",
		  0, 0, 0 }},
    /* 0x1f9 */
	{ "bulldozer_right", "Moving bulldozer from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{151,-1,-1}, "bulldozer_right(BK)",
		{ 0,
		  "Movement distance",
		  "Movement time",
		  "Time before starting",
		  "Time of standing still",
		  0, 0, 0 }},
    /* 0x1fa */
	{ "kinoko_nm", "Green mushroom.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_SCALE | OBF_ROTATE | OBF_FALLDOWN | OBF_OBJFLOW | OBF_SOLID | OBF_ROAD | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{195,-1,-1}, "kinoko(B4K)",
		{ "Texturing:<br>0 = Light<br>1 = Dark",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1fb */
	{ "Crane", "Crane platform Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{13,-1,-1}, "Crane(BK)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x1fc */
	{ "VolcanoPiece", "Floating, shaking and sinking (driveable) rock from Grumble Volcano.<br>Slot 3.4 enables its SFX",
		OBF_OPTIONAL | OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{135,-1,-1}, "VolcanoPiece1(B42K)",
		{ "Model/KCL reference",
		  "Time until it shakes in seconds (already starts 4 seconds before in-game timer)",
		  "Time it shakes in seconds",
		  "No visible effect, either 0 or S2 + X with 3≤X≤12",
		  "No visible effect, on GV always the same value as S3",
		  "No visible effect, either 0 or S4 + the same X value",
		  "No visible effect, on GV always the same value as S3 and S5",
		  "Time in frames between shaking and falling (always 30 frames on GV)" }},
    /* 0x1fd */
	{ "FlamePole", "Ground fire geyser from Bowser's Castle.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{49,-1,-1}, "FlamePole(BEK)",
		{ "Cycle time in 1/60 seconds + 9 seconds",
		  "Start delay in 1/60 seconds",
		  "Size factor",
		  0, 0, 0, 0, 0 }},
    /* 0x1fe */
	{ "TwistedWay", "Moving section from Bowser's Castle.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{132,-1,-1}, "TwistedWay(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x1ff */
	{ "TownBridgeDSc", "Drawbridge from DS Delfino Square; the bridge in DS Delfino Square is created using two of these objects face to face.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{127,-1,-1}, "TownBridgeDS(B3K)",
		{ "Angle α of inclination in degrees, with 0°≤α<45°; if α ≥ 45° causes beauty flaws and stops the bridge at 45°",
		  "Time in 1/60 seconds used to lift and lower",
		  "Time in 1/60 seconds of stop after lift",
		  "Time in 1/60 seconds of stop after lowering",
		  0, 0, 0, 0 }},
    /* 0x200 */
	{ "DKship64", "Ferry-boat and audience from N64 DK's Jungle Parkway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_TRACK,
		obj_charact_r_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{19,178,180}, "DKship64(BE);group_enemy_a(B);group_enemy_b(B)",
		{ "Speed",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x201 */
	{ "kinoko_kuki", "Object not used in any track.",
		OBF_OBJFLOW | OBF_SOLID,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{-1,-1,-1}, 0,
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x202 */
	{ "DKturibashiGCc", "Bridge from GCN DK Mountain.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_SCALE | OBF_ROTATE | OBF_FALLDOWN | OBF_OBJFLOW | OBF_SOLID | OBF_ROAD | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{22,-1,-1}, "DKturibashiGC(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x203 */
	{ "FlamePoleEff", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{50,-1,-1}, "FlamePoleEff",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x204 */
	{ "aurora", "Moving section from Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{143,-1,-1}, "aurora(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x205 */
	{ "venice_saku", "Fence gate from Delfino Pier.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{251,-1,-1}, "venice_saku(BK)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x206 */
	{ "casino_roulette", "The rotating parts of Chain Chomp Wheel; when used with KCL flag 0x1D, the road slowly rotates around the object counterclockwise.<br/>X, Y and Z positions and rotations need to be 0 and scales need to be 1 in order to work properly.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{153,-1,-1}, "casino_roulette(BK)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x207 */
	{ "BossField01_OBJ1", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{8,-1,-1}, "BossField01_OBJ1",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x208 */
	{ "dc_pillar", "Falling pillar from Dry Dry Ruins.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{163,-1,-1}, "dc_pillar(BEK)",
		{ "Time before falling in 1/60 seconds",
		  "Final angle in degrees<br>(0° = vertical, 90° = horizontal), normally ≥ 90°",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x209 */
	{ "dc_sandcone", "Pile of sand from Dry Dry Ruins.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{164,-1,-1}, "dc_sandcone(BEK)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x20a */
	{ "venice_hasi", "Bridge from Delfino Pier.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{249,-1,-1}, "venice_hasi(BEK)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x20b */
	{ "venice_gondola", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME | OBF_MULTI_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{248,210,-1}, "venice_gondola;monte_a(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x20c */
	{ "quicksand", "Thwomp Desert controller.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{232,170,-1}, "quicksand(BE);dossun(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x20d */
	{ "bblock", "Block parts from Block Plaza, with statues.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_ARENA,
		obj_charact_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{146,99,-1}, "bblock1(B18K);MiiStatue1",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x20e */
	{ "ami", "Bouncing bridge from Maple Treeway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{142,-1,-1}, "ami(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x20f */
	{ "M_obj_jump", "Trick ramp used on backwards competitions; object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{77,-1,-1}, "M_obj_jump",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x210 */
	{ "starGate", "Gates used in some competitions; object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{239,-1,-1}, "starGate",
		{ 0,
		  "Number (ordered)",
		  "Trigger",
		  0, 0, 0, 0, 0 }},
    /* 0x211 */
	{ "RM_ring1", "Driveable ring zones from Galaxy Colosseum; object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_ALWAYS_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_r_s_o,
		settings_format_uuuu, settings_format_uuuu,
		{117,-1,-1}, "RM_ring1(B8K)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x212 */
	{ "FlamePole_v", "Fire geyser without a base.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{51,-1,-1}, "FlamePole_v(BE)",
		{ "?",
		  "Start delay in 1/60 seconds",
		  "Scale factor",
		  "Cycle time in 1/60 seconds + 8,25 seconds",
		  0, 0, 0, 0 }},
    /* 0x213 */
	{ "M_obj_s_jump", "Ramp used on competitions; object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{81,-1,-1}, "M_obj_s_jump",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x214 */
	{ "InsekiA", "Asteroids from Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{63,-1,-1}, "InsekiA(B)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x215 */
	{ "InsekiB", "Star bits from Rainbow Road.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{64,-1,-1}, "InsekiB(B)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x216 */
	{ "FlamePole_v_big", "Really, really big fire geyser without a base from N64 Bowser's Castle.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{52,51,-1}, "FlamePole_v_big(E);FlamePole_v(BE)",
		{ "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0, 0 }},
    /* 0x217 */
	{ "Mdush", "Small jump ramp from Mario Circuit and Moo Moo Meadows.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{86,-1,-1}, "Mdush(BK)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x218 */
	{ "HP_pipe", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{58,-1,-1}, "HP_pipe",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x219 */
	{ "DemoCol", "Collision zone from the losing demo screen, located in a grass part from Mario Circuit; object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_s_o,
		settings_format_uuuu, settings_format_uuuu,
		{23,-1,-1}, "DemoCol(BK)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x21a */
	{ "M_obj_s_jump2", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{82,-1,-1}, "M_obj_s_jump2",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x21b */
	{ "M_obj_jump2", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_SOLID | OBF_FNAME,
		obj_charact_s,
		settings_format_uuuu, settings_format_uuuu,
		{78,-1,-1}, "M_obj_jump2",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x21c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x21d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x21e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x21f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x220 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x221 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x222 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x223 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x224 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x225 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x226 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x227 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x228 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x229 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x22a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x22b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x22c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x22d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x22e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x22f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x230 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x231 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x232 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x233 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x234 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x235 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x236 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x237 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x238 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x239 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x23a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x23b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x23c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x23d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x23e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x23f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x240 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x241 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x242 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x243 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x244 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x245 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x246 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x247 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x248 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x249 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x24a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x24b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x24c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x24d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x24e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x24f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x250 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x251 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x252 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x253 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x254 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x255 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x256 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x257 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x258 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x259 */
	{ "DonkyCannonGC", "DK cannon from GCN DK Mountain.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{26,-1,-1}, "DonkyCannonGC(BED)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x25a */
	{ "BeltEasy", "Second set of belts from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{5,-1,-1}, "BeltEasy(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x25b */
	{ "BeltCrossing", "First set of belts from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{2,-1,-1}, "BeltCrossing(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x25c */
	{ "BeltCurveA", "Third set of belts from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{3,-1,-1}, "BeltCurveA(B)",
		{ 0, 0,
		  "Time until it switches",
		  "Time until it switches back",
		  0, 0, 0, 0 }},
    /* 0x25d */
	{ "BeltCurveB", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{4,-1,-1}, "BeltCurveB",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x25e */
	{ "escalator", "Coconut Mall escalator.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{173,-1,-1}, "escalator(BK)",
		{ 0,
		  "Always the same as S6 in Nintendo tracks.<br>Unknown influence",
		  "Unknown",
		  "Always the same as S6 in Nintendo tracks.<br>Unknown influence",
		  "Unknown",
		  "Speed in units per seconds",
		  0, 0 }},
    /* 0x25f */
	{ "DonkyCannon_wii", "DK cannon from DK Summit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{27,-1,-1}, "DonkyCannon_wii(BED)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x260 */
	{ "escalator_group", "2 Time Escalators from Coconut Mall.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_KCL | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_MULTI_FNAME | OBF_M_TRACK,
		obj_charact_s_t,
		settings_format_uuuu, settings_format_uuuu,
		{173,210,-1}, "escalator(BK);monte_a(B)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0 }},
    /* 0x261 */
	{ "tree_cannon", "Cannon from Maple Treeway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_BRASD | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{243,-1,-1}, "tree_cannon(BED)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x262 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x263 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x264 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x265 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x266 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x267 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x268 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x269 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x26a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x26b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x26c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x26d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x26e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x26f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x270 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x271 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x272 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x273 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x274 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x275 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x276 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x277 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x278 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x279 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x27a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x27b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x27c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x27d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x27e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x27f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x280 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x281 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x282 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x283 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x284 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x285 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x286 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x287 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x288 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x289 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x28a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x28b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x28c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x28d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x28e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x28f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x290 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x291 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x292 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x293 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x294 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x295 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x296 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x297 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x298 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x299 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x29a */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x29b */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x29c */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x29d */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x29e */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x29f */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2a9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2aa */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2ab */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2ac */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2ad */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2ae */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2af */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b0 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b1 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b2 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b3 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b4 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b5 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b6 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b7 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b8 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2b9 */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2ba */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2bb */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2bc */ { 0,0,0,0,0,0, {-1,-1,-1},0, {0,0,0,0,0,0,0,0} },
    /* 0x2bd */
	{ "group_enemy_b", "Enemy audience.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{180,-1,-1}, "group_enemy_b(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2be */
	{ "group_enemy_c", "Toads audience.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{181,-1,-1}, "group_enemy_c(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2bf */
	{ "taimatsu", "Flame of the torches from N64 DK's Jungle Parkway (torches inside the cave) and Bowser Castle (on the wall).",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{242,-1,-1}, "taimatsu(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c0 */
	{ "truckChimSmkW", "Houses' smoke from Delfino Pier.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_SOLID | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_s_a,
		settings_format_uuuu, settings_format_uuuu,
		{245,-1,-1}, "truckChimSmkW(BE)",
		{ 0,
		  "Unknown",
		  0, 0, 0, 0, 0, 0 }},
    /* 0x2c1 */
	{ "Mstand", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{111,-1,-1}, "Mstand",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c2 */
	{ "dkmonitor", "TV screen from DK Summit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{166,-1,-1}, "dkmonitor(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c3 */
	{ "group_enemy_a", "Enemy audience.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{178,-1,-1}, "group_enemy_a(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c4 */
	{ "FlagB3", "Bright Shell Flag from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{47,-1,-1}, "FlagB3(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c5 */
	{ "spot", "Spotlights from Chain Chomp Wheel.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{238,-1,-1}, "spot(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c6 */
	{ "group_enemy_d", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{182,-1,-1}, "group_enemy_d",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c7 */
	{ "FlagB4", "Dark Shell Flag from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{48,-1,-1}, "FlagB4(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c8 */
	{ "group_enemy_e", "Enemy audience from Mario Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{183,-1,-1}, "group_enemy_e(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2c9 */
	{ "group_monte_L", "Enemy audience from Delfino Pier.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{185,-1,-1}, "group_monte_a(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2ca */
	{ "group_enemy_f", "Enemy audience from Mario Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{184,-1,-1}, "group_enemy_f(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2cb */
	{ "FallBsA", "Waterfall from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{34,-1,-1}, "FallBsA(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2cc */
	{ "FallBsB", "Waterfall from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{35,-1,-1}, "FallBsB(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2cd */
	{ "FallBsC", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{36,-1,-1}, "FallBsC",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2ce */
	{ "volsmk", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{253,-1,-1}, "volsmk(E)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0 }},
    /* 0x2cf */
	{ "ridgemii00", "Mii audience from Moonview Highway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{234,-1,-1}, "ridgemii00(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d0 */
	{ "Flash_L", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{54,-1,-1}, "Flash_L(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d1 */
	{ "Flash_B", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{53,-1,-1}, "Flash_B(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d2 */
	{ "Flash_W", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{57,-1,-1}, "Flash_W(E)",
		{ "Unknown",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d3 */
	{ "Flash_M", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{55,-1,-1}, "Flash_M(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d4 */
	{ "Flash_S", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{56,-1,-1}, "Flash_S(E)",
		{ "Unknown",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d5 */
	{ "MiiSignNoko", "Koopa face sign from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{95,-1,-1}, "MiiSignNoko(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d6 */
	{ "UtsuboDokan", "Piped Unagis (eels) from Koopa Cape.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{133,-1,-1}, "UtsuboDokan(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d7 */
	{ "Spot64", "Spotlights from N64 Skyscraper.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{124,-1,-1}, "Spot64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d8 */
	{ "DemoEf", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_o,
		settings_format_uuuu, settings_format_uuuu,
		{24,-1,-1}, "DemoEf(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2d9 */
	{ "Fall_MH", "Part of the waterfall effect from Moonview Highway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{37,-1,-1}, "Fall_MH(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2da */
	{ "Fall_Y", "Part of the waterfall effects from DS Yoshi Falls.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{38,-1,-1}, "Fall_Y(E)",
		{ "Unknown",
		  0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2db */
	{ "DemoJugemu", "Lakitu model from the Mario Circuit winning demo.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_o,
		settings_format_uuuu, settings_format_uuuu,
		{25,-1,-1}, "DemoJugemu(BE)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2dc */
	{ "group_enemy_a_demo", "Enemy audience from the Mario Circuit winning demo.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_o,
		settings_format_uuuu, settings_format_uuuu,
		{179,-1,-1}, "group_enemy_a_demo(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2dd */
	{ "group_monte_a_demo", "Pianta audience from the Mario Circuit winning demo.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_o,
		settings_format_uuuu, settings_format_uuuu,
		{186,-1,-1}, "group_monte_a_demo(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2de */
	{ "volfall", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{252,-1,-1}, "volfall",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2df */
	{ "MiiStatueM2", "Mario statue from DK Summit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{109,-1,-1}, "MiiStatueM2(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e0 */
	{ "RhMiiKanban", "Peach face poster from Moonview Highway.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{118,-1,-1}, "RhMiiKanban(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e1 */
	{ "MiiStatueL3", "Luigi statue from Luigi Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK | OBF_F_OTHER,
		obj_charact_to,
		settings_format_uuuu, settings_format_uuuu,
		{107,-1,-1}, "MiiStatueL3(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e2 */
	{ "MiiSignWario", "Wario Face Sign in Wario's Gold Mine.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{96,-1,-1}, "MiiSignWario(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e3 */
	{ "MiiStatueBL1", "Baby Luigi Statue from Daisy Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{101,-1,-1}, "MiiStatueBL1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e4 */
	{ "MiiStatueBD1", "Baby Daisy Statue from Daisy Circuit.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{100,-1,-1}, "MiiStatueBD1(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e5 */
	{ "Kamifubuki", "Object not used in any track.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_F_OTHER,
		obj_charact_o,
		settings_format_uuuu, settings_format_uuuu,
		{72,-1,-1}, "Kamifubuki(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e6 */
	{ "Crescent64", "Crescent Moon from N64 Skyscraper.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_ARENA,
		obj_charact_a,
		settings_format_uuuu, settings_format_uuuu,
		{14,-1,-1}, "Crescent64(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e7 */
	{ "MiiSighKino", "Toad face sign from Toad's Factory.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{94,-1,-1}, "MiiSighKino(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e8 */
	{ "MiiObjD01", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{91,-1,-1}, "MiiObjD01(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2e9 */
	{ "MiiObjD02", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{92,-1,-1}, "MiiObjD02(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2ea */
	{ "MiiObjD03", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{93,-1,-1}, "MiiObjD03(B)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2eb */
	{ "mare_a", "Toad from GCN Peach Peach.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{205,-1,-1}, "mare_a(B)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x2ec */
	{ "mare_b", "Toad from GCN Peach Peach.",
		OBF_OBJECT | OBF_UNIQUE | OBF_BRRES | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{206,-1,-1}, "mare_b(B)",
		{ 0,
		  "Unknown",
		  "Unknown",
		  "Unknown",
		  0, 0, 0, 0 }},
    /* 0x2ed */
	{ "EnvKareha", "Downward Leaf effect on screen from Maple Treeway; AREA type 0x01 activates this object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{30,-1,-1}, "EnvKareha(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2ee */
	{ "EnvFire", "Lava particle effect from Bowser's Castle; AREA type 0x01 deactivates this object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{29,-1,-1}, "EnvFire(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2ef */
	{ "EnvSnow", "Snow effect from DK Summit; AREA type 0x01 deactivates this object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{32,-1,-1}, "EnvSnow(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2f0 */
	{ "M_obj_start", "Object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{83,-1,-1}, "M_obj_start",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2f1 */
	{ "EnvKarehaUp", "Upward Leaf effect on screen from Maple Treeway; AREA type 0x01 activates this object.",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{31,-1,-1}, "EnvKarehaUp(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2f2 */
	{ "M_obj_kanban_y", "Yellow/black fence with an arrow on it, can be found in competitions; object not used in any track.",
		OBF_OBJECT | OBF_NO_FILE | OBF_OBJFLOW | OBF_FNAME,
		obj_charact,
		settings_format_uuuu, settings_format_uuuu,
		{80,-1,-1}, "M_obj_kanban_y",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
    /* 0x2f3 */
	{ "DKfalls", "Unknown",
		OBF_OBJECT | OBF_UNIQUE | OBF_EFFECT | OBF_OBJFLOW | OBF_NO_ROUTE | OBF_FNAME | OBF_M_TRACK,
		obj_charact_t,
		settings_format_uuuu, settings_format_uuuu,
		{15,-1,-1}, "DKfalls(E)",
		{ 0, 0, 0, 0, 0, 0, 0, 0 }},
};


//
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////   E N D   //////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

