
/***************************************************************************
 *                       _______ _______ _______                           *
 *                      |  ___  |____   |  ___  |                          *
 *                      | |   |_|    / /| |   |_|                          *
 *                      | |_____    / / | |_____                           *
 *                      |_____  |  / /  |_____  |                          *
 *                       _    | | / /    _    | |                          *
 *                      | |___| |/ /____| |___| |                          *
 *                      |_______|_______|_______|                          *
 *                                                                         *
 *                           Wiimms SZS Tools                              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This file is part of the SZS project.                                 *
 *   Visit http://szs.wiimm.de/ for project details and sources.           *
 *                                                                         *
 *   Copyright (c) 2011-2015 by Dirk Clemens <wiimm@wiimm.de>              *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   See file gpl-2.0.txt or http://www.gnu.org/licenses/gpl-2.0.txt       *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   >>>  This file is automatically generated by './src/gen-ui.c'.  <<<   *
 *   >>>                   Do not edit this file!                    <<<   *
 *                                                                         *
 ***************************************************************************/

#include <getopt.h>
#include "ui-wszst.h"

//
///////////////////////////////////////////////////////////////////////////////
///////////////                  OptionInfo[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t OptionInfo[OPT__N_TOTAL+1] =
{
    {0,0,0,0,0,0,0,0}, // OPT_NONE,

    //----- command specific options -----

    {	OPT_TOUCH, false, false, false, false, 0, "touch",
	0,
	"Mark the minimap as modified to force a new calculation of the"
	" translation and inverse matrices."
    },

    {	OPT_AUTO, false, false, false, false, 0, "auto",
	0,
	"Calculate the minimap translations automatically by using the minimum"
	" and maximum vertex coordinates. The 'scale' and 'rotation' fields"
	" are reset. This is done as first action before the SET, CENTER and"
	" the other transformations."
    },

    {	OPT_SET_FLAGS, false, false, false, false, 0, "set-flags",
	"flag",
	"Define the flag values (default 0x31f) of the minimap."
    },

    {	OPT_SET_SCALE, false, false, false, false, 0, "set-scale",
	"vector",
	"Define the scale values (default 1.0) of the minimap. The parameter"
	" is either a vector expression or a comma separated list of"
	" coordinates ('x,z' or 'x,y,z')."
    },

    {	OPT_SET_ROT, false, false, false, false, 0, "set-rot",
	"vector",
	"Define the rotation values (default 0.0) of the minimap. The"
	" parameter is either a vector expression or a comma separated list of"
	" coordinates ('x,z' or 'x,y,z')."
    },

    {	OPT_SET_X, false, false, false, false, 0, "set-x",
	"v1[,v2]",
	"Define 2 values and sort them to define the minimum and maximum"
	" x-coordinates of the minimap. If 'v2' is not entered, '-v1' is used"
	" as second value."
    },

    {	OPT_SET_Y, false, false, false, false, 0, "set-y",
	"v1[,v2]",
	"Define 2 values and sort them to define the minimum and maximum"
	" y-coordinates of the minimap. If 'v2' is not entered, '-v1' is used"
	" as second value."
    },

    {	OPT_SET_Z, false, false, false, false, 0, "set-z",
	"v1[,v2]",
	"Define 2 values and sort them to define the minimum and maximum"
	" z-coordinates of the minimap. If 'v2' is not entered, '-v1' is used"
	" as second value."
    },

    {	OPT_XCENTER, false, false, false, false, 0, "xcenter",
	0,
	"Center the minimap in x-direction. This is done after AUTO and SET,"
	" but before SCALE and SHIFT."
    },

    {	OPT_YCENTER, false, false, false, false, 0, "ycenter",
	0,
	"Center the minimap in y-direction. This is done after AUTO and SET,"
	" but before SCALE and SHIFT."
    },

    {	OPT_ZCENTER, false, false, false, false, 0, "zcenter",
	0,
	"Center the minimap in z-direction. This is done after AUTO and SET,"
	" but before SCALE and SHIFT."
    },

    {	OPT_CENTER, false, false, false, false, 0, "center",
	0,
	"Center the minimap in all 3 directions. This is a short cut for"
	" '--xcenter --ycenter --zcenter'."
    },

    {	OPT_SCALE, false, false, false, false, 0, "scale",
	"vector[@origin]",
	"Transform the data: Scale all coordinates and size values by 'vector'"
	" relative to the point 'origin'. If the origin is not set, 0,0,0 is"
	" used instead.\n"
	"  Negative values mirror the coordinates. Each parameter is either a"
	" vector expression or a comma separated expression list of"
	" coordinates ('x,z' or 'x,y,z').\n"
	"  Transformations are calculated in the order SCALE, SHIFT, ROTATE,"
	" TRANSLATE."
    },

    {	OPT_SHIFT, false, false, false, false, 0, "shift",
	"vector",
	"Transform the data: Add 'vector' to all coordinates. Is's simlar to"
	" --translate, but the addition is done before rotation. The parameter"
	" is either a vector expression or a comma separated expression list"
	" of coordinates ('x,z' or 'x,y,z').\n"
	"  Transformations are calculated in the order SCALE, SHIFT, ROTATE,"
	" TRANSLATE."
    },

    {	OPT_XSS, false, false, false, false, 0, "xss",
	"x1old,x1new,x2old,x2new",
	"--xss (x-scale-shift) calculates the X values of --scale and --shift,"
	" so that the old values are transformed to the new values. The"
	" parameters are numbers or expression."
    },

    {	OPT_YSS, false, false, false, false, 0, "yss",
	"y1old,y1new,y2old,y2new",
	"--yss (y-scale-shift) calculates the Y values of --scale and --shift,"
	" so that the old values are transformed to the new values. The"
	" parameters are numbers or expression."
    },

    {	OPT_ZSS, false, false, false, false, 0, "zss",
	"z1old,z1new,z2old,z2new",
	"--zss (z-scale-shift) calculates the Z values of --scale and --shift,"
	" so that the old values are transformed to the new values. The"
	" parameters are numbers or expression."
    },

    {	OPT_ROT, false, false, false, false, 0, "rot",
	"degree[@origin]",
	"Transform the data: Rotate all coordinates and rotation values by the"
	" angle 'degree' (is a vecotr) around the 3 axes. All 3 axes goes"
	" through the point 'origin'. If the origin is not set, 0,0,0 is used"
	" instead.\n"
	"  Each parameter is either a vector expression or a comma separated"
	" expression list of coordinates ('x,y,z').\n"
	"  Option --rot is an alternative for --xrot, --yrot and --zrot to"
	" define all 3 rotations in one step. Transformations are calculated"
	" in the order SCALE, SHIFT, X-ROTATE, Y-ROTATE, Z-ROTATE, TRANSLATE."
    },

    {	OPT_XROT, false, false, false, false, 0, "xrot",
	"degree[@origin]",
	"Transform the data: Rotate all coordinates and rotation values by the"
	" angle 'degree' around the x-axis, that goes through the point"
	" 'origin'. If the origin is not set, 0,0,0 is used instead.\n"
	"  Each parameter is either a vector expression or a comma separated"
	" expression list of coordinates ('y,z' or 'x,y,z').\n"
	"  Transformations are calculated in the order SCALE, SHIFT, X-ROTATE,"
	" Y-ROTATE, Z-ROTATE, TRANSLATE."
    },

    {	OPT_YROT, false, false, false, false, 0, "yrot",
	"degree[@origin]",
	"Transform the data: Rotate all coordinates and rotation values by the"
	" angle 'degree' around the x-axis, that goes through the point"
	" 'origin'. If the origin is not set, 0,0,0 is used instead. This is a"
	" horizontal counterclockwise rotation and the old option name --hrot"
	" can also used.\n"
	"  Each parameter is either a vector expression or a comma separated"
	" expression list of coordinates ('x,z' or 'x,y,z').\n"
	"  Transformations are calculated in the order SCALE, SHIFT, X-ROTATE,"
	" Y-ROTATE, Z-ROTATE, TRANSLATE."
    },

    {	OPT_ZROT, false, false, false, false, 0, "zrot",
	"degree[@origin]",
	"Transform the data: Rotate all coordinates and rotation values by the"
	" angle 'degree' around the z-axis, that goes through the point"
	" 'origin'. If the origin is not set, 0,0,0 is used instead.\n"
	"  Each parameter is either a vector expression or a comma separated"
	" expression list of coordinates ('x,y' or 'x,y,z').\n"
	"  Transformations are calculated in the order SCALE, SHIFT, X-ROTATE,"
	" Y-ROTATE, Z-ROTATE, TRANSLATE."
    },

    {	OPT_YPOS, false, false, false, false, 0, "ypos",
	"pos",
	"This option defines an Y position for KMP/CKPT transformations. It"
	" has only impact to X and Z rotations (Options --xrot and --zrot). If"
	" not set, the mean y of the active rotation origins are used."
    },

    {	OPT_TRANSLATE, false, false, false, false, 0, "translate",
	"vector",
	"Transform the data: Add 'vector' to all coordinates. Is's simlar to"
	" --shift, but the addition is done after rotation. The parameter is"
	" either a vector expression or a comma separated expression list of"
	" coordinates ('x,z' or 'x,y,z'). --trans is a short cut.\n"
	"  Transformations are calculated in the order SCALE, SHIFT, ROTATE,"
	" TRANSLATE."
    },

    {	OPT_NULL, false, false, false, false, 0, "null",
	0,
	"Create a neutral transformation without affecting the coordinates."
	" The only influence is, that the dependent values (like maximum) are"
	" re-calculated as if a transformation has taken place."
    },

    {	OPT_NEXT, false, false, false, false, 0, "next",
	0,
	"Close the current transformation step with all scaling, shifting,"
	" rotation and translation options and open a new step with cleared"
	" options. On transformation each step is logical done one by one. In"
	" real, one total transformation matrix is calculated and used for"
	" fast transformations.\n"
	"  If option --next is used, the ability for modifying the scale and"
	" rotation vectors (not the positions) of different KMP sections is"
	" nearly always lost. A warning is printed if this occurs."
    },

    {	OPT_ASCALE, false, false, false, false, 0, "ascale",
	"factor@dir",
	"Transform the data and do an axis scale: Close the current"
	" transformation step like --next and scale the data by 'factor' into"
	" the direction given by the vector 'dir'. Store the resulting matrix"
	" as single transformation step and open a new one.\n"
	"  This kind of transformation is EXPERIMENTAL!"
    },

    {	OPT_AROT, false, false, false, false, 0, "arot",
	"degree[@pos1]@pos2",
	"Transform the data and do an axis rotation: Close the current"
	" transformation step like --next and rotate the data by 'degree'"
	" around the axis defined by the 2 points. If 'pos1' is not set, use"
	" 0,0,0 instead. Store the resulting matrix as single transformation"
	" step and open a new one.\n"
	"  This kind of transformation is EXPERIMENTAL!"
    },

    {	OPT_TFORM_SCRIPT, false, false, false, false, 0, "tform-script",
	"script",
	"Load the script and execute it by the text parser.\n"
	" Then for each coordinate (2D and 3D), call the macro TRANSFORM after"
	" all other transformations. Call it without parameters and set"
	" variable $I with a zero based index of all vertices, variable $D to"
	" the dimension (2 or 3) and the variable $P to the vector of the"
	" current vertex. If the macro returns a vector, it is the new"
	" position.\n"
	"  For each file, macro BEGIN is called at the beginning and END after"
	" proccessing all points, but only, if the macros are defined. For"
	" END, variable $I is set to the number of proccessed vertices in the"
	" current file.\n"
	"  Before each macro call, the private and local variables are cleared"
	" and only global parameters are permanent. The zero based index is"
	" cleared for each new source. The parameters of the macro calls are"
	" defined in the local name space."
    },

    {	OPT_MINIMAP, false, false, false, false, 0, "minimap",
	0,
	"Fix the minimap position in the same way as 'wszst MINIMAP --auto'."
	" All other minimap related options are ignored for the minimap"
	" processing. See http://szs.wiimm.de/cmd/wszst/minimap for details."
    },

    {	OPT_RM_GOBJ, false, false, false, false, 0, "rm-gobj",
	"objlist",
	"Remove objects from the KMP section GOBJ. Therefor a comma separated"
	" object list with single values like 'a' or ranges like 'a:b' is"
	" expected. 'a' and 'b' are numbers, object names (prefixed by 'o$')"
	" or any other parser expressions."
    },

    {	OPT_SLOT, false, false, false, false, 0, "slot",
	"keyword",
	"Patch a track file to run at the specified slot. KMP and KCL may be"
	" modified. BRRES files may be added to or removed from SZS. The main"
	" keywords are DAISY, DESERT, SHERBET, SHYGUY, STANDARD and MOST. Slot"
	" numbers (except '42' and '4.2') and different other track names are"
	" also accepted. For some conversions, the auto-add library is needed."
	" See http://szs.wiimm.de/opt/slot for details."
    },

    {	OPT_KCL_FLAG, false, false, false, false, 0, "kcl-flag",
	"joblist",
	"Modify the KCL flag of KCL files. A comma separated job list in the"
	" format 'srclist=dest' is expected. 'srclist' is a plus sign"
	" separated list with single values like <val>, T<type> and"
	" <val>/<mask> or ranges like <val>:<val>, T<type>:<type> and"
	" <val>:<val>/<mask>. '<val>' is a complete KCL flag in the range of"
	" 0..0xffff. '<type>' are only the base types in the range of 0..0x1f."
	" If <mask> is present, it marks the relevant bits. For the T<type>"
	" variant, the mask is set to 0x1f.\n"
	"  All KCL flags of the source list are assigned to the new value"
	" 'dest', but only the set bits of '<mask>' are modified. A later"
	" definition overrides the previous one. See"
	" http://szs.wiimm.de/opt/kcl-flag for details."
    },

    {	OPT_KCL_SCRIPT, false, false, false, false, 0, "kcl-script",
	"script",
	"After reading a KCL source file and executing all transformations,"
	" the text file 'script' is executed by the internal text parser. The"
	" script should use the parser functions tri$*() to read and modify"
	" the triangle positions and flags, or to add or remove complete"
	" triangles.\n"
	"  If this option is used multiple times, each script is executed in"
	" the entered order. See http://szs.wiimm.de/opt/kcl-script for"
	" details."
    },

    {	OPT_FLAG_FILE, false, false, false, false, 0, "flag-file",
	"filename",
	"Define a flag file if scanning an OBJ file (KCL processing). The file"
	" name may contain %-escapes. Set it to an empty string to disable"
	" flag files at all.\n"
	"  The tool search the flag file in the following order until found:"
	" File defined by --flag-file; OBJ file name with replaced extension"
	" ('a.obj' becomes 'a.flag'); OBJ file name with appended extension"
	" ('a.obj' becomes 'a.obj.flag'). See"
	" http://szs.wiimm.de/opt/flag-file for details."
    },

    {	OPT_PATCH_BMG, false, false, false, false, 0, "patch-bmg",
	"mode[=param]",
	"This option specifies a BMG patch mode. Some of the modes need a"
	" parameter or a file name of a BMG patch file (raw or text BMG), both"
	" separated by an equal sign. Modes with required file names are"
	" PRINT, REPLACE, INSERT, OVERWRITE, DELETE, MASK, EQUAL and NOTEQUAL."
	" A mode with text parameter is FORMAT.  Standalone modes are ID,"
	" ID-ALL, UNICODE, RM-ESCAPES, RM-CUPS, CT-COPY, CT-FORCE-COPY and"
	" CT-FILL. Unique abbreviations are allowed.\n"
	"  If this option is used multiple times, all patch files will be"
	" processed in the entered order. Read"
	" http://szs.wiimm.de/opt/patch-bmg for more details."
    },

    {	OPT_MSG, false, false, false, false, 0, "msg",
	"list",
	"If this option is set, the BMG messages are filtered by this list."
	" Only enabled messages are exported to the ouput BMG file (binary or"
	" text).\n"
	"  The parameter is a list of message ids (short MID, 'Txx' or 'Uxx'"
	" or Mxx' or hex number) or message ranges (MID:MID) or one of the"
	" keywords NONE, PARAM, CUPS, TRACKS, ARENAS, CHAT, CTCODE, CTTRACKS"
	" or ALL. If an element is preceeded by a minus sign,  it is removed"
	" from the filter list (disabled)."
    },

    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print in long format. Multiple usage possible."
    },

    {	OPT_CACHE, false, false, false, false, 0, "cache",
	"file",
	"Use the file as cache file. If the parameter is a directory, find a"
	" file with the file name of the destination file. If the file is"
	" valid (same content), then use it as compressed version of the file"
	" and link (or copy if link failed) it to the destination.\n"
	"  If the cache file is not found or the content differ, the file is"
	" (re-)created and exit status 2=differ is returned."
    },

    {	OPT_ID, false, false, false, false, 0, "id",
	0,
	"Print an ID with 8 characters instead of a SHA-1 sum with 40"
	" characters. The SHA-1 sum is used to calculate the ID. The ID"
	" consists of '0'-'9' and 'a'-'w' (32 characters)."
    },

    {	OPT_BASE64, false, false, false, false, 0, "base64",
	0,
	"Encode the the checksum string as BASE64 instead of hex. If --id is"
	" also set, use the alternative charset with '-.*' instead of '+/='."
    },

    {	OPT_VERIFY, false, false, false, false, 0, "verify",
	0,
	"Calculate the checksum and compare the filename and return exit"
	" status (0=valid, 2=differ). The result is valid, if the checksum is"
	" found with a leading and a following point or minus sign. If --quiet"
	" is set, error messages are suppressed."
    },

    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress printing of header and footer."
    },

    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Suppress information lines in decoded text files. This includes"
	" syntax information (--no-header). If set twice, the output of"
	" unneeded sections is also suppressed."
    },

    {	OPT_BMG_INF_SIZE, false, false, false, false, 0, "bmg-inf-size",
	"size",
	"Defines the 'INF0' size of new BMG files between 4 and 1000. The"
	" first 4 bytes of a INF0 record is a pointer to the string and the"
	" remaining bytes the string attributes. However, maximal 20 attribute"
	" bytes are supported and additional bytes are assumed to be NULL. All"
	" BMG files of MKW have a size of 8."
    },

    {	OPT_FORCE_ATTRIB, false, false, false, false, 0, "force-attrib",
	"attrib",
	"Forces, that all attributes are set to this vector. See"
	" http://szs.wiimm.de/doc/bmg/attrib for the syntax."
    },

    {	OPT_DEF_ATTRIB, false, false, false, false, 0, "def-attrib",
	"attrib",
	"Define the default attributes for BMG files. If not set, the default"
	" attributes are estimated. On text output, strings with default"
	" attributes are printed without attribute vector. The usual default"
	" attribute for MKW is [1]. See http://szs.wiimm.de/doc/bmg/attrib for"
	" the syntax."
    },

    {	OPT_NO_ATTRIB, false, false, false, false, 0, "no-attrib",
	0,
	"Suppress the output of any BMG attributes at text BMG files."
    },

    {	OPT_X_ESCAPES, false, false, false, false, 0, "x-escapes",
	0,
	"Use \\x{} escapes instead of \\z{} escapes."
    },

    {	OPT_OLD_ESCAPES, false, false, false, false, 0, "old-escapes",
	0,
	"To be compatible with v1.43 and earlier, print 1A escape sequences"
	" with total size of >12 bytes as single words using \\x{}. Also don't"
	" use \\x{} and \\u{} with parameter lists."
    },

    {	OPT_SINGLE_LINE, false, false, false, false, '1', "single-line",
	0,
	"If set, don't print continuation lines for BMG text output. If set"
	" twice, print only single text lines and suppress attributes like"
	" option --no-attrib does it."
    },

    {	OPT_NO_BMG_COLORS, false, false, false, false, 0, "no-bmg-colors",
	0,
	"If set, suppress the output of '\\c{color}' escape sequences for"
	" colors definitions in BMG text output to be compatible with old"
	" versions of the tools."
    },

    {	OPT_BMG_COLORS, false, false, false, false, 0, "bmg-colors",
	0,
	"Force output of '\\c{color}' escape sequences with names, even for"
	" foreign (not MKWii) BMG files."
    },

    {	OPT_NO_BMG_INLINE, false, false, false, false, 0, "no-bmg-inline",
	0,
	"Print BMG values as separate line before the message definition to be"
	" compatible with versions until v1.39. The output for the standard"
	" value 0x01000000 is always suppressed. This was the default until"
	" v1.43. Since v1.44, --bmg-inline is the default."
    },

    {	OPT_BMG_INLINE, false, true, false, false, 0, "bmg-inline",
	0,
	"[DEPRECATED] Print BMG values between message name and the equal sign"
	" using the format '[...]'. The output for the standard value (usually"
	" 0x01000000) is always suppressed. Since v1.44, the inline mode is"
	" the default. It can be disabled by option --no-bmg-inline to be"
	" compatible with versions until v1.39."
    },

    {	OPT_EXPORT, false, false, false, false, 'X', "export",
	0,
	"Enable the export modus and create small and machine readable text"
	" files for easy post processing. The option works similar like -HBB"
	" for KMP and like -HBl1 for BMG text files."
    },

    {	OPT_NO_PARAM, false, false, false, false, 'P', "no-param",
	0,
	"Disable parameter support in decoded KMP text files."
    },

    {	OPT_SORT, false, false, false, false, 'S', "sort",
	"mode",
	"Define a sort mode. Allowed keywords are: NONE (default), NAME,"
	" OFFSET, U8, PACK, BRRES, BREFT and AUTO"
    },

    {	OPT_TRANSFORM, false, false, false, true, 'x', "transform",
	"list",
	"Convert image formats when reading. A comma separated list with terms"
	" is expected. A term have the syntax '[SRC=]DEST'. It means: convert"
	" SRC format into DEST format. If SRC= is not set, the destination"
	" format is used for all source formats. This makes only sense as last"
	" rule. If DEST is empty no transformation is done for the source."
	" Examples: 'TPL' or 'GRAY' or 'BTI.IA8' or 'TPL.I4+I8=IA8,TEX=,CMPR'\n"
	"  SRC and DEST are tupel of file, image and palette formats and of 2"
	" more attributes. All parts are optional and separated by points, the"
	" order is irrelevant.\n"
	"  Allowed file formats are: TPL, TEX, BTI, BREFT-IMG (=BTIMG), PNG"
	" (import). Allowed image formats are: I4, I8, IA4, IA8, RGB565"
	" (=R565), RGB5A3 (=R3), RGBA32 (=R32), C4, C8, C14X2, CMPR. Allowed"
	" palette formats are: P-IA8 (=P8), P-RGB565 (=P565), P-RGB5A3 (=P3)."
	" Attributtes are PALETTE, NO-PALETTE, GRAY, COLOR, ALPHA and"
	" NO-ALPHA.\n"
	"  All terms are managed as list. For each graphic the list is"
	" iterated until the first SRC tupel of a term matches the graphic."
	" Then the destination tupel is used for the transformation.\n"
	"  The command 'wimgt TEST' prints a clearly arranged readable table"
	" as result of this option."
    },

    {	OPT_ANALYZE, true, false, false, false, 0, "analyze",
	"outfile",
	"Run in analyze mode and write results to the entered file."
    },

    {	OPT_ANALYZE_MODE, true, false, false, false, 0, "analyze-mode",
	"modelist",
	"Comma separated list with objects to analyse. Objects are BRRES,"
	" MDL0, PAT0, TEX0, BREFF, BREFT, TPL, KCL, KMP, GOBJ, MKWANA and ALL"
	" for all (=default). --ana-mode is a short cut."
    },

    {	OPT_SOURCE, false, false, false, true, 's', "src",
	"path",
	"Define a secondary source path (directory/file).\n"
	"  The path may contain escape sequences: %Q is replaced by the fully"
	" qualified primary source name. %P and %F are replaced by the primary"
	" source path or by the filename. %N and %E are replaced by primary"
	" source filename without extension or by the source extension."
	" Finally, %T is replaced by the default extension of a virtual"
	" destination format.\n"
	"  A '?' direct behind '%' in %E and %T conversions avoid that the"
	" same extension is used twice in row. Read"
	" http://szs.wiimm.de/opt/source for more details."
    },

    {	OPT_DEST, false, false, false, false, 'd', "dest",
	"path",
	"Define a destination path (directory/file). The destination - means:"
	" write to standard output.\n"
	"  The path may contain escape sequences: %Q is replaced by the fully"
	" qualified source name. %P and %F are replaced by the source path or"
	" by the filename. %N and %E are replaced by source filename without"
	" extension or by the source extension. Finally, %T is replaced by the"
	" default extension of the destination format.\n"
	"  A '?' direct behind '%' in %E and %T conversions avoid that the"
	" same extension is used twice in row. Read"
	" http://szs.wiimm.de/opt/dest for more details."
    },

    {	OPT_DEST2, false, false, false, false, 'D', "DEST",
	"path",
	"Like --dest, but create the directory path automatically."
    },

    {	OPT_ESC, false, false, false, false, 'E', "esc",
	"char",
	"Define an alternative escape character for destination files. The"
	" default is '%'. For Windows batch files it is a good choice to set"
	" '-E$'."
    },

    {	OPT_OVERWRITE, false, false, false, false, 'o', "overwrite",
	0,
	"Overwrite already existing files without warning and ignore option"
	" --number."
    },

    {	OPT_NUMBER, false, false, false, false, 0, "number",
	0,
	"If a file already exist, append a number directly before the file"
	" extension to make the filename unique. If other numbered files"
	" already exist (ignoring case), use the maximum existing index+1."
	" --num is a short cut."
    },

    {	OPT_REMOVE_SRC, false, false, false, false, 0, "remove-src",
	0,
	"Remove the source file after successful operation. --rm-src is a"
	" short cut."
    },

    {	OPT_REMOVE_DEST, false, false, false, false, 'r', "remove-dest",
	0,
	"Remove already existing files before creating it. If set, --overwrite"
	" is ignored. --rm-dest is a short cut."
    },

    {	OPT_UPDATE, false, false, false, false, 'u', "update",
	0,
	"Create only files that do not exist. Already existing files are"
	" ignored without warning. If set, --overwrite and --remove-dest are"
	" ignored."
    },

    {	OPT_PRESERVE, false, false, false, false, 'p', "preserve",
	0,
	"Preserve file times (atime+mtime) while converting or copying files."
    },

    {	OPT_IGNORE, false, false, false, false, 'i', "ignore",
	0,
	"Ignore non existing source files without warning."
    },

    {	OPT_IGNORE_SETUP, false, false, false, false, 0, "ignore-setup",
	0,
	"Ignore hidden setup file 'wszst-setup.txt'. This file is used to"
	" determine some default settings and to find out sub archives and"
	" files to encode. Use this option only if you know what you do."
    },

    {	OPT_ALIGN_U8, false, false, false, false, 0, "align-u8",
	"size",
	"Define an align value for the sub files in U8 archives. The value"
	" must be a power of 2 and the default value is 32 (0x20) This value"
	" is only relevant if creating or normalizing U8 archives."
    },

    {	OPT_ALIGN_PACK, false, false, false, false, 0, "align-pack",
	"size",
	"Define an align value for the sub files in PACK archives. The value"
	" must be a power of 2 and the default value is 32 (0x20) This value"
	" is only relevant if creating or normalizing OACK archives."
    },

    {	OPT_ALIGN_BRRES, false, false, false, false, 0, "align-brres",
	"size",
	"Define an align value for the sub files in BRRES archives. The value"
	" must be a power of 2 and the default value is 4 This value is only"
	" relevant if creating or normalizing BRRES archives."
    },

    {	OPT_ALIGN_BREFF, false, false, false, false, 0, "align-breff",
	"size",
	"Define an align value for the sub files in BREFF archives. The value"
	" must be a power of 2 and the default value is 4 This value is only"
	" relevant if creating or normalizing BREFF archives."
    },

    {	OPT_ALIGN_BREFT, false, false, false, false, 0, "align-breft",
	"size",
	"Define an align value for the sub files in BREFT archives. The value"
	" must be a power of 2 and the default value is 0x20 This value is"
	" only relevant if creating or normalizing BREFT archives."
    },

    {	OPT_ALIGN, false, false, false, false, 0, "align",
	"size",
	"Define an align value for the sub files in all archives. This is a"
	" short cut for '--align-u8=size --align-pack=size --align-brres=size"
	" --align-breff=size --align-breft=size'."
    },

    {	OPT_ENCODE_ALL, false, false, false, false, 0, "encode-all",
	0,
	"Encode all files. Normally a file is only encoded, if the source is"
	" younger than the destination or the destination is missing. Only"
	" files in the [encode] section of the file 'wszst-setup.txt' are"
	" candidates for encoding. --eall is a short cut. Option --no-encode"
	" takes precedence over --encode-all."
    },

    {	OPT_ENCODE_IMG, false, false, false, false, 0, "encode-img",
	0,
	"Encode all image files. Normally a image file is only encoded, if the"
	" source is younger than the destination or the destination is"
	" missing. Only files in the [encode] section of the file"
	" 'wszst-setup.txt' are candidates for encoding. --eimg is a short"
	" cut. If set, option --no-encode is ignored for images."
    },

    {	OPT_NO_ENCODE, false, false, false, false, 0, "no-encode",
	0,
	"Do not encode files before creating an archive. --noenc is a short"
	" cut. Option --no-encode takes precedence over --encode-all, but"
	" --encode-img takes precedence for images."
    },

    {	OPT_NO_RECURSE, false, false, false, false, 0, "no-recurse",
	0,
	"Do not create archives recursively. Normally files in the [create]"
	" section of the file 'wszst-setup.txt' are created first. --norec is"
	" a short cut."
    },

    {	OPT_AUTO_ADD, false, false, false, false, 0, "auto-add",
	0,
	"Analyze the KMP (if exist) and add missing BRRES, BREFF, BREFT, BRASD"
	" and KCL files automatically, if the tool can find the files in any"
	" sub directory named 'auto-add'. This sub directory is searched in"
	" all directories of 'SEARCH_PATH'; try 'wszst AUTOADD' to view them."
	" Command 'wszst AUTOADD' may also create an auto-add database. --aadd"
	" is a short cut."
    },

    {	OPT_NO_ECHO, false, false, false, false, 0, "no-echo",
	0,
	"Suppress output of @ECHO commands while scanning text files."
    },

    {	OPT_NO_CHECK, false, false, false, false, 'N', "no-check",
	0,
	"Do not make plausibility checks for KCL and KMP files."
    },

    {	OPT_PT_DIR, false, false, false, false, 0, "pt-dir",
	"[=mode]",
	"Set one of the `point directory' modes REMOVE (=0), FORCE (=1) or"
	" AUTO (default). If --pt-dir is used without parameter, then FORCE is"
	" assumed.\n"
	"  This option is only relevant if creating an U8 archive. It decides,"
	" if a special directory with name '.' will be added as base for all"
	" other files."
    },

    {	OPT_RM_AIPARAM, false, false, false, false, 0, "rm-aiparam",
	0,
	"Remove the directory AIParam and all files from the archive. This"
	" option has only impact, if creating a new archive or normalizing an"
	" existing archive. --rmai is a short cut."
    },

    {	OPT_U8, false, false, false, false, 0, "u8",
	0,
	"Create an U8 archive, if possible. If the source is a WU8 archive,"
	" convert it to an U8 archive. This is the default if the setup file"
	" 'wszst-setup.txt' has no other definition. The default compression"
	" mode is set to Yaz0 (see --yaz0)."
    },

    {	OPT_SZS, false, false, false, false, 0, "szs",
	0,
	"Short cut for '--u8 --yaz0': Create an U8 archive, if possible, and"
	" set the compression method to Yaz0."
    },

    {	OPT_WU8, false, false, false, false, 0, "wu8",
	0,
	"Create a WU8 archive, if possible. If the source is an U8 archive,"
	" convert it to a WU8 archive."
    },

    {	OPT_XWU8, true, false, false, false, 0, "xwu8",
	0,
	"Short cut for '--wu8 --xyz': Create a WU8 archive, if possible, and"
	" set the compression method to XYZ."
    },

    {	OPT_WBZ, false, false, false, false, 0, "wbz",
	0,
	"Short cut for '--wu8 --bz': Create a WU8 archive, if possible, and"
	" set the compression method to BZ."
    },

    {	OPT_PACK, false, false, false, false, 0, "pack",
	0,
	"Create a PACK archive."
    },

    {	OPT_BRRES, false, false, false, false, 0, "brres",
	0,
	"Create a BRRES archive."
    },

    {	OPT_BREFF, false, false, false, false, 0, "breff",
	0,
	"Create a BREFF archive."
    },

    {	OPT_BREFT, false, false, false, false, 0, "breft",
	0,
	"Create a BREFT archive."
    },

    {	OPT_NO_COMPRESS, false, false, false, false, 0, "no-compress",
	0,
	"Create an uncompressed file instead of a compressed SZS file. The"
	" default destination changes to '%P/%N%T'. --noc is a short cut."
    },

    {	OPT_COMPR, false, false, false, false, 'C', "compr",
	"level",
	"Define a compression level between 0..9: 0 (or NOCHUNKS) disables"
	" finding chunks, 1 (or FAST) set the fastest real compression and 9"
	" (or BEST) set the best (=default) compression. The special value"
	" UNCOMPRESSED acts like option --no-compress.\n"
	"  Because of many repeated data, the best bz-compression mode varies."
	" Therefor the levels TRY2..TRY5 (or short T2..T5) are defined to find"
	" the best compression mode with testing the first N modes of 9, 1, 8,"
	" 2, 5. TRY2 is used for normalizing. For non bz-compression, TRY* are"
	" the same as BEST.\n"
	"  Option --norm takes precedence over --compr and sets the"
	" compression level to TRY2 (BEST)."
    },

    {	OPT_FAST, false, false, false, false, 0, "fast",
	0,
	"Short cut for --compr=fast: Set the fastest real compression. It also"
	" overrides compression rates set by --norm or --compr."
    },

    {	OPT_NORM, false, false, false, false, 'n', "norm",
	0,
	"The uncompressed data will be normalized. See command NORMALIZE for"
	" more details."
    },

    {	OPT_RECURSE, false, false, false, true, 'R', "recurse",
	"[=level]",
	"If a extracted file is a known and supported archive, than extract it"
	" recursively until the entered level is reached. Level 0 (=NONE)"
	" deactivates this. If --recurse is used without parameter, then"
	" UNLIMITED is assumed.\n"
	"  -R does'nt accept a parameter and is a short cut for"
	" --recurse=unlimited."
    },

    {	OPT_EXT, false, false, false, false, 'e', "ext",
	0,
	"For BRRES archives only: If a file is extracted, add a handy file"
	" extension like '.mdl' to the file name. If set twice and a textual"
	" file magic is available, use the file magic in lower case instead"
	" like '.mdl0'."
    },

    {	OPT_DECODE, false, false, false, false, 0, "decode",
	0,
	"If a extracted file is known and can be decoded, do it. --dec is a"
	" short cut."
    },

    {	OPT_N_MIPMAPS, false, false, false, false, 0, "n-mipmaps",
	"num",
	"Force the number of mipmaps. Values between 0 and 20 are allowed."
	" Value AUTO (default) enabless automatic detection. The creation of"
	" mipmaps stops if the witdh or the height of the mipmap becomes 0."
	" --n-mm is a short cut."
    },

    {	OPT_MIPMAP_SIZE, false, false, false, false, 0, "mipmap-size",
	"num",
	"Define the minimal width and minimal height of a generated mipmap."
	" The default is 16. Tools before v1.49 used 1 as not alterable value."
	" --mm-size is a short cut."
    },

    {	OPT_MIPMAPS, false, false, false, false, 0, "mipmaps",
	0,
	"If reading a source, scan for mipmaps and load them too. For PNG"
	" files, files named NAME.mm#.EXT with #=1.. are searched. This is the"
	" default."
    },

    {	OPT_NO_MIPMAPS, false, false, false, false, 0, "no-mipmaps",
	0,
	"If reading a source, ignore mipmaps. This disables not the creation"
	" of mipmaps (see -n-mipmaps). --no-mm is a short cut."
    },

    {	OPT_SMART, false, false, false, false, 0, "smart",
	0,
	"If resizing an image, use the new smart resize function. The new"
	" function is much slower (factor 2-4) than the old function, but"
	" creates much better resized images. This is only relevant for"
	" creating mipmaps with odd width or height."
    },

    {	OPT_CUT, false, false, false, false, 0, "cut",
	0,
	"Cut different non archive files into smaller peaces (logical units"
	" like headers, groups, sections) or list these peaces as single sub"
	" files for a more detailed analysis. Supported file types are BMG,"
	" BREFT-IMG, KMP, PAT, TEX, TPL, BRRES sub files and more."
    },

    {	OPT_ALL, false, false, false, false, 'a', "all",
	0,
	"Extract and decode all known and supported files recursively. This is"
	" a short cut for '--recurse --decode --mipmaps'. If entered twice,"
	" option --cut is included too."
    },

    {	OPT_RAW, false, false, false, false, 0, "raw",
	0,
	"Extract BRRES sub file in raw mode and do not adjust string pointers"
	" and other offsets."
    },

    {	OPT_SECTIONS, false, false, false, true, 0, "sections",
	0,
	"Print in machine readable sections and parameter lines."
    },

    {0,0,0,0,0,0,0,0}, // OPT__N_SPECIFIC == 113

    //----- global options -----

    {	OPT_VERSION, false, false, false, false, 'V', "version",
	0,
	"Stop parsing the command line, print a version info and exit."
    },

    {	OPT_HELP, false, false, false, false, 'h', "help",
	0,
	"Stop parsing the command line, print a help message and exit."
    },

    {	OPT_XHELP, false, false, false, false, 0, "xhelp",
	0,
	"Stop parsing the command line and print a help message with all"
	" commands included. Exit after printing."
    },

    {	OPT_ALLOW_ALL, false, false, false, false, 0, "allow-all",
	0,
	"Usually commands accept only options with impact to the command. All"
	" other options fire a syntax error. But if --allow-all is set, all"
	" commands accept all options.\n"
	"  This makes changing the command of a long command line without"
	" removing useless options easier. It also helps to override wrong"
	" option permissions."
    },

    {	OPT_COMPATIBLE, false, false, false, false, 0, "compatible",
	"vers",
	"The option expects a version number (format '#.##' or 'v#.##') or a"
	" revision number (format 'r#') as parameter. If set, the tools try to"
	" create BMG and KMP text files, that are compatible to the entered"
	" version of the tools. This may override other legacy options."
    },

    {	OPT_WIDTH, false, false, true, false, 0, "width",
	"width",
	"Define the width (number of columns) for help and some other messages"
	" and disable the automatic detection of the terminal width."
    },

    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Be quiet and print only error messages. Multiple usage is possible."
	" The impact is command dependent."
    },

    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Be verbose and print more progress information. Multiple usage is"
	" possible. The impact is command dependent."
    },

    {	OPT_DE, false, false, false, false, 0, "de",
	0,
	"Use german track and arena names."
    },

    {	OPT_COLOR, false, false, true, false, 0, "color",
	0,
	"Force colorized text. This is the default, if an output file is a"
	" terminal. But colorized text is only supported for a few messages.\n"
	"  If a command is prefixed by 'C-', then this option is set"
	" automatically."
    },

    {	OPT_NO_COLOR, false, false, true, false, 0, "no-color",
	0,
	"Deactive colorized text. This is the default, if an output file is"
	" not a terminal."
    },

    {	OPT_CT_CODE, false, false, false, false, 0, "ct-code",
	0,
	"Enable the CT-CODE modus. See http://szs.wiimm.de/opt/ctcode for"
	" details."
    },

    {	OPT_CHDIR, false, false, false, false, 0, "chdir",
	"dir",
	"Set a new working directory for all following options, for all"
	" parameters and for the command execution. This option can be used"
	" multiple times, but for parameter parsing and for command execution"
	" only the last usage is relevant. Nevertheless, '@param' values are"
	" scanned while reading the command line."
    },

    {	OPT_CONST, false, false, false, false, 'c', "const",
	"list",
	"Define constant values, that are used by the internal encoders and by"
	" the numeric options as predefined global variables. This option"
	" allows a conditional encoding of text files. It can be used multiple"
	" times for multiple definitions.\n"
	"  The Parameter is a comma separated list of terms and a term is"
	" 'name=expression'. The expression is calculated by the text parser."
    },

    {	OPT_LOAD_KCL, false, false, false, false, 0, "load-kcl",
	"file",
	"Load a KCL or OBJ file for reference issues."
    },

    {	OPT_KCL, false, false, false, false, 0, "kcl",
	"list",
	"Set global options for KCL processing. Parameter 'list' is a comma"
	" separated list of keywords. A minus sign before a keyword disables a"
	" setting. Each occurrence of the option will only change entered"
	" settings and all other settings are untouched.\n"
	"  Keyword DEFAULT resets the default settings and CLEAR disables all."
	" Keywords SMALL, MEDIUM and CHARY select the default parameters for"
	" the octree creation. The other allowed keywords are: FAST, NEW,"
	" CENTER, ROUND, NORMALS, MTL, WIIMM, TRIANGLES, OUT-SWAP, G, USEMTL,"
	" CLIP, IN-SWAP, AUTO, HEX4, HEX23, HEX, DROP-UNUSED, DROP-FIXED,"
	" DROP-INVALID, DROP, RM-FACEDOWN, RM-FACEUP, FIX-ALL, CONV-FACEUP,"
	" SORT, INPLACE, SILENT and LOG. See http://szs.wiimm.de/opt/kcl for"
	" details."
    },

    {	OPT_KMP, false, false, false, false, 0, "kmp",
	"list",
	"Set global options for KMP processing. Parameter 'list' is a comma"
	" separated list of keywords. A minus sign before a keyword disables a"
	" setting. Each occurrence of the option will only change entered"
	" settings and all other settings are untouched.\n"
	"  Keyword DEFAULT resets the default settings and CLEAR disables all."
	" The other allowed keywords are: FORCE, NEW, RM-SPCITEM, LEFT, RIGHT,"
	" WIDE, NARROW, FIX-CKPH, FIX-ENPH, FIX-ITPH, FIX-PH, FIX-CKNEXT,"
	" FIX-CKJGPT, FIX-CK, FIX-ALL, 1LAP, 2LAPS ... 9LAPS, INPLACE, SILENT"
	" and LOG. See http://szs.wiimm.de/opt/kmp for details."
    },

    {	OPT_SPEED_MOD, false, false, false, false, 0, "speed-mod",
	"factor",
	"The speed modifier is a user extensions to change the basic speed of"
	" all vehicles. The speed factor itself is stored into KMP/STGI"
	" section of a track.\n"
	"  If --speed-mod is set to a value >0.0, then the last 2 bytes  of"
	" the STGI section are patched. The value 0.0 reset these 2 bytes and"
	" deactivates the speed modifier."
    },

    {	OPT_TFORM_KMP, false, false, false, false, 0, "tform-kmp",
	"list",
	"Select KMP sections and objects for a transformation. --tkmp is a"
	" short cut. The option expects a comma separated list of keywords."
	" Non ambiguous of keywords are allowed and minus signs within"
	" keywords are optional (e.g. GOBJS). A minus sign before a keyword"
	" disables transformation of the related section or object.\n"
	"  Sections are selected by the KMP section names AREA, CAME, CKPT,"
	" CNPT, ENPT, GOBJ, ITPT, JGPT, KTPT, MSPT and POTI.\n"
	"  Objects are selected by the keywords AREA-POSITION, AREA-ROTATE,"
	" AREA-SCALE, CAME-POSITION, CKPT-POSITION, CNPT-POSITION,"
	" CNPT-ROTATE, ENPT-POSITION, ENPT-SCALE, GOBJ-POSITION, GOBJ-ROTATE,"
	" GOBJ-SCALE, ITPT-POSITION, ITPT-SCALE, JGPT-POSITION, JGPT-ROTATE,"
	" KTPT-POSITION, KTPT-ROTATE, MSPT-POSITION, MSPT-ROTATE and"
	" POTI-POSITION.\n"
	"  The keywords NONE and ALL (default) complete the field."
    },

    {	OPT_MDL, false, false, false, false, 0, "mdl",
	"list",
	"Set global options for MDL processing. To enable MDL patching, use"
	" option --patch-file to select BRRES files for patching.\n"
	"  Parameter 'list' is a comma separated list of keywords. A minus"
	" sign before a keyword disables a setting. Each occurrence of the"
	" option will only change entered settings and all other settings are"
	" untouched.\n"
	"  A MDL transformation (controlled by the transformation options) is"
	" only done, if at least one of the keywords VECTOR or VERTEX is set.\n"
	"  Keyword DEFAULT resets the default settings (VERTEX) and CLEAR"
	" disables all. The other allowed keywords are: VECTOR, MATRIX,"
	" VERTEX, PARENT, CHILD and LOG. See http://szs.wiimm.de/opt/mdl for"
	" details."
    },

    {	OPT_PAT, false, false, false, false, 0, "pat",
	"list",
	"Set global options for PAT processing. Parameter 'list' is a comma"
	" separated list of keywords. A minus sign before a keyword disables a"
	" setting. Each occurrence of the option will only change entered"
	" settings and all other settings are untouched.\n"
	"  Keyword DEFAULT resets the default settings and CLEAR disables all."
	" The other allowed keywords are: AUTO, SIMPLE, COMPLEX, BOTH, SILENT"
	" and LOG. See http://szs.wiimm.de/opt/pat for details."
    },

    {	OPT_PATCH_FILE, false, false, false, false, 0, "patch-file",
	"list",
	"Define, which kind of KMP, KCL and BRRES/MDL files are objects for"
	" patching. --pfile is a short cut.\n"
	"  Parameter 'list' is a comma separated list of keywords. A minus"
	" sign before a keyword disables a setting. Each occurrence of the"
	" option will only change entered settings and all other settings are"
	" untouched.\n"
	"  Keyword DEFAULT resets the default settings (TRACK,LOG) and CLEAR"
	" disables all. The other allowed keywords are: KMP, KCL, OTHER-KCL,"
	" ALL-KCL, MODEL, MAP, VRCORN, OTHER-BRRES, ALL-BRRES, TRACK"
	" (=KMP,KCL,MODEL,MAP,VRCORN), ALL, LOG and LOG-ALL. See"
	" http://szs.wiimm.de/opt/patch for details."
    },

    {	OPT_LOGGING, false, false, false, false, 'L', "logging",
	0,
	"This debug option enables the logging of internal lists and maps."
    },

    {	OPT_MAX_FILE_SIZE, false, false, false, false, 'M', "max-file-size",
	"size",
	"This security option defines the maximum file size for input files;"
	" larger files are ignored with a warning. The default unit is MiB and"
	" the default size is 100 MiB; that should be enough for standard"
	" usage."
    },

    {	OPT_TRACKS, false, false, false, false, 'T', "tracks",
	"tracks",
	"Define a new track order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are track names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned track. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Tracks will only be exchanged so that always all tracks are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_ARENAS, false, false, false, false, 'A', "arenas",
	"arenas",
	"Define a new arena order. A comma separated list in the format [a=]b"
	" or a:=b is expected. 'a' and 'b' are arena names or slot numbers."
	" 'a' is the destination slot and 'b' the assigned arena. If 'a' is"
	" omitted, the next slot is used; this means [a=]b,c,d is possible.\n"
	"  Arenas will only be exchanged so that always all arenas are"
	" assigned. But if using ':=' the new slots are assigned without"
	" exchanging and the old values are lost."
    },

    {	OPT_AUTOADD_PATH, false, false, false, false, 0, "autoadd-path",
	"directory",
	"Define an alternative directory as autoadd library. The default is,"
	" that the sub-directory called './auto-add/' of all search pathes are"
	" used. Use 'wszst test -vvvv' for tests."
    },

    {	OPT_UTF_8, true, false, false, true, 0, "utf-8",
	0,
	"Enables UTF-8 support for filenames (default)."
    },

    {	OPT_NO_UTF_8, true, false, false, false, 0, "no-utf-8",
	0,
	"Disables UTF-8 support for filenames."
    },

    {	OPT_TEST, false, false, false, true, 't', "test",
	0,
	"Run in test mode, modify nothing.\n"
	">>> USE THIS OPTION IF UNSURE! <<<"
    },

    {	OPT_FORCE, false, false, false, false, 0, "force",
	0,
	"The tools analyse input files and reject files with invalid data"
	" structures. If --force is set, little repairable issues are ignored"
	" and a warning is printed.\n"
	"Option '--kmp force' does the same, but only for KMP files.\n"
	">>> THE RESULT MAY BE INVALID OUTPUT FILES! <<<"
    },

    {	OPT_YAZ0, false, false, false, false, 0, "yaz0",
	0,
	"If creating a compressed file, force Yaz0 compression. Yaz0"
	" compression is the default, if no compression method is defined by"
	" option or setup file."
    },

    {	OPT_YAZ1, false, false, false, false, 0, "yaz1",
	0,
	"If creating a compressed file, force Yaz1 compression. The difference"
	" to Yaz0 is only the magic, which is set to 'Yaz1'."
    },

    {	OPT_XYZ, false, false, false, false, 0, "xyz",
	0,
	"If creating a compressed file, force XYZ compression (an experimental"
	" Yaz0 variant)."
    },

    {	OPT_BZ, false, false, false, false, 0, "bz",
	0,
	"If creating a compressed file, force BZ compression (a BZIP2"
	" variant)."
    },

    {	OPT_OLD, true, false, false, false, 0, "OLD",
	0,
	"Use old implemenation if available."
    },

    {	OPT_NEW, true, false, false, false, 0, "NEW",
	0,
	"Use new implemenation if available."
    },

    {	OPT_EXTRACT, true, false, false, false, 0, "EXTRACT",
	"dir",
	"Create the directory and extract different objects in different"
	" formats at the moment when they are seen. This is a development"
	" helper option."
    },

    {0,0,0,0,0,0,0,0} // OPT__N_TOTAL == 151

};

//
///////////////////////////////////////////////////////////////////////////////
///////////////             alternate option infos              ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t option_grp_TEXTOUT_NO_HEADER =
    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in decoded text files."
    };

static const InfoOption_t option_grp_ENCODE_ALL =
    {	OPT_ALL, false, false, false, false, 'a', "all",
	0,
	" Encode all files. This is a short cut for --encode-all (and more"
	" options in the future)."
    };

static const InfoOption_t option_cmd_VERSION_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print only the version number, revision and system. If set twice,"
	" print only the version number."
    };

static const InfoOption_t option_cmd_VERSION_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print in long format. Ignored if option --sections is set."
    };

static const InfoOption_t option_cmd_TEST_VERBOSE =
    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Print the matrices of transformations."
    };

static const InfoOption_t option_cmd_COLORS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print also a list of all colored text types."
    };

static const InfoOption_t option_cmd_ERROR_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print a message text instead of a message name."
    };

static const InfoOption_t option_cmd_FILETYPE_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print an additional column with the decompressed file type and"
	" version. If entered twice, a validation status column is added."
    };

static const InfoOption_t option_cmd_FUNCTIONS_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Suppres the output of the description and print only the function"
	" type and syntax."
    };

static const InfoOption_t option_cmd_FUNCTIONS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Normally only the function syntax is searched for the entered keys."
	" But if --long is set, a description is searched too."
    };

static const InfoOption_t option_cmd_MATRIX_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"If set once, suppress vector dumps for transformation steps and"
	" ignore option --long. If set twice, suppress vector dump for final"
	" transformation too."
    };

static const InfoOption_t option_cmd_MATRIX_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set once, print inverse matrix for the final transformation. If"
	" set twice, print inverse matrix for all transformations."
    };

static const InfoOption_t option_cmd_MATRIX_QUIET =
    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Option --quiet is dedicated to automatic tests comparing the old and"
	" new transformation algorithms. If set once, the tables are only"
	" printed, if the results differ. If set twice, nothing is printed at"
	" all and only the exit status will inform about the results."
    };

static const InfoOption_t option_cmd_AUTOADD_QUIET =
    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	" If set, suppress logging."
    };

static const InfoOption_t option_cmd_AUTOADD_VERBOSE =
    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"If set, list all missed files of the current auto-add archive after"
	" adding the adding operation. If set twice, then additionally list"
	" first all already existing files in the current auto-add archive."
    };

static const InfoOption_t option_cmd_AUTOADD_DEST =
    {	OPT_DEST, false, false, false, false, 'd', "dest",
	"path",
	"Define a destination directory as current auto-add archive. The"
	" default is the standard auto-add path. Try AUTOADD without sources"
	" to view the path."
    };

static const InfoOption_t option_cmd_AUTOADD_OVERWRITE =
    {	OPT_OVERWRITE, false, false, false, false, 'o', "overwrite",
	0,
	"Overwrite already existing files instead of only adding new files to"
	" the auto-add archive."
    };

static const InfoOption_t option_cmd_TRACKS_VERBOSE =
    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Print an additonally hex status value as second column before the"
	" file name. These values can be used to find a selection mask."
    };

static const InfoOption_t option_cmd_TRACKS_ALL =
    {	OPT_ALL, false, false, false, false, 'a', "all",
	0,
	"Print the '_d' files too. If set twice, all files listed (same as"
	" -all)."
    };

static const InfoOption_t option_cmd_TRACKS_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print 5 non track files too. If set twice, print 4 more files with"
	" old BRRES sub file formats too."
    };

static const InfoOption_t option_cmd_LIST_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set, the size of each file is printed. If set twice, offset and"
	" size are printed. If set three times, debugging mode is enabled."
    };

static const InfoOption_t option_cmd_ILIST_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set, image width, height and size are printed. If set twice, a"
	" block info and attribites are printed too."
    };

static const InfoOption_t option_cmd_MEMORY_DECODE =
    {	OPT_DECODE, false, false, false, false, 0, "decode",
	0,
	"Decode binary files to find memory addresses of sections."
    };

static const InfoOption_t option_cmd_MEMORY_MIPMAPS =
    {	OPT_MIPMAPS, false, false, false, false, 0, "mipmaps",
	0,
	"Analyze images and dump mipmap adresses too."
    };

static const InfoOption_t option_cmd_MEMORY_ALL =
    {	OPT_ALL, false, false, false, false, 'a', "all",
	0,
	"A short cut for '--recurse --decode --mipmaps'. If entered twice,"
	" option --cut is included too."
    };

static const InfoOption_t option_cmd_MEMORY_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set, print absolute offsets too."
    };

static const InfoOption_t option_cmd_SHA1_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Suppress output of the filename."
    };

static const InfoOption_t option_cmd_SHA1_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set, start the line with the length of the decompressed source as"
	" decimal number (field width 9) separated with a comma from the SHA1"
	" checksum. If set twice, prefix each line with the modification time"
	" in the format 'yyyy-mm-dd HH:MM:SS '."
    };

static const InfoOption_t option_cmd_DIFF_QUIET =
    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"If set once, only a summary status is printed. If set twice, the"
	" status is only reported as exit status."
    };

static const InfoOption_t option_cmd_CHECK_NO_CHECK =
    {	OPT_NO_CHECK, false, false, false, false, 'N', "no-check",
	0,
	"Don't check the KCL and KMP files."
    };

static const InfoOption_t option_cmd_CHECK_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print only warnings and suppress hints."
    };

static const InfoOption_t option_cmd_CHECK_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Be verbose and print more statistics."
    };

static const InfoOption_t option_cmd_CHECK_QUIET =
    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Be quiet until the first warning or hint is found."
    };

static const InfoOption_t option_cmd_SLOTS_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Print the slot list in a compressed form without spaces."
    };

static const InfoOption_t option_cmd_STGI_IGNORE =
    {	OPT_IGNORE, false, false, false, false, 'i', "ignore",
	0,
	"If set, ignore non existing source files and files without KMP"
	" without warning. If set twice, ignore files with standard settings"
	" too."
    };

static const InfoOption_t option_cmd_MINIMAP_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"If set, print the matrices too. If set twice, print minimum and"
	" maximum values too."
    };

static const InfoOption_t option_cmd_BMG_NO_HEADER =
    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in decoded text files."
    };

static const InfoOption_t option_cmd_BMG_LONG =
    {	OPT_LONG, false, false, false, false, 'l', "long",
	0,
	"Print long numeric message IDs instead of alternative message names"
	" like Txx, Uxx or Mxx."
    };

static const InfoOption_t option_cmd_KCL_NO_HEADER =
    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in decoded text files."
    };

static const InfoOption_t option_cmd_KMP_NO_HEADER =
    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress the syntax information section in decoded text files."
    };

static const InfoOption_t option_cmd_INFO_NO_HEADER =
    {	OPT_NO_HEADER, false, false, false, false, 'H', "no-header",
	0,
	"Suppress output of the printed filename."
    };

static const InfoOption_t option_cmd_VEHICLE_SOURCE =
    {	OPT_SOURCE, false, false, false, false, 's', "src",
	"path",
	"Load the file instead of using the internal base."
    };

static const InfoOption_t option_cmd_VEHICLE_DEST =
    {	OPT_DEST, false, false, false, false, 'd', "dest",
	"path",
	"Define a destination path (directory/file). The destination - means:"
	" write to standard output."
    };

static const InfoOption_t option_cmd_VEHICLE_QUIET =
    {	OPT_QUIET, false, false, false, false, 'q', "quiet",
	0,
	"Suppress logging."
    };

static const InfoOption_t option_cmd_VEHICLE_VERBOSE =
    {	OPT_VERBOSE, false, false, false, false, 'v', "verbose",
	0,
	"Log patching."
    };

static const InfoOption_t option_cmd_VEHICLE_BRIEF =
    {	OPT_BRIEF, false, false, false, false, 'B', "brief",
	0,
	"Suppress min/max counts on dumps."
    };


//
///////////////////////////////////////////////////////////////////////////////
///////////////                  CommandTab[]                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const KeywordTab_t CommandTab[] =
{
    { CMD_VERSION,	"VERSION",	0,		0 },
    { CMD_HELP,		"HELP",		"H",		0 },
    { CMD_HELP,		"?",		0,		0 },
    { CMD_ARGTEST,	"ARGTEST",	0,		0 },
    { CMD_TEST,		"TEST",		0,		0 },
    { CMD_COLORS,	"COLORS",	0,		0 },
    { CMD_ERROR,	"ERROR",	"ERR",		0 },
    { CMD_FILETYPE,	"FILETYPE",	"FT",		0 },
    { CMD_FILEATTRIB,	"FILEATTRIB",	"FA",		0 },
    { CMD_SYMBOLS,	"SYMBOLS",	0,		0 },
    { CMD_FUNCTIONS,	"FUNCTIONS",	0,		0 },
    { CMD_CALCULATE,	"CALCULATE",	0,		0 },
    { CMD_MATRIX,	"MATRIX",	0,		0 },
    { CMD_FLOAT,	"FLOAT",	0,		0 },
    { CMD_AUTOADD,	"AUTOADD",	0,		0 },
    { CMD_TRACKS,	"TRACKS",	0,		0 },
    { CMD_EXPORT,	"_EXPORT",	0,		0 },
    { CMD_CODE,		"_CODE",	0,		0 },
    { CMD_RECODE,	"_RECODE",	0,		0 },
    { CMD_SUBFILE,	"_SUBFILE",	0,		0 },
    { CMD_LIST,		"LIST",		"LS",		0 },
    { CMD_LIST_L,	"LIST-L",	"LL",		0 },
    { CMD_LIST_L,	"LISTL",	0,		0 },
    { CMD_LIST_LL,	"LIST-LL",	"LLL",		0 },
    { CMD_LIST_LL,	"LISTLL",	0,		0 },
    { CMD_LIST_LLL,	"LIST-LLL",	"LLLL",		0 },
    { CMD_LIST_LLL,	"LISTLLL",	0,		0 },
    { CMD_LIST_A,	"LIST-A",	"LA",		0 },
    { CMD_LIST_A,	"LISTA",	0,		0 },
    { CMD_LIST_LA,	"LIST-LA",	"LLA",		0 },
    { CMD_LIST_LA,	"LISTLA",	0,		0 },
    { CMD_ILIST,	"ILIST",	"IL",		0 },
    { CMD_ILIST_L,	"ILIST-L",	"ILL",		0 },
    { CMD_ILIST_L,	"ILISTL",	0,		0 },
    { CMD_ILIST_LL,	"ILIST-LL",	"ILLL",		0 },
    { CMD_ILIST_LL,	"ILISTLL",	0,		0 },
    { CMD_ILIST_A,	"ILIST-A",	"ILA",		0 },
    { CMD_ILIST_LA,	"ILIST-LA",	"ILLA",		0 },
    { CMD_ILIST_LA,	"ILISTLA",	0,		0 },
    { CMD_MEMORY,	"MEMORY",	"MEM",		0 },
    { CMD_MEMORY_A,	"MEMORY-A",	"MEMA",		0 },
    { CMD_DUMP,		"DUMP",		0,		0 },
    { CMD_SHA1,		"SHA1",		0,		0 },
    { CMD_DIFF,		"DIFF",		"CMP",		0 },
    { CMD_CHECK,	"CHECK",	0,		0 },
    { CMD_SLOTS,	"SLOTS",	0,		0 },
    { CMD_STGI,		"STGI",		0,		0 },
    { CMD_NORMALIZE,	"NORMALIZE",	"NORM",		0 },
    { CMD_PATCH,	"PATCH",	0,		0 },
    { CMD_COPY,		"COPY",		"CP",		0 },
    { CMD_MINIMAP,	"MINIMAP",	0,		0 },
    { CMD_COMPRESS,	"COMPRESS",	"COM",		0 },
    { CMD_DECOMPRESS,	"DECOMPRESS",	"DEC",		0 },
    { CMD_ENCODE,	"ENCODE",	"E",		0 },
    { CMD_CREATE,	"CREATE",	"C",		0 },
    { CMD_UPDATE,	"UPDATE",	"U",		0 },
    { CMD_EXTRACT,	"EXTRACT",	"X",		0 },
    { CMD_XDECODE,	"XDECODE",	"XD",		0 },
    { CMD_XEXPORT,	"XEXPORT",	"XX",		0 },
    { CMD_XALL,		"XALL",		"XA",		0 },
    { CMD_CAT,		"CAT",		0,		0 },
    { CMD_BMG,		"BMG",		0,		0 },
    { CMD_KCL,		"KCL",		0,		0 },
    { CMD_KMP,		"KMP",		0,		0 },
    { CMD_INFO,		"INFO",		0,		0 },
    { CMD_VEHICLE,	"VEHICLE",	0,		0 },

    { CMD__N,0,0,0 }
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionShort & OptionLong             ///////////////
///////////////////////////////////////////////////////////////////////////////

static const char OptionShort[] = "Vhqvc:lHB1XPS:LM:T:A:x:ts:d:D:E:orupiNC:nRea";

static const struct option OptionLong[] =
{
	{ "version",		0, 0, 'V' },
	{ "help",		0, 0, 'h' },
	{ "xhelp",		0, 0, GO_XHELP },
	{ "allow-all",		0, 0, GO_ALLOW_ALL },
	 { "allowall",		0, 0, GO_ALLOW_ALL },
	{ "compatible",		1, 0, GO_COMPATIBLE },
	{ "width",		1, 0, GO_WIDTH },
	{ "quiet",		0, 0, 'q' },
	{ "verbose",		0, 0, 'v' },
	{ "de",			0, 0, GO_DE },
	{ "color",		0, 0, GO_COLOR },
	{ "no-color",		0, 0, GO_NO_COLOR },
	 { "nocolor",		0, 0, GO_NO_COLOR },
	{ "ct-code",		0, 0, GO_CT_CODE },
	 { "ctcode",		0, 0, GO_CT_CODE },
	{ "chdir",		1, 0, GO_CHDIR },
	{ "const",		1, 0, 'c' },
	{ "touch",		0, 0, GO_TOUCH },
	{ "auto",		0, 0, GO_AUTO },
	{ "set-flags",		1, 0, GO_SET_FLAGS },
	 { "setflags",		1, 0, GO_SET_FLAGS },
	{ "set-scale",		1, 0, GO_SET_SCALE },
	 { "setscale",		1, 0, GO_SET_SCALE },
	{ "set-rot",		1, 0, GO_SET_ROT },
	 { "setrot",		1, 0, GO_SET_ROT },
	{ "set-x",		1, 0, GO_SET_X },
	 { "setx",		1, 0, GO_SET_X },
	{ "set-y",		1, 0, GO_SET_Y },
	 { "sety",		1, 0, GO_SET_Y },
	{ "set-z",		1, 0, GO_SET_Z },
	 { "setz",		1, 0, GO_SET_Z },
	{ "xcenter",		0, 0, GO_XCENTER },
	{ "ycenter",		0, 0, GO_YCENTER },
	{ "zcenter",		0, 0, GO_ZCENTER },
	{ "center",		0, 0, GO_CENTER },
	{ "scale",		1, 0, GO_SCALE },
	{ "shift",		1, 0, GO_SHIFT },
	{ "xss",		1, 0, GO_XSS },
	{ "yss",		1, 0, GO_YSS },
	{ "zss",		1, 0, GO_ZSS },
	{ "rot",		1, 0, GO_ROT },
	{ "xrot",		1, 0, GO_XROT },
	{ "yrot",		1, 0, GO_YROT },
	 { "hrot",		1, 0, GO_YROT },
	{ "zrot",		1, 0, GO_ZROT },
	{ "ypos",		1, 0, GO_YPOS },
	{ "translate",		1, 0, GO_TRANSLATE },
	 { "trans",		1, 0, GO_TRANSLATE },
	{ "null",		0, 0, GO_NULL },
	{ "next",		0, 0, GO_NEXT },
	{ "ascale",		1, 0, GO_ASCALE },
	{ "arot",		1, 0, GO_AROT },
	{ "tform-script",	1, 0, GO_TFORM_SCRIPT },
	 { "tformscript",	1, 0, GO_TFORM_SCRIPT },
	{ "minimap",		0, 0, GO_MINIMAP },
	{ "rm-gobj",		1, 0, GO_RM_GOBJ },
	 { "rmgobj",		1, 0, GO_RM_GOBJ },
	{ "slot",		1, 0, GO_SLOT },
	{ "load-kcl",		1, 0, GO_LOAD_KCL },
	 { "loadkcl",		1, 0, GO_LOAD_KCL },
	{ "kcl",		1, 0, GO_KCL },
	{ "kcl-flag",		1, 0, GO_KCL_FLAG },
	 { "kclflag",		1, 0, GO_KCL_FLAG },
	{ "kcl-script",		1, 0, GO_KCL_SCRIPT },
	 { "kclscript",		1, 0, GO_KCL_SCRIPT },
	{ "flag-file",		1, 0, GO_FLAG_FILE },
	 { "flagfile",		1, 0, GO_FLAG_FILE },
	{ "kmp",		1, 0, GO_KMP },
	{ "speed-mod",		1, 0, GO_SPEED_MOD },
	 { "speedmod",		1, 0, GO_SPEED_MOD },
	{ "tform-kmp",		1, 0, GO_TFORM_KMP },
	 { "tformkmp",		1, 0, GO_TFORM_KMP },
	 { "tkmp",		1, 0, GO_TFORM_KMP },
	{ "mdl",		1, 0, GO_MDL },
	{ "pat",		1, 0, GO_PAT },
	{ "patch-file",		1, 0, GO_PATCH_FILE },
	 { "patchfile",		1, 0, GO_PATCH_FILE },
	 { "pfile",		1, 0, GO_PATCH_FILE },
	{ "patch-bmg",		1, 0, GO_PATCH_BMG },
	 { "patchbmg",		1, 0, GO_PATCH_BMG },
	 { "pb",		1, 0, GO_PATCH_BMG },
	{ "msg",		1, 0, GO_MSG },
	{ "long",		0, 0, 'l' },
	{ "cache",		1, 0, GO_CACHE },
	{ "id",			0, 0, GO_ID },
	{ "base64",		0, 0, GO_BASE64 },
	{ "verify",		0, 0, GO_VERIFY },
	{ "no-header",		0, 0, 'H' },
	 { "noheader",		0, 0, 'H' },
	{ "brief",		0, 0, 'B' },
	{ "bmg-inf-size",	1, 0, GO_BMG_INF_SIZE },
	 { "bmginfsize",	1, 0, GO_BMG_INF_SIZE },
	{ "force-attrib",	1, 0, GO_FORCE_ATTRIB },
	 { "forceattrib",	1, 0, GO_FORCE_ATTRIB },
	{ "def-attrib",		1, 0, GO_DEF_ATTRIB },
	 { "defattrib",		1, 0, GO_DEF_ATTRIB },
	{ "no-attrib",		0, 0, GO_NO_ATTRIB },
	 { "noattrib",		0, 0, GO_NO_ATTRIB },
	{ "x-escapes",		0, 0, GO_X_ESCAPES },
	 { "xescapes",		0, 0, GO_X_ESCAPES },
	{ "old-escapes",	0, 0, GO_OLD_ESCAPES },
	 { "oldescapes",	0, 0, GO_OLD_ESCAPES },
	{ "single-line",	0, 0, '1' },
	 { "singleline",	0, 0, '1' },
	{ "no-bmg-colors",	0, 0, GO_NO_BMG_COLORS },
	 { "nobmgcolors",	0, 0, GO_NO_BMG_COLORS },
	{ "bmg-colors",		0, 0, GO_BMG_COLORS },
	 { "bmgcolors",		0, 0, GO_BMG_COLORS },
	{ "no-bmg-inline",	0, 0, GO_NO_BMG_INLINE },
	 { "nobmginline",	0, 0, GO_NO_BMG_INLINE },
	{ "bmg-inline",		0, 0, GO_BMG_INLINE },
	 { "bmginline",		0, 0, GO_BMG_INLINE },
	{ "export",		0, 0, 'X' },
	{ "no-param",		0, 0, 'P' },
	 { "noparam",		0, 0, 'P' },
	{ "sort",		1, 0, 'S' },
	{ "logging",		0, 0, 'L' },
	{ "max-file-size",	1, 0, 'M' },
	 { "maxfilesize",	1, 0, 'M' },
	{ "tracks",		1, 0, 'T' },
	{ "arenas",		1, 0, 'A' },
	{ "autoadd-path",	1, 0, GO_AUTOADD_PATH },
	 { "autoaddpath",	1, 0, GO_AUTOADD_PATH },
	{ "transform",		1, 0, 'x' },
	{ "utf-8",		0, 0, GO_UTF_8 },
	 { "utf8",		0, 0, GO_UTF_8 },
	{ "no-utf-8",		0, 0, GO_NO_UTF_8 },
	 { "no-utf8",		0, 0, GO_NO_UTF_8 },
	 { "noutf8",		0, 0, GO_NO_UTF_8 },
	{ "test",		0, 0, 't' },
	{ "force",		0, 0, GO_FORCE },
	{ "yaz0",		0, 0, GO_YAZ0 },
	{ "yaz1",		0, 0, GO_YAZ1 },
	{ "xyz",		0, 0, GO_XYZ },
	{ "bz",			0, 0, GO_BZ },
	{ "analyze",		1, 0, GO_ANALYZE },
	 { "analyse",		1, 0, GO_ANALYZE },
	{ "analyze-mode",	1, 0, GO_ANALYZE_MODE },
	 { "ana-mode",		1, 0, GO_ANALYZE_MODE },
	 { "anamode",		1, 0, GO_ANALYZE_MODE },
	 { "amd",		1, 0, GO_ANALYZE_MODE },
	{ "OLD",		0, 0, GO_OLD },
	{ "NEW",		0, 0, GO_NEW },
	{ "EXTRACT",		1, 0, GO_EXTRACT },
	{ "src",		1, 0, 's' },
	 { "source",		1, 0, 's' },
	{ "dest",		1, 0, 'd' },
	{ "DEST",		1, 0, 'D' },
	{ "esc",		1, 0, 'E' },
	{ "overwrite",		0, 0, 'o' },
	{ "number",		0, 0, GO_NUMBER },
	 { "num",		0, 0, GO_NUMBER },
	{ "remove-src",		0, 0, GO_REMOVE_SRC },
	 { "removesrc",		0, 0, GO_REMOVE_SRC },
	 { "rm-src",		0, 0, GO_REMOVE_SRC },
	 { "rmsrc",		0, 0, GO_REMOVE_SRC },
	{ "remove-dest",	0, 0, 'r' },
	 { "removedest",	0, 0, 'r' },
	 { "rm-dest",		0, 0, 'r' },
	 { "rmdest",		0, 0, 'r' },
	 { "remove",		0, 0, 'r' },
	{ "update",		0, 0, 'u' },
	{ "preserve",		0, 0, 'p' },
	{ "ignore",		0, 0, 'i' },
	{ "ignore-setup",	0, 0, GO_IGNORE_SETUP },
	 { "ignoresetup",	0, 0, GO_IGNORE_SETUP },
	{ "align-u8",		1, 0, GO_ALIGN_U8 },
	 { "alignu8",		1, 0, GO_ALIGN_U8 },
	{ "align-pack",		1, 0, GO_ALIGN_PACK },
	 { "alignpack",		1, 0, GO_ALIGN_PACK },
	{ "align-brres",	1, 0, GO_ALIGN_BRRES },
	 { "alignbrres",	1, 0, GO_ALIGN_BRRES },
	{ "align-breff",	1, 0, GO_ALIGN_BREFF },
	 { "alignbreff",	1, 0, GO_ALIGN_BREFF },
	{ "align-breft",	1, 0, GO_ALIGN_BREFT },
	 { "alignbreft",	1, 0, GO_ALIGN_BREFT },
	{ "align",		1, 0, GO_ALIGN },
	{ "encode-all",		0, 0, GO_ENCODE_ALL },
	 { "encodeall",		0, 0, GO_ENCODE_ALL },
	 { "eall",		0, 0, GO_ENCODE_ALL },
	{ "encode-img",		0, 0, GO_ENCODE_IMG },
	 { "encodeimg",		0, 0, GO_ENCODE_IMG },
	 { "eimg",		0, 0, GO_ENCODE_IMG },
	{ "no-encode",		0, 0, GO_NO_ENCODE },
	 { "noencode",		0, 0, GO_NO_ENCODE },
	 { "noenc",		0, 0, GO_NO_ENCODE },
	{ "no-recurse",		0, 0, GO_NO_RECURSE },
	 { "norecurse",		0, 0, GO_NO_RECURSE },
	 { "norec",		0, 0, GO_NO_RECURSE },
	{ "auto-add",		0, 0, GO_AUTO_ADD },
	 { "autoadd",		0, 0, GO_AUTO_ADD },
	 { "aadd",		0, 0, GO_AUTO_ADD },
	{ "no-echo",		0, 0, GO_NO_ECHO },
	 { "noecho",		0, 0, GO_NO_ECHO },
	{ "no-check",		0, 0, 'N' },
	 { "nocheck",		0, 0, 'N' },
	{ "pt-dir",		2, 0, GO_PT_DIR },
	 { "ptdir",		2, 0, GO_PT_DIR },
	 { "pdir",		2, 0, GO_PT_DIR },
	{ "rm-aiparam",		0, 0, GO_RM_AIPARAM },
	 { "rmaiparam",		0, 0, GO_RM_AIPARAM },
	 { "rmai",		0, 0, GO_RM_AIPARAM },
	{ "u8",			0, 0, GO_U8 },
	{ "szs",		0, 0, GO_SZS },
	{ "wu8",		0, 0, GO_WU8 },
	{ "xwu8",		0, 0, GO_XWU8 },
	{ "wbz",		0, 0, GO_WBZ },
	{ "pack",		0, 0, GO_PACK },
	{ "brres",		0, 0, GO_BRRES },
	 { "bres",		0, 0, GO_BRRES },
	{ "breff",		0, 0, GO_BREFF },
	{ "breft",		0, 0, GO_BREFT },
	{ "no-compress",	0, 0, GO_NO_COMPRESS },
	 { "nocompress",	0, 0, GO_NO_COMPRESS },
	 { "noc",		0, 0, GO_NO_COMPRESS },
	{ "compr",		1, 0, 'C' },
	{ "fast",		0, 0, GO_FAST },
	{ "norm",		0, 0, 'n' },
	{ "recurse",		2, 0, 'R' },
	{ "ext",		0, 0, 'e' },
	{ "decode",		0, 0, GO_DECODE },
	 { "dec",		0, 0, GO_DECODE },
	{ "n-mipmaps",		1, 0, GO_N_MIPMAPS },
	 { "nmipmaps",		1, 0, GO_N_MIPMAPS },
	 { "n-mm",		1, 0, GO_N_MIPMAPS },
	 { "nmm",		1, 0, GO_N_MIPMAPS },
	{ "mipmap-size",	1, 0, GO_MIPMAP_SIZE },
	 { "mipmap-size",	1, 0, GO_MIPMAP_SIZE },
	 { "mm-size",		1, 0, GO_MIPMAP_SIZE },
	 { "mm-size",		1, 0, GO_MIPMAP_SIZE },
	{ "mipmaps",		0, 0, GO_MIPMAPS },
	{ "no-mipmaps",		0, 0, GO_NO_MIPMAPS },
	 { "nomipmaps",		0, 0, GO_NO_MIPMAPS },
	 { "no-mm",		0, 0, GO_NO_MIPMAPS },
	 { "nomm",		0, 0, GO_NO_MIPMAPS },
	{ "smart",		0, 0, GO_SMART },
	{ "cut",		0, 0, GO_CUT },
	{ "all",		0, 0, 'a' },
	{ "raw",		0, 0, GO_RAW },
	{ "sections",		0, 0, GO_SECTIONS },

	{0,0,0,0}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////            OptionUsed & OptionIndex             ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 OptionUsed[OPT__N_TOTAL+1] = {0};

static const u8 OptionIndex[OPT_INDEX_SIZE] = 
{
	/* 0x00   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x10   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x20   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 0x30   */	 0,
	/* 0x31 1 */	OPT_SINGLE_LINE,
	/* 0x32   */	 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,
	/* 0x41 A */	OPT_ARENAS,
	/* 0x42 B */	OPT_BRIEF,
	/* 0x43 C */	OPT_COMPR,
	/* 0x44 D */	OPT_DEST2,
	/* 0x45 E */	OPT_ESC,
	/* 0x46   */	 0,0,
	/* 0x48 H */	OPT_NO_HEADER,
	/* 0x49   */	 0,0,0,
	/* 0x4c L */	OPT_LOGGING,
	/* 0x4d M */	OPT_MAX_FILE_SIZE,
	/* 0x4e N */	OPT_NO_CHECK,
	/* 0x4f   */	 0,
	/* 0x50 P */	OPT_NO_PARAM,
	/* 0x51   */	 0,
	/* 0x52 R */	OPT_RECURSE,
	/* 0x53 S */	OPT_SORT,
	/* 0x54 T */	OPT_TRACKS,
	/* 0x55   */	 0,
	/* 0x56 V */	OPT_VERSION,
	/* 0x57   */	 0,
	/* 0x58 X */	OPT_EXPORT,
	/* 0x59   */	 0,0,0,0, 0,0,0,0, 
	/* 0x61 a */	OPT_ALL,
	/* 0x62   */	 0,
	/* 0x63 c */	OPT_CONST,
	/* 0x64 d */	OPT_DEST,
	/* 0x65 e */	OPT_EXT,
	/* 0x66   */	 0,0,
	/* 0x68 h */	OPT_HELP,
	/* 0x69 i */	OPT_IGNORE,
	/* 0x6a   */	 0,0,
	/* 0x6c l */	OPT_LONG,
	/* 0x6d   */	 0,
	/* 0x6e n */	OPT_NORM,
	/* 0x6f o */	OPT_OVERWRITE,
	/* 0x70 p */	OPT_PRESERVE,
	/* 0x71 q */	OPT_QUIET,
	/* 0x72 r */	OPT_REMOVE_DEST,
	/* 0x73 s */	OPT_SOURCE,
	/* 0x74 t */	OPT_TEST,
	/* 0x75 u */	OPT_UPDATE,
	/* 0x76 v */	OPT_VERBOSE,
	/* 0x77   */	 0,
	/* 0x78 x */	OPT_TRANSFORM,
	/* 0x79   */	 0,0,0,0, 0,0,0,
	/* 0x80   */	OPT_XHELP,
	/* 0x81   */	OPT_ALLOW_ALL,
	/* 0x82   */	OPT_COMPATIBLE,
	/* 0x83   */	OPT_WIDTH,
	/* 0x84   */	OPT_DE,
	/* 0x85   */	OPT_COLOR,
	/* 0x86   */	OPT_NO_COLOR,
	/* 0x87   */	OPT_CT_CODE,
	/* 0x88   */	OPT_CHDIR,
	/* 0x89   */	OPT_TOUCH,
	/* 0x8a   */	OPT_AUTO,
	/* 0x8b   */	OPT_SET_FLAGS,
	/* 0x8c   */	OPT_SET_SCALE,
	/* 0x8d   */	OPT_SET_ROT,
	/* 0x8e   */	OPT_SET_X,
	/* 0x8f   */	OPT_SET_Y,
	/* 0x90   */	OPT_SET_Z,
	/* 0x91   */	OPT_XCENTER,
	/* 0x92   */	OPT_YCENTER,
	/* 0x93   */	OPT_ZCENTER,
	/* 0x94   */	OPT_CENTER,
	/* 0x95   */	OPT_SCALE,
	/* 0x96   */	OPT_SHIFT,
	/* 0x97   */	OPT_XSS,
	/* 0x98   */	OPT_YSS,
	/* 0x99   */	OPT_ZSS,
	/* 0x9a   */	OPT_ROT,
	/* 0x9b   */	OPT_XROT,
	/* 0x9c   */	OPT_YROT,
	/* 0x9d   */	OPT_ZROT,
	/* 0x9e   */	OPT_YPOS,
	/* 0x9f   */	OPT_TRANSLATE,
	/* 0xa0   */	OPT_NULL,
	/* 0xa1   */	OPT_NEXT,
	/* 0xa2   */	OPT_ASCALE,
	/* 0xa3   */	OPT_AROT,
	/* 0xa4   */	OPT_TFORM_SCRIPT,
	/* 0xa5   */	OPT_MINIMAP,
	/* 0xa6   */	OPT_RM_GOBJ,
	/* 0xa7   */	OPT_SLOT,
	/* 0xa8   */	OPT_LOAD_KCL,
	/* 0xa9   */	OPT_KCL,
	/* 0xaa   */	OPT_KCL_FLAG,
	/* 0xab   */	OPT_KCL_SCRIPT,
	/* 0xac   */	OPT_FLAG_FILE,
	/* 0xad   */	OPT_KMP,
	/* 0xae   */	OPT_SPEED_MOD,
	/* 0xaf   */	OPT_TFORM_KMP,
	/* 0xb0   */	OPT_MDL,
	/* 0xb1   */	OPT_PAT,
	/* 0xb2   */	OPT_PATCH_FILE,
	/* 0xb3   */	OPT_PATCH_BMG,
	/* 0xb4   */	OPT_MSG,
	/* 0xb5   */	OPT_CACHE,
	/* 0xb6   */	OPT_ID,
	/* 0xb7   */	OPT_BASE64,
	/* 0xb8   */	OPT_VERIFY,
	/* 0xb9   */	OPT_BMG_INF_SIZE,
	/* 0xba   */	OPT_FORCE_ATTRIB,
	/* 0xbb   */	OPT_DEF_ATTRIB,
	/* 0xbc   */	OPT_NO_ATTRIB,
	/* 0xbd   */	OPT_X_ESCAPES,
	/* 0xbe   */	OPT_OLD_ESCAPES,
	/* 0xbf   */	OPT_NO_BMG_COLORS,
	/* 0xc0   */	OPT_BMG_COLORS,
	/* 0xc1   */	OPT_NO_BMG_INLINE,
	/* 0xc2   */	OPT_BMG_INLINE,
	/* 0xc3   */	OPT_AUTOADD_PATH,
	/* 0xc4   */	OPT_UTF_8,
	/* 0xc5   */	OPT_NO_UTF_8,
	/* 0xc6   */	OPT_FORCE,
	/* 0xc7   */	OPT_YAZ0,
	/* 0xc8   */	OPT_YAZ1,
	/* 0xc9   */	OPT_XYZ,
	/* 0xca   */	OPT_BZ,
	/* 0xcb   */	OPT_ANALYZE,
	/* 0xcc   */	OPT_ANALYZE_MODE,
	/* 0xcd   */	OPT_OLD,
	/* 0xce   */	OPT_NEW,
	/* 0xcf   */	OPT_EXTRACT,
	/* 0xd0   */	OPT_NUMBER,
	/* 0xd1   */	OPT_REMOVE_SRC,
	/* 0xd2   */	OPT_IGNORE_SETUP,
	/* 0xd3   */	OPT_ALIGN_U8,
	/* 0xd4   */	OPT_ALIGN_PACK,
	/* 0xd5   */	OPT_ALIGN_BRRES,
	/* 0xd6   */	OPT_ALIGN_BREFF,
	/* 0xd7   */	OPT_ALIGN_BREFT,
	/* 0xd8   */	OPT_ALIGN,
	/* 0xd9   */	OPT_ENCODE_ALL,
	/* 0xda   */	OPT_ENCODE_IMG,
	/* 0xdb   */	OPT_NO_ENCODE,
	/* 0xdc   */	OPT_NO_RECURSE,
	/* 0xdd   */	OPT_AUTO_ADD,
	/* 0xde   */	OPT_NO_ECHO,
	/* 0xdf   */	OPT_PT_DIR,
	/* 0xe0   */	OPT_RM_AIPARAM,
	/* 0xe1   */	OPT_U8,
	/* 0xe2   */	OPT_SZS,
	/* 0xe3   */	OPT_WU8,
	/* 0xe4   */	OPT_XWU8,
	/* 0xe5   */	OPT_WBZ,
	/* 0xe6   */	OPT_PACK,
	/* 0xe7   */	OPT_BRRES,
	/* 0xe8   */	OPT_BREFF,
	/* 0xe9   */	OPT_BREFT,
	/* 0xea   */	OPT_NO_COMPRESS,
	/* 0xeb   */	OPT_FAST,
	/* 0xec   */	OPT_DECODE,
	/* 0xed   */	OPT_N_MIPMAPS,
	/* 0xee   */	OPT_MIPMAP_SIZE,
	/* 0xef   */	OPT_MIPMAPS,
	/* 0xf0   */	OPT_NO_MIPMAPS,
	/* 0xf1   */	OPT_SMART,
	/* 0xf2   */	OPT_CUT,
	/* 0xf3   */	OPT_RAW,
	/* 0xf4   */	OPT_SECTIONS,
	/* 0xf5   */	 0,0,0,0, 0,0,0,0, 0,0,0,
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                opt_allowed_cmd_*                ///////////////
///////////////////////////////////////////////////////////////////////////////

static u8 option_allowed_cmd_VERSION[113] = // cmd #1
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,1
};

static u8 option_allowed_cmd_HELP[113] = // cmd #2
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1
};

static u8 option_allowed_cmd_ARGTEST[113] = // cmd #3
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1
};

static u8 option_allowed_cmd_TEST[113] = // cmd #4
{
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1
};

static u8 option_allowed_cmd_COLORS[113] = // cmd #5
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_ERROR[113] = // cmd #6
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,1
};

static u8 option_allowed_cmd_FILETYPE[113] = // cmd #7
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_FILEATTRIB[113] = // cmd #8
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_SYMBOLS[113] = // cmd #9
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_FUNCTIONS[113] = // cmd #10
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_CALCULATE[113] = // cmd #11
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_MATRIX[113] = // cmd #12
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_FLOAT[113] = // cmd #13
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_AUTOADD[113] = // cmd #14
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,0, 1,0,0,1,0,  1,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_TRACKS[113] = // cmd #15
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  1,0,0
};

static u8 option_allowed_cmd_EXPORT[113] = // cmd #16
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_CODE[113] = // cmd #17
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_RECODE[113] = // cmd #18
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_SUBFILE[113] = // cmd #19
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,1, 1,1,0,1,1,  1,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_LIST[113] = // cmd #20
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,0,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_LIST_L[113] = // cmd #21
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,0,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_LIST_LL[113] = // cmd #22
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,0,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_LIST_LLL[113] = // cmd #23
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,0,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_LIST_A[113] = // cmd #24
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,0,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_LIST_LA[113] = // cmd #25
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,0,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_ILIST[113] = // cmd #26
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_ILIST_L[113] = // cmd #27
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_ILIST_LL[113] = // cmd #28
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_ILIST_A[113] = // cmd #29
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_ILIST_LA[113] = // cmd #30
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,1,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_MEMORY[113] = // cmd #31
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,1,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_MEMORY_A[113] = // cmd #32
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,0,0,0, 0,0,1,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,1,1,1,1, 1,1,1,1,1,  1,0,0
};

static u8 option_allowed_cmd_DUMP[113] = // cmd #33
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,0,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_SHA1[113] = // cmd #34
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,1,  1,1,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  1,0,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_DIFF[113] = // cmd #35
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,0,1, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,1,  1,0,0
};

static u8 option_allowed_cmd_CHECK[113] = // cmd #36
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,1,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  0,0,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_SLOTS[113] = // cmd #37
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,0,0,0,  0,0,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_STGI[113] = // cmd #38
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_NORMALIZE[113] = // cmd #39
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,1, 1,1,1,1,1,  1,1,0,1,1, 1,1,1,1,0,  0,0,0,1,0, 0,1,1,1,1,
    1,1,1,0,0, 0,0,0,0,1,  1,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_PATCH[113] = // cmd #40
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,1, 1,1,1,1,1,  1,1,0,1,1, 1,1,1,1,0,  0,0,0,1,0, 0,1,1,1,1,
    1,1,1,0,0, 0,0,0,1,1,  1,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_COPY[113] = // cmd #41
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,1, 1,1,1,1,1,  1,1,0,1,1, 1,1,1,1,0,  0,0,0,1,0, 0,1,1,1,1,
    1,1,1,0,0, 0,0,0,1,1,  1,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_MINIMAP[113] = // cmd #42
{
    0,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,1,0,  1,1,0,1,1, 1,1,1,1,0,  0,0,0,1,0, 0,1,1,0,0,
    0,0,0,0,0, 0,0,0,1,1,  1,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_COMPRESS[113] = // cmd #43
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,1,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,1, 1,1,1,1,1,  1,1,0,1,1, 1,1,1,1,0,  0,0,0,1,0, 0,1,1,1,1,
    1,1,1,0,0, 0,0,0,1,1,  1,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_DECOMPRESS[113] = // cmd #44
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,1,1,1, 1,1,1,1,1,  1,1,0,1,1, 1,1,1,1,0,  0,0,0,1,0, 0,1,1,1,0,
    1,0,0,0,0, 0,0,0,0,0,  1,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_ENCODE[113] = // cmd #45
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,1,1, 1,1,1,1,1,  1,1,1,0,1, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_CREATE[113] = // cmd #46
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,0,1,1,1, 1,1,0,1,1,  1,0,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,1, 1,1,1,1,1,  0,0,0,0,1, 1,1,1,1,0,  1,0,0
};

static u8 option_allowed_cmd_UPDATE[113] = // cmd #47
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,1,0,
    0,1,1,1,1, 1,1,0,1,1,  1,1,0,0,0, 0,0,0,0,1,  1,1,1,0,1, 1,0,0,0,0,
    0,0,0,0,0, 0,0,1,1,1,  0,1,0,0,0, 0,0,0,0,0,  1,0,0
};

static u8 option_allowed_cmd_EXTRACT[113] = // cmd #48
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 1,1,0,0,1,
    1,0,1,1,1, 1,1,0,1,1,  1,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,0, 0,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_XDECODE[113] = // cmd #49
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 1,1,0,0,1,
    1,0,1,1,1, 1,1,0,1,1,  1,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,0, 0,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_XEXPORT[113] = // cmd #50
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 1,1,0,0,1,
    1,0,1,1,1, 1,1,0,1,1,  1,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,0, 0,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_XALL[113] = // cmd #51
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 1,1,0,0,1,
    1,0,1,1,1, 1,1,0,1,1,  1,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,1,1,0, 0,1,1,1,1,  1,1,0
};

static u8 option_allowed_cmd_CAT[113] = // cmd #52
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 1,1,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_BMG[113] = // cmd #53
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,1,0,0,  0,0,1,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_KCL[113] = // cmd #54
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,1,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_KMP[113] = // cmd #55
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,1, 1,1,1,1,1,  1,1,1,1,1, 1,1,1,1,1,
    1,1,1,1,0, 1,1,0,0,0,  0,0,1,1,0, 0,0,0,0,0,  0,0,0,0,0, 1,1,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 1,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_INFO[113] = // cmd #56
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,1,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,1,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};

static u8 option_allowed_cmd_VEHICLE[113] = // cmd #57
{
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,1,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,1,1,1,0, 1,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,
    0,0,0,0,0, 0,0,0,0,0,  0,0,0,0,0, 0,0,0,0,0,  0,0,0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                 InfoOption tabs                 ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoOption_t * option_tab_tool[] =
{
	OptionInfo + OPT_VERSION,
	OptionInfo + OPT_HELP,
	OptionInfo + OPT_XHELP,
	OptionInfo + OPT_ALLOW_ALL,
	OptionInfo + OPT_COMPATIBLE,
	OptionInfo + OPT_WIDTH,
	OptionInfo + OPT_QUIET,
	OptionInfo + OPT_VERBOSE,
	OptionInfo + OPT_DE,
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	OptionInfo + OPT_CT_CODE,
	OptionInfo + OPT_CHDIR,
	OptionInfo + OPT_CONST,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_MAX_FILE_SIZE,
	OptionInfo + OPT_TRACKS,
	OptionInfo + OPT_ARENAS,
	OptionInfo + OPT_AUTOADD_PATH,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TEST,
	OptionInfo + OPT_FORCE,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_XYZ,
	OptionInfo + OPT_BZ,

	0
};

static const InfoOption_t * option_tab_cmd_VERSION[] =
{
	&option_cmd_VERSION_BRIEF,
	OptionInfo + OPT_SECTIONS,
	&option_cmd_VERSION_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_HELP[] =
{
	OptionInfo + OPT_WIDTH,

	0
};

static const InfoOption_t * option_tab_cmd_ARGTEST[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_TEST[] =
{
	&option_cmd_TEST_VERBOSE,

	0
};

static const InfoOption_t * option_tab_cmd_COLORS[] =
{
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	&option_cmd_COLORS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_ERROR[] =
{
	OptionInfo + OPT_SECTIONS,
	OptionInfo + OPT_NO_HEADER,
	&option_cmd_ERROR_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_FILETYPE[] =
{
	&option_cmd_FILETYPE_LONG,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_FILEATTRIB[] =
{
	OptionInfo + OPT_NO_HEADER,

	0
};

static const InfoOption_t * option_tab_cmd_SYMBOLS[] =
{
	OptionInfo + OPT_NO_HEADER,

	0
};

static const InfoOption_t * option_tab_cmd_FUNCTIONS[] =
{
	OptionInfo + OPT_NO_HEADER,
	&option_cmd_FUNCTIONS_BRIEF,
	&option_cmd_FUNCTIONS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_CALCULATE[] =
{
	OptionInfo + OPT_CONST,

	0
};

static const InfoOption_t * option_tab_cmd_MATRIX[] =
{
	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,

	OptionInfo + OPT_NONE, // separator

	&option_cmd_MATRIX_BRIEF,
	&option_cmd_MATRIX_LONG,
	&option_cmd_MATRIX_QUIET,

	0
};

static const InfoOption_t * option_tab_cmd_FLOAT[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_AUTOADD[] =
{
	OptionInfo + OPT_IGNORE,
	&option_cmd_AUTOADD_QUIET,
	&option_cmd_AUTOADD_VERBOSE,
	&option_cmd_AUTOADD_DEST,
	OptionInfo + OPT_DEST2,
	&option_cmd_AUTOADD_OVERWRITE,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_PRESERVE,

	0
};

static const InfoOption_t * option_tab_cmd_TRACKS[] =
{
	&option_cmd_TRACKS_VERBOSE,
	&option_cmd_TRACKS_ALL,
	&option_cmd_TRACKS_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_EXPORT[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_CODE[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_RECODE[] =
{

	0
};

static const InfoOption_t * option_tab_cmd_SUBFILE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,

	0
};

static const InfoOption_t * option_tab_cmd_LIST[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_L[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_LL[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_LLL[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_A[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_LIST_LA[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	&option_cmd_LIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_ILIST[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_ALL,
	&option_cmd_ILIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,

	0
};

static const InfoOption_t * option_tab_cmd_ILIST_L[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_ALL,
	&option_cmd_ILIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,

	0
};

static const InfoOption_t * option_tab_cmd_ILIST_LL[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_ALL,
	&option_cmd_ILIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,

	0
};

static const InfoOption_t * option_tab_cmd_ILIST_A[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_ALL,
	&option_cmd_ILIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,

	0
};

static const InfoOption_t * option_tab_cmd_ILIST_LA[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_ALL,
	&option_cmd_ILIST_LONG,
	OptionInfo + OPT_SORT,
	OptionInfo + OPT_NO_HEADER,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,

	0
};

static const InfoOption_t * option_tab_cmd_MEMORY[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	&option_cmd_MEMORY_DECODE,
	&option_cmd_MEMORY_MIPMAPS,
	OptionInfo + OPT_CUT,
	&option_cmd_MEMORY_ALL,
	&option_cmd_MEMORY_LONG,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_MEMORY_A[] =
{
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	&option_cmd_MEMORY_DECODE,
	&option_cmd_MEMORY_MIPMAPS,
	OptionInfo + OPT_CUT,
	&option_cmd_MEMORY_ALL,
	&option_cmd_MEMORY_LONG,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_SLOT,

	0
};

static const InfoOption_t * option_tab_cmd_DUMP[] =
{
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	&option_grp_ENCODE_ALL,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,

	0
};

static const InfoOption_t * option_tab_cmd_SHA1[] =
{
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	&option_grp_ENCODE_ALL,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_ID,
	OptionInfo + OPT_BASE64,
	OptionInfo + OPT_VERIFY,
	&option_cmd_SHA1_BRIEF,
	&option_cmd_SHA1_LONG,

	0
};

static const InfoOption_t * option_tab_cmd_DIFF[] =
{
	&option_cmd_DIFF_QUIET,
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_ESC,

	0
};

static const InfoOption_t * option_tab_cmd_CHECK[] =
{
	&option_cmd_CHECK_NO_CHECK,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	&option_cmd_CHECK_BRIEF,
	&option_cmd_CHECK_LONG,
	&option_cmd_CHECK_QUIET,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	&option_grp_ENCODE_ALL,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_SLOTS[] =
{
	OptionInfo + OPT_IGNORE,
	&option_cmd_SLOTS_BRIEF,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	&option_grp_ENCODE_ALL,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_STGI[] =
{
	OptionInfo + OPT_COLOR,
	OptionInfo + OPT_NO_COLOR,
	OptionInfo + OPT_NO_HEADER,
	&option_cmd_STGI_IGNORE,

	0
};

static const InfoOption_t * option_tab_cmd_NORMALIZE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_REMOVE_SRC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_FAST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_PATCH[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_REMOVE_SRC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_COMPR,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_FAST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_COPY[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_REMOVE_SRC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_COMPR,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_FAST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_MINIMAP[] =
{
	&option_cmd_MINIMAP_LONG,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_COMPR,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_FAST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_TOUCH,
	OptionInfo + OPT_AUTO,
	OptionInfo + OPT_SET_FLAGS,
	OptionInfo + OPT_SET_SCALE,
	OptionInfo + OPT_SET_ROT,
	OptionInfo + OPT_SET_X,
	OptionInfo + OPT_SET_Y,
	OptionInfo + OPT_SET_Z,
	OptionInfo + OPT_XCENTER,
	OptionInfo + OPT_YCENTER,
	OptionInfo + OPT_ZCENTER,
	OptionInfo + OPT_CENTER,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,

	0
};

static const InfoOption_t * option_tab_cmd_COMPRESS[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_REMOVE_SRC,
	OptionInfo + OPT_CACHE,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_COMPR,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_FAST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_DECOMPRESS[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_REMOVE_SRC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_NORM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_AUTO_ADD,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_ENCODE[] =
{
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	&option_grp_ENCODE_ALL,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_CREATE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_IGNORE_SETUP,
	OptionInfo + OPT_U8,
	OptionInfo + OPT_WU8,
	OptionInfo + OPT_PACK,
	OptionInfo + OPT_BRRES,
	OptionInfo + OPT_BREFF,
	OptionInfo + OPT_BREFT,
	OptionInfo + OPT_YAZ0,
	OptionInfo + OPT_YAZ1,
	OptionInfo + OPT_BZ,
	OptionInfo + OPT_SZS,
	OptionInfo + OPT_WBZ,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PT_DIR,
	OptionInfo + OPT_RM_AIPARAM,
	OptionInfo + OPT_ALIGN_U8,
	OptionInfo + OPT_ALIGN_PACK,
	OptionInfo + OPT_ALIGN_BRRES,
	OptionInfo + OPT_ALIGN_BREFF,
	OptionInfo + OPT_ALIGN_BREFT,
	OptionInfo + OPT_ALIGN,
	OptionInfo + OPT_LOGGING,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	&option_grp_ENCODE_ALL,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_AUTO_ADD,
	OptionInfo + OPT_N_MIPMAPS,
	OptionInfo + OPT_MIPMAP_SIZE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_NO_COMPRESS,
	OptionInfo + OPT_COMPR,
	OptionInfo + OPT_FAST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_UPDATE[] =
{
	OptionInfo + OPT_SOURCE,
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_NO_COMPRESS,
	OptionInfo + OPT_COMPR,
	OptionInfo + OPT_FAST,
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_ALL,
	OptionInfo + OPT_ENCODE_ALL,
	OptionInfo + OPT_ENCODE_IMG,
	OptionInfo + OPT_NO_ENCODE,
	OptionInfo + OPT_NO_RECURSE,
	OptionInfo + OPT_NO_ECHO,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_TRANSFORM,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_EXTRACT[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_DECODE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	OptionInfo + OPT_IGNORE,
	&option_grp_TEXTOUT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_NO_PARAM,
	OptionInfo + OPT_NO_CHECK,
	OptionInfo + OPT_RAW,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_XDECODE[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_DECODE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	OptionInfo + OPT_IGNORE,
	&option_grp_TEXTOUT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_NO_PARAM,
	OptionInfo + OPT_NO_CHECK,
	OptionInfo + OPT_RAW,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_XEXPORT[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_DECODE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	OptionInfo + OPT_IGNORE,
	&option_grp_TEXTOUT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_NO_PARAM,
	OptionInfo + OPT_NO_CHECK,
	OptionInfo + OPT_RAW,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_XALL[] =
{
	OptionInfo + OPT_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_ESC,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_PRESERVE,
	OptionInfo + OPT_UPDATE,
	OptionInfo + OPT_OVERWRITE,
	OptionInfo + OPT_NUMBER,
	OptionInfo + OPT_REMOVE_DEST,
	OptionInfo + OPT_RECURSE,
	OptionInfo + OPT_EXT,
	OptionInfo + OPT_DECODE,
	OptionInfo + OPT_MIPMAPS,
	OptionInfo + OPT_NO_MIPMAPS,
	OptionInfo + OPT_SMART,
	OptionInfo + OPT_CUT,
	OptionInfo + OPT_ALL,
	OptionInfo + OPT_IGNORE,
	&option_grp_TEXTOUT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_NO_PARAM,
	OptionInfo + OPT_NO_CHECK,
	OptionInfo + OPT_RAW,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_CAT[] =
{
	OptionInfo + OPT_IGNORE,
	OptionInfo + OPT_DECODE,
	&option_grp_TEXTOUT_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_NO_PARAM,

	0
};

static const InfoOption_t * option_tab_cmd_BMG[] =
{
	OptionInfo + OPT_IGNORE,
	&option_cmd_BMG_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_BMG_INF_SIZE,
	OptionInfo + OPT_FORCE_ATTRIB,
	OptionInfo + OPT_DEF_ATTRIB,
	OptionInfo + OPT_NO_ATTRIB,
	OptionInfo + OPT_X_ESCAPES,
	OptionInfo + OPT_OLD_ESCAPES,
	OptionInfo + OPT_SINGLE_LINE,
	OptionInfo + OPT_NO_BMG_COLORS,
	OptionInfo + OPT_BMG_COLORS,
	OptionInfo + OPT_NO_BMG_INLINE,
	OptionInfo + OPT_BMG_INLINE,
	&option_cmd_BMG_LONG,
	OptionInfo + OPT_EXPORT,

	0
};

static const InfoOption_t * option_tab_cmd_KCL[] =
{
	OptionInfo + OPT_IGNORE,
	&option_cmd_KCL_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_NO_PARAM,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_KMP[] =
{
	OptionInfo + OPT_IGNORE,
	&option_cmd_KMP_NO_HEADER,
	OptionInfo + OPT_BRIEF,
	OptionInfo + OPT_EXPORT,
	OptionInfo + OPT_NO_PARAM,
	OptionInfo + OPT_NO_CHECK,

	OptionInfo + OPT_NONE, // separator

	OptionInfo + OPT_CONST,
	OptionInfo + OPT_SCALE,
	OptionInfo + OPT_SHIFT,
	OptionInfo + OPT_XSS,
	OptionInfo + OPT_YSS,
	OptionInfo + OPT_ZSS,
	OptionInfo + OPT_ROT,
	OptionInfo + OPT_XROT,
	OptionInfo + OPT_YROT,
	OptionInfo + OPT_ZROT,
	OptionInfo + OPT_YPOS,
	OptionInfo + OPT_TRANSLATE,
	OptionInfo + OPT_NULL,
	OptionInfo + OPT_NEXT,
	OptionInfo + OPT_ASCALE,
	OptionInfo + OPT_AROT,
	OptionInfo + OPT_TFORM_SCRIPT,
	OptionInfo + OPT_RM_GOBJ,
	OptionInfo + OPT_SLOT,
	OptionInfo + OPT_LOAD_KCL,
	OptionInfo + OPT_KCL,
	OptionInfo + OPT_KCL_FLAG,
	OptionInfo + OPT_KCL_SCRIPT,
	OptionInfo + OPT_KMP,
	OptionInfo + OPT_SPEED_MOD,
	OptionInfo + OPT_TFORM_KMP,
	OptionInfo + OPT_MDL,
	OptionInfo + OPT_MINIMAP,
	OptionInfo + OPT_PAT,
	OptionInfo + OPT_PATCH_FILE,
	OptionInfo + OPT_PATCH_BMG,
	OptionInfo + OPT_MSG,

	0
};

static const InfoOption_t * option_tab_cmd_INFO[] =
{
	OptionInfo + OPT_IGNORE,
	&option_cmd_INFO_NO_HEADER,

	0
};

static const InfoOption_t * option_tab_cmd_VEHICLE[] =
{
	&option_cmd_VEHICLE_SOURCE,
	&option_cmd_VEHICLE_DEST,
	OptionInfo + OPT_DEST2,
	OptionInfo + OPT_OVERWRITE,
	&option_cmd_VEHICLE_QUIET,
	&option_cmd_VEHICLE_VERBOSE,
	&option_cmd_VEHICLE_BRIEF,

	0
};


//
///////////////////////////////////////////////////////////////////////////////
///////////////                   InfoCommand                   ///////////////
///////////////////////////////////////////////////////////////////////////////

static const InfoCommand_t CommandInfo[CMD__N+1] =
{
    {	0,
	false,
	false,
	false,
	"wszst",
	0,
	"wszst [option]... command [option|parameter|file]...",
	"Wiimms SZS Tool : List, compare, (de-)compress, extract and create"
	" SZS, U8, PACK, BRRES, BREFF, BREFT and RARC archives. It is also a"
	" wrapper to all other tools.",
	0,
	33,
	option_tab_tool,
	0
    },

    {	CMD_VERSION,
	false,
	false,
	false,
	"VERSION",
	0,
	"wszst VERSION [ignored]...",
	"Print program name and version and exit.",
	0,
	3,
	option_tab_cmd_VERSION,
	option_allowed_cmd_VERSION
    },

    {	CMD_HELP,
	false,
	false,
	false,
	"HELP",
	"H",
	"wszst HELP [--width=wd] OPT|OPTION [option]...\n"
	"wszst HELP [--width=wd] CMD|COMMAND ...\n"
	"wszst HELP [--width=wd] command ...\n"
	"wszst HELP [--width=wd] ...",
	"Print help for commands and options.",
	"Print help for commands and options.\n"
	"  The first variant (with keyword OPT or OPTION) prints a list of all"
	" global and command specific options. If at least one option is set,"
	" only infos about the declared options are printed. The second"
	" variant (with keyword CMD or COMMAND) prints an overview about all"
	" commands. The third variant (with a valid command name) prints"
	" details about the declared command. The fourth variant prints an"
	" overview about all commands and all global options.",
	1,
	option_tab_cmd_HELP,
	option_allowed_cmd_HELP
    },

    {	CMD_ARGTEST,
	false,
	false,
	false,
	"ARGTEST",
	0,
	"wszst ARGTEST ...",
	"This debug command accepts all kinds of parameters and prints one"
	" line for each parameter.",
	0,
	0,
	option_tab_cmd_ARGTEST,
	option_allowed_cmd_ARGTEST
    },

    {	CMD_TEST,
	false,
	false,
	false,
	"TEST",
	0,
	"wszst TEST [options]... [ignored]...",
	"This debugging command accepts all options and parameters and prints"
	" a list of the internal option values. The command is designed to"
	" test the option parameters. The non option parameters are completly"
	" ignored.",
	0,
	1,
	option_tab_cmd_TEST,
	option_allowed_cmd_TEST
    },

    {	CMD_COLORS,
	false,
	false,
	false,
	"COLORS",
	0,
	"wszst COLORS",
	"Ignore all parameters and print clored text for testing.",
	0,
	3,
	option_tab_cmd_COLORS,
	option_allowed_cmd_COLORS
    },

    {	CMD_ERROR,
	false,
	false,
	false,
	"ERROR",
	"ERR",
	"wszst ERROR [error_code]",
	"Translate an exit code to a message name. If no exit code is entered,"
	" print a table with all error messages.",
	0,
	3,
	option_tab_cmd_ERROR,
	option_allowed_cmd_ERROR
    },

    {	CMD_FILETYPE,
	false,
	false,
	false,
	"FILETYPE",
	"FT",
	"wszst FILETYPE file...",
	"Scan the header of the entered files and print file type and path for"
	" each file as list.",
	0,
	3,
	option_tab_cmd_FILETYPE,
	option_allowed_cmd_FILETYPE
    },

    {	CMD_FILEATTRIB,
	false,
	false,
	false,
	"FILEATTRIB",
	"FA",
	"wszst FILEATTRIB [keyword]...",
	"Print a table with attributes for all known file types. If at least"
	" one keyword is entered, only matching file types are printed. A"
	" keyword is either a file type (like 'BRRES' or 'BMG') or one of the"
	" printed keywords (like 'ARCHIVE' or 'EXTRACT').",
	0,
	1,
	option_tab_cmd_FILEATTRIB,
	option_allowed_cmd_FILEATTRIB
    },

    {	CMD_SYMBOLS,
	false,
	false,
	false,
	"SYMBOLS",
	0,
	"wszst SYMBOLS",
	"Print predefined symbols of text parser to standard output.",
	0,
	1,
	option_tab_cmd_SYMBOLS,
	option_allowed_cmd_SYMBOLS
    },

    {	CMD_FUNCTIONS,
	false,
	false,
	false,
	"FUNCTIONS",
	0,
	"wszst FUNCTIONS [key]...",
	"Print a list with all parser functions. If one key ore more key"
	" entered, then only functions that match at least one key are"
	" printed.",
	0,
	3,
	option_tab_cmd_FUNCTIONS,
	option_allowed_cmd_FUNCTIONS
    },

    {	CMD_CALCULATE,
	false,
	false,
	false,
	"CALCULATE",
	0,
	"wszst CALCULATE expression...",
	"Calculate each expression and print the result to standard output.",
	0,
	1,
	option_tab_cmd_CALCULATE,
	option_allowed_cmd_CALCULATE
    },

    {	CMD_MATRIX,
	false,
	false,
	false,
	"MATRIX",
	0,
	"wszst MATRIX [patch-option]... [vector]...",
	"Use the transformation options as base and calculate and print the"
	" related vectors and the transformation matrices. Then do a forward"
	" and backward transformation for each vector parameter using the"
	" matrices and print the results.",
	"Use the transformation options as base and calculate and print the"
	" related vectors and the transformation matrices. Then do a forward"
	" and backward transformation for each vector parameter using the"
	" matrices and print the results. The transformations are done with 4"
	" different methods to confirm the algorithms. Only the main results"
	" and results, which differ, are printed.\n"
	" Normally, the exit status is OK (null). If at least one old"
	" transformation returns different results for the different"
	" algorithms, then status DIFFER (not null) is returned.",
	20,
	option_tab_cmd_MATRIX,
	option_allowed_cmd_MATRIX
    },

    {	CMD_FLOAT,
	false,
	false,
	false,
	"FLOAT",
	0,
	"wszst FLOAT number...",
	"This commands helps to convert hex value into floating point numbers."
	" For each non empty parameter, a line with 4 bytes hex and a float, 8"
	" bytes hex and a double float, and the parameter itself is printed."
	" If a parameter begins with 'x' or '0x', it is a hex string."
	" Otherwise it is a floating point number. All conversions are done"
	" using big endian.",
	0,
	0,
	option_tab_cmd_FLOAT,
	option_allowed_cmd_FLOAT
    },

    {	CMD_AUTOADD,
	false,
	false,
	false,
	"AUTOADD",
	0,
	"wszst AUTOADD [source]...",
	"Add files to the main auto-add archive for future use of option"
	" --auto-add. If 'source' is a directory, all standard track and arena"
	" file names are searched in it. Without any source files an archive"
	" status is printed.\n"
	"  Try 'wszst AUTOADD ./path_to/Race/Course/' to add all supported"
	" files.",
	0,
	8,
	option_tab_cmd_AUTOADD,
	option_allowed_cmd_AUTOADD
    },

    {	CMD_TRACKS,
	false,
	false,
	false,
	"TRACKS",
	0,
	"wszst TRACKS [selection_mask]",
	"Print a list of all known track SZS files of Mario Kart internal"
	" directory './Race/Course'. These files are 32 standard track files"
	" and 10 arena files. The first column shows an unique ID of exact 3"
	" upper case characters or digits. For '_d' files, a 'd' is appended.",
	0,
	3,
	option_tab_cmd_TRACKS,
	option_allowed_cmd_TRACKS
    },

    {	CMD_EXPORT,
	true,
	false,
	false,
	"_EXPORT",
	0,
	"wszst _EXPORT key...",
	"This hidden command exports some definitions to standard output. Use"
	" keyword HELP to get a list of possible keywords.",
	0,
	0,
	option_tab_cmd_EXPORT,
	option_allowed_cmd_EXPORT
    },

    {	CMD_CODE,
	true,
	false,
	false,
	"_CODE",
	0,
	"wszst _CODE [files]",
	"All bytes of all input files are xored with 0xDC and copied to"
	" stdout. If no source file is given, stdin is read.",
	0,
	0,
	option_tab_cmd_CODE,
	option_allowed_cmd_CODE
    },

    {	CMD_RECODE,
	true,
	false,
	false,
	"_RECODE",
	0,
	"wszst _RECODE mode [files]",
	"All bytes of all input files are interpreted as 1 file and re-coded."
	" MODE defines the re-code mode. If no source file is given, stdin is"
	" read.",
	0,
	0,
	option_tab_cmd_RECODE,
	option_allowed_cmd_RECODE
    },

    {	CMD_SUBFILE,
	true,
	false,
	false,
	"_SUBFILE",
	0,
	"wszst _SUBFILE [files]",
	"Test sub-file system.",
	0,
	8,
	option_tab_cmd_SUBFILE,
	option_allowed_cmd_SUBFILE
    },

    {	CMD_LIST,
	false,
	false,
	true,
	"LIST",
	"LS",
	"wszst LIST [source]...",
	"List all sub files of SZS, U8, PACK, BRRES, BREFF, BREFT and RARC"
	" archives. If listing a directory, then a virtual SZS file is created"
	" (like CREATE does it) and listed.",
	0,
	44,
	option_tab_cmd_LIST,
	option_allowed_cmd_LIST
    },

    {	CMD_LIST_L,
	false,
	false,
	false,
	"LIST-L",
	"LL",
	"wszst LIST-L [source]...",
	"List all sub files with size. 'LIST-L' and 'LL' are short cuts for"
	" 'LIST --long'.",
	0,
	44,
	option_tab_cmd_LIST_L,
	option_allowed_cmd_LIST_L
    },

    {	CMD_LIST_LL,
	false,
	false,
	false,
	"LIST-LL",
	"LLL",
	"wszst LIST-LL [source]...",
	"List all sub files with offset and size. 'LIST-LL' and 'LLL' are"
	" short cuts for 'LIST --long --long'.",
	0,
	44,
	option_tab_cmd_LIST_LL,
	option_allowed_cmd_LIST_LL
    },

    {	CMD_LIST_LLL,
	false,
	false,
	false,
	"LIST-LLL",
	"LLLL",
	"wszst LIST-LLL [source]...",
	"List all sub files with offset and size in debugging mode. 'LIST-LLL'"
	" and 'LLLL' are short cuts for 'LIST --long --long --long'.",
	0,
	44,
	option_tab_cmd_LIST_LLL,
	option_allowed_cmd_LIST_LLL
    },

    {	CMD_LIST_A,
	false,
	false,
	false,
	"LIST-A",
	"LA",
	"wszst LIST-A [source]...",
	"List recursive all sub files with size. 'LIST-A' and 'LA' are short"
	" cuts for 'LIST --long --all --all'.",
	0,
	44,
	option_tab_cmd_LIST_A,
	option_allowed_cmd_LIST_A
    },

    {	CMD_LIST_LA,
	false,
	false,
	false,
	"LIST-LA",
	"LLA",
	"wszst LIST-LA [source]...",
	"List recursive all sub files with offset and size. 'LIST-LA' and"
	" 'LLA' are short cuts for 'LIST --long --long --all --all'.",
	0,
	44,
	option_tab_cmd_LIST_LA,
	option_allowed_cmd_LIST_LA
    },

    {	CMD_ILIST,
	false,
	false,
	true,
	"ILIST",
	"IL",
	"wszst ILIST [source]...",
	"List the images files of all sub files of SZS, U8, PACK, BRRES,"
	" BREFF, BREFT and RARC archives; non image files are ignored. If"
	" listing a directory, then a virtual SZS file is created (like CREATE"
	" does it) and listed.",
	0,
	41,
	option_tab_cmd_ILIST,
	option_allowed_cmd_ILIST
    },

    {	CMD_ILIST_L,
	false,
	false,
	false,
	"ILIST-L",
	"ILL",
	"wit ILIST-L [source]...",
	"List all image files with geometry data. 'ILIST-L' and 'ILL' are"
	" short cuts for 'ILIST --long'.",
	0,
	41,
	option_tab_cmd_ILIST_L,
	option_allowed_cmd_ILIST_L
    },

    {	CMD_ILIST_LL,
	false,
	false,
	false,
	"ILIST-LL",
	"ILLL",
	"wit ILIST-LL [source]...",
	"List all sub files with advanced geometry data. 'ILIST-LL' and 'ILLL'"
	" are short cuts for 'ILIST --long --long'.",
	0,
	41,
	option_tab_cmd_ILIST_LL,
	option_allowed_cmd_ILIST_LL
    },

    {	CMD_ILIST_A,
	false,
	false,
	false,
	"ILIST-A",
	"ILA",
	"wszst ILIST-A [source]...",
	"List recursive all image files. 'ILIST-A' and 'ILA' are short cuts"
	" for 'ILIST --all'.",
	0,
	41,
	option_tab_cmd_ILIST_A,
	option_allowed_cmd_ILIST_A
    },

    {	CMD_ILIST_LA,
	false,
	false,
	false,
	"ILIST-LA",
	"ILLA",
	"wit ILIST-LA [source]...",
	"List recursive all image files with geometry data. 'ILIST-LA' and"
	" 'ILLA' are short cuts for 'ILIST --long --all'.",
	0,
	41,
	option_tab_cmd_ILIST_LA,
	option_allowed_cmd_ILIST_LA
    },

    {	CMD_MEMORY,
	false,
	false,
	true,
	"MEMORY",
	"MEM",
	"wszst MEMORY [source]...",
	"Dump a memory map of each source file. Virtual images (extracted"
	" directories) are also supported.",
	0,
	43,
	option_tab_cmd_MEMORY,
	option_allowed_cmd_MEMORY
    },

    {	CMD_MEMORY_A,
	false,
	false,
	false,
	"MEMORY-A",
	"MEMA",
	"wszst MEMORY-A [source]...",
	"Dump recursive a memory map of each source file. 'MEMORY-A' and"
	" 'MEMA' are short cuts for 'MEMORY --all --all'.",
	0,
	43,
	option_tab_cmd_MEMORY_A,
	option_allowed_cmd_MEMORY_A
    },

    {	CMD_DUMP,
	false,
	false,
	false,
	"DUMP",
	0,
	"wszst DUMP [source]...",
	"Dump the internal structure of a BRRES files, compressed or not."
	" Other archives are ignored. The main goal is to verify string"
	" relocation. Virtual images (extracted directories) are also"
	" supported.",
	0,
	37,
	option_tab_cmd_DUMP,
	option_allowed_cmd_DUMP
    },

    {	CMD_SHA1,
	false,
	false,
	true,
	"SHA1",
	0,
	"wszst SHA1 [source]...",
	"Print a SHA1 checksum for each source. The checksum is calculated"
	" using the uncompressed data.",
	0,
	42,
	option_tab_cmd_SHA1,
	option_allowed_cmd_SHA1
    },

    {	CMD_DIFF,
	false,
	false,
	false,
	"DIFF",
	"CMP",
	"wszst DIFF source1 source2\n"
	"wszst DIFF source... --dest dest",
	"Compare two or more sources (each SZS, U8, PACK, BRRES, BREFF, BREFT,"
	" RARC or directory) on file level and report mismatches for each sub"
	" file. If option --dest is set, than each source file is compared"
	" with a file in the destination.",
	0,
	6,
	option_tab_cmd_DIFF,
	option_allowed_cmd_DIFF
    },

    {	CMD_CHECK,
	false,
	false,
	true,
	"CHECK",
	0,
	"wszst CHECK [source]...",
	"Make a validity check for track files: Try to read KCL and KMP (and"
	" check both) and find unknown, modified, needed and unneeded files."
	" Also analyse cannons and make slot proposals. This command uses an"
	" internal object and file database. The source can be a SZS, U8, WU8"
	" or WBZ file, or an U8 like directory.",
	0,
	73,
	option_tab_cmd_CHECK,
	option_allowed_cmd_CHECK
    },

    {	CMD_SLOTS,
	false,
	false,
	false,
	"SLOTS",
	0,
	"wszst SLOTS [source]...",
	"Try to find out the slots, that will run a track. Each source can be"
	" a SZS, U8, WU8 or WBZ file, or an U8 like directory. For each source"
	" one status line is printed. The status line contains either a"
	" positive or a negative slot list, whatever is shorter.",
	0,
	69,
	option_tab_cmd_SLOTS,
	option_allowed_cmd_SLOTS
    },

    {	CMD_STGI,
	false,
	false,
	false,
	"STGI",
	0,
	"wszst STGI [source]...",
	"Find the first KMP/STGI of each file and print an analysis of it as"
	" single line statistic. Additional the number of lap counter check"
	" points ('LC') is printed. Track and KMP (binary and text) files are"
	" accepted as input.",
	0,
	4,
	option_tab_cmd_STGI,
	option_allowed_cmd_STGI
    },

    {	CMD_NORMALIZE,
	false,
	false,
	false,
	"NORMALIZE",
	"NORM",
	"wszst NORMALIZE [source]...",
	"Normalize an U8 archive, compressed or not: The files are sorted in"
	" `Nintendo like' order and unused data holes are removed. If"
	" directory '.' is available it becomes the root directory for all"
	" others. Compressed sources are compressed again with maximum"
	" compression (level 9). The destination is only written if any data"
	" changed.\n"
	"  'wszst NORMALIZE' is the same as 'wszst PATCH --norm'.",
	0,
	60,
	option_tab_cmd_NORMALIZE,
	option_allowed_cmd_NORMALIZE
    },

    {	CMD_PATCH,
	false,
	false,
	false,
	"PATCH",
	0,
	"wszst PATCH [source]...",
	"Patch an U8 archive, compressed or not: Load the archive, apply all"
	" patching and transforming options and store the file again."
	" Compressed sources are compressed again. The destination is only"
	" written if any data changed.",
	0,
	61,
	option_tab_cmd_PATCH,
	option_allowed_cmd_PATCH
    },

    {	CMD_COPY,
	false,
	false,
	false,
	"COPY",
	"CP",
	"wszst COPY source dest\n"
	"wszst COPY source... [-d|-D] dest",
	"COPY is an alternative command for copying and pathing files. It uses"
	" the same internal procedure as command PATCH, but has another"
	" command line syntax.\n"
	" The command copies all source files to the destination. If more than"
	" 1 source is defined, the destination must be either a directory or a"
	" destination filename with escapes. Patching is also possible and"
	" option --overwrite is set implicitly.",
	0,
	61,
	option_tab_cmd_COPY,
	option_allowed_cmd_COPY
    },

    {	CMD_MINIMAP,
	false,
	false,
	false,
	"MINIMAP",
	0,
	"wszst MINIMAP [source]...",
	"Print minimap data (more exact: the visual field of the minimap) of a"
	" SZS, U8, BRRES or MDL file. If patching options are used, modify the"
	" data and write back the file using its original file format. Only"
	" the 'translation' vector is modified and new translation and inverse"
	" matrices are calculated.",
	0,
	45,
	option_tab_cmd_MINIMAP,
	option_allowed_cmd_MINIMAP
    },

    {	CMD_COMPRESS,
	false,
	false,
	false,
	"COMPRESS",
	"COM",
	"wszst COMPRESS [source]...",
	"Compress and create a SZS archives. If the source is already"
	" compressed, then decompress and compress it again. The default"
	" destination is '%P/%N.szs'.",
	0,
	62,
	option_tab_cmd_COMPRESS,
	option_allowed_cmd_COMPRESS
    },

    {	CMD_DECOMPRESS,
	false,
	false,
	false,
	"DECOMPRESS",
	"DEC",
	"wszst DECOMPRESS [szs]...",
	"Decompress SZS files. The default destination is '%P/%N.u8'.",
	0,
	54,
	option_tab_cmd_DECOMPRESS,
	option_allowed_cmd_DECOMPRESS
    },

    {	CMD_ENCODE,
	false,
	false,
	false,
	"ENCODE",
	"E",
	"wszst ENCODE [source_dir]...",
	" Create and/or encode sub files if necessary. It works like command"
	" CREATE, but without creating a new first level archive file.",
	0,
	53,
	option_tab_cmd_ENCODE,
	option_allowed_cmd_ENCODE
    },

    {	CMD_CREATE,
	false,
	false,
	false,
	"CREATE",
	"C",
	"wszst CREATE [source_dir]...",
	"Create SZS, U8, PACK, BRRES, BREFF, BREFT or RARC archives by adding"
	" all not hidden files of the directory structure. Create and/or"
	" encode sub files if necessary. The default destination is '%P/%N%T'.",
	0,
	78,
	option_tab_cmd_CREATE,
	option_allowed_cmd_CREATE
    },

    {	CMD_UPDATE,
	false,
	false,
	false,
	"UPDATE",
	"U",
	"wszst UPDATE [source]... [--source=] [--dest=]",
	"Update an existing SZS, U8, PACK, BRRES, BREFF, BREFT and"
	" RARCarchive. This is done in similar way as the EXTRACT command, but"
	" instead of extracting, source files are searched in a prior"
	" extracted archive. Only files with the same size are updated. The"
	" secondary source is used to find the source sub files. The default"
	" secondary source is '%P/%N.d/'.",
	0,
	54,
	option_tab_cmd_UPDATE,
	option_allowed_cmd_UPDATE
    },

    {	CMD_EXTRACT,
	false,
	false,
	false,
	"EXTRACT",
	"X",
	"wszst EXTRACT [source]...",
	"Extract all sub files of SZS, U8, PACK, BRRES, BREFF, BREFT and RARC"
	" archives. The default destination is '%P/%N.d/'.",
	0,
	55,
	option_tab_cmd_EXTRACT,
	option_allowed_cmd_EXTRACT
    },

    {	CMD_XDECODE,
	false,
	false,
	false,
	"XDECODE",
	"XD",
	"wszst XDECODE [source]...",
	"Command XDECODE is a short cut for 'EXTRACT --decode'. It extract all"
	" sub files of SZS, U8, PACK, BRRES, BREFF, BREFT and RARC archives"
	" and decodes all supported files. The default destination is"
	" '%P/%N.d/'.",
	0,
	55,
	option_tab_cmd_XDECODE,
	option_allowed_cmd_XDECODE
    },

    {	CMD_XEXPORT,
	false,
	false,
	false,
	"XEXPORT",
	"XX",
	"wszst XEXPORT [source]...",
	"Command XEXPORT is a short cut for 'EXTRACT --decode --export'. It"
	" extract all sub files of SZS, U8, PACK, BRRES, BREFF, BREFT and RARC"
	" archives and decodes all supported files with enabled export modus."
	" The default destination is '%P/%N.d/'.",
	0,
	55,
	option_tab_cmd_XEXPORT,
	option_allowed_cmd_XEXPORT
    },

    {	CMD_XALL,
	false,
	false,
	false,
	"XALL",
	"XA",
	"wszst XALL [source]...",
	"Command XALL is a short cut for 'EXTRACT --all'. It extract all sub"
	" files of SZS, U8, PACK, BRRES, BREFF, BREFT and RARC archives"
	" recursively and decodes all supported files. The default destination"
	" is '%P/%N.d/'.",
	0,
	55,
	option_tab_cmd_XALL,
	option_allowed_cmd_XALL
    },

    {	CMD_CAT,
	false,
	false,
	false,
	"CAT",
	0,
	"wszst CAT [source/subfile]...",
	"Extract one or more sub files of SZS, U8, PACK, BRRES, BREFF, BREFT"
	" and RARC archives. The output of all source files is concatenated"
	" and written to stdout.",
	0,
	6,
	option_tab_cmd_CAT,
	option_allowed_cmd_CAT
    },

    {	CMD_BMG,
	false,
	false,
	false,
	"BMG",
	0,
	"wszst BMG [source]...",
	"For each archive all BMG sub files are searched and, if found,"
	" decoded and printed as combined BMG text file. The command works"
	" exactly like 'wbmgt MIX'.",
	0,
	16,
	option_tab_cmd_BMG,
	option_allowed_cmd_BMG
    },

    {	CMD_KCL,
	false,
	false,
	false,
	"KCL",
	0,
	"wszst KCL [source]...",
	"For each archive the KCL sub file course.kcl is searched and, if"
	" found, decoded and printed (copied to stdout).\n"
	"  Automated dropping of bad KCL triangles is enabled if no other drop"
	" option is specified by option --kcl.",
	0,
	37,
	option_tab_cmd_KCL,
	option_allowed_cmd_KCL
    },

    {	CMD_KMP,
	false,
	false,
	false,
	"KMP",
	0,
	"wszst KMP [source]...",
	"For each archive the KMP sub file course.kmp is searched and, if"
	" found, decoded and printed (copied to stdout).",
	0,
	38,
	option_tab_cmd_KMP,
	option_allowed_cmd_KMP
    },

    {	CMD_INFO,
	false,
	false,
	false,
	"INFO",
	0,
	"wszst INFO [source]...",
	"For each archive a file named info.txt and, if not found, credits.txt"
	" is searched, ignoring case. The first found file of each archive is"
	" printed (copied to stdout).",
	0,
	2,
	option_tab_cmd_INFO,
	option_allowed_cmd_INFO
    },

    {	CMD_VEHICLE,
	true,
	false,
	true,
	"VEHICLE",
	0,
	"wszst VEHICLE job ...",
	"Hidden vehicle settings command.",
	0,
	7,
	option_tab_cmd_VEHICLE,
	option_allowed_cmd_VEHICLE
    },

    {0,0,0,0,0,0,0,0,0,00,}
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                     InfoUI                      ///////////////
///////////////////////////////////////////////////////////////////////////////

const InfoUI_t InfoUI_wszst =
{
	"wszst",
	CMD__N,
	CommandTab,
	CommandInfo,
	OPT__N_SPECIFIC,
	OPT__N_TOTAL,
	OptionInfo,
	OptionUsed,
	OptionIndex,
	OptionShort,
	OptionLong
};

//
///////////////////////////////////////////////////////////////////////////////
///////////////                       END                       ///////////////
///////////////////////////////////////////////////////////////////////////////

